/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const MtgDlg = require('./MtgDlg')
const kernel = require('../kernel/kernel')
const $ = require('jquery')
module.exports = AboutDlg

function AboutDlg (app) {
  MtgDlg.call(this, app, 'aboutdlg')
  var self = this
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var label = kernel.ce('label', {
    class: 'labelSmall',
    disabled: true,
    style: 'color:blue;'
  })
  tr.appendChild(label)
  $(label).html(
    '<strong>MathGraph32 JavaScript version 6.7.0. Software for creating and animating dynamic mathematics figures.</br>' +
    'Copyright (C) 2017 Yves Biton (France) http://mathgraph32.org</br></strong></br>')
  tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var ta = kernel.ce('textarea', {
    style: 'width:620px;height:400px;overflow:auto;',
    disabled: true
  })
  tr.appendChild(ta)
  $(ta).val(
    'Author and developpement : Yves Biton (France).\n' +
    'Translations of documentation and text files :\n' +
    '  English : Yves Biton\n' +
    '  Spanish : Luis Belcredi (Uruguay)\n' +
    'Icons :\n' +
    '  Sébastien Cogez\n' +
    '  with the help of Gartoon Gnome Icon Theme Created by Zeus (zeussama@yahoo.com)\n' +
    '    Icon website http://zeus.qballcow.nl \nCo-designer: La Mula Francis\n' +
    '    People who donate icons :\n' +
    "    La Mula Francis : Lot's of stock icons {MULAFRANCIS@terra.com}\n" +
    '    Tiago Bortoletto : Open Office Impress\n' +
    '    James Birkett : Open Office Math\n' +
    '    Ian Megibben : Houdini and Maya\n\n' +
    'This program is free software: you can redistribute it and/or modify\n' +
    'it under the terms of the GNU General Public License as published by\n' +
    'the Free Software Foundation, either version 3 of the License, or\n' +
    '(at your option) any later version.\n' +
    'This program is distributed in the hope that it will be useful,\n' +
    'but WITHOUT ANY WARRANTY; without even the implied warranty of\n' +
    'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n' +
    'GNU General Public License for more details.\n' +
    'You should have received a copy of the GNU General Public License\n' +
    'along with this program.  If not, see http://www.gnu.org/licenses.\n' +
    (app.electron ? 'MathGraph32 JavaScript is built using electron : https://github.com/electron/electron/blob/master/LICENSE' : '') + '\n' +
    'MathGraph32 JavaScript uses the following librairies :\n' +
    '  electronLocalshortcut (electron version)\n' +
    '  MathJax version 3 : https://github.com/mathjax/MathJax/blob/master/LICENSE\n' +
    '  jquery version 3.6.0\n' +
    '  jquery-ui version 1.12.1\n' +
    '  jquery-textrange version 1.4.0\n' +
    '  spectrum-colorpicker version 1.8.0 :\n         https://github.com/bgrins/spectrum/blob/master/LICENSE\n' +
    '  mathjs : https://mathjs.org/\n' +
    '  jstree version 3.3.4 : https://www.jstree.com/\n' +
    '  binary-parser :\n         http://jsfromhell.com/classes/binary-parser\n' +
    '  file-saver version 1.3.3 :\n         https://github.com/eligrey/FileSaver.js/blob/master/LICENSE.md\n'
  )
  $(ta).textrange('setcursor', 0)
  // Attention : Pour cette boîte de dialogue ne pas appeler create
  var buttons = [
    {
      text: kernel.getStr('Fermer'),
      id: 'btnOK',
      click: function (ev) {
        self.onClose(ev)
        self.stopEvent(ev)
      }
    }
  ]

  // Cette boîte de dialogue n'a qu'un bouton : On n'appelle pas create
  $('#' + self.id).dialog({
    modal: true,
    title: kernel.getStr('About'),
    buttons: buttons,
    close: function (ev) {
      self.onClose(ev)
    },
    width: 650,
    closeOnEscape: false,
    // On affiche la boîte de dialogue sur le div parent de l'application en haut et à droite
    position: { my: 'center', at: 'center', of: '#divMtgDlg' }
  })
}

AboutDlg.prototype = new MtgDlg()
