/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const AvertDlg = require('./AvertDlg')
const $ = require('./../global/jQuery-ui')

module.exports = ChoixLangDlg

function ChoixLangDlg (app) {
  // Ici appel avec seulement trois patramètres car fonctionnement spécial
  MtgDlg.call(this, app, 'choixLangDlg')
  this.lang = app.language
  this.select = kernel.ce('select', {
    size: 3, // Le nombre de lignes visibles par défaut
    style: 'width:150px'
  })
  this.appendChild(this.select)
  var tab = ['fr', 'en', 'es']
  for (var i = 0; i < tab.length; i++) {
    var option = kernel.ce('Option')
    if (tab[i] === app.language) option.setAttribute('selected', 'selected')
    $(option).html(kernel.getStr(tab[i]))
    this.select.appendChild(option)
  }
  // Création de la boîte de dialogue par jqueryui
  this.create('ChoixLang', 500)
}

ChoixLangDlg.prototype = new MtgDlg()

ChoixLangDlg.prototype.OK = function () {
  var tab = ['fr', 'en', 'es']
  var app = this.app
  var newLang = tab[this.select.selectedIndex]
  if (newLang !== this.lang) {
    // setLang est une fonction de la page index.html de electron
    setLang(newLang) // eslint-disable-line no-undef
    app.language = newLang
    this.destroy()
    new AvertDlg(app, 'Restart')
  }
}
