/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * Created by yvesb on 02/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('./../global/jQuery-ui')

module.exports = ChoixModificationImageDlg

function ChoixModificationImageDlg (app, callBack1, callBack2) {
  // Ici appel avec seulement trois patramètres car fonctionnement spécial
  MtgDlg.call(this, app, 'choixModifDlg')
  // Il peut arriver que l'endroit où on a cliqué soit aussi l'endroit d'un des deux boutons
  // OK ou Cancel et que la boîte se referme tout de suite.
  // Pour éviter cela on regardera le temps entre le début de la création de la boîte
  // et l'appui sur un de ces deux boutons
  this.callBack1 = callBack1
  this.callBack2 = callBack2
  var tab = kernel.ce('table', {
    cellspacing: 10
  })
  this.appendChild(tab)
  var tr = kernel.ce('TR')
  tab.appendChild(tr)
  var label = kernel.ce('label', {
    class: 'labelSmall'
  })
  $(label).html(kernel.getStr('ChoixTrans1') + ' : ')
  tr.appendChild(label)
  tr = kernel.ce('TR')
  tab.appendChild(tr)
  label = kernel.ce('label', {
    for: 'mtgradiofirst'
  })
  $(label).html(kernel.getStr('ChoixTrans2') + ':')
  tr.appendChild(label)
  let td = kernel.ce('TD')
  tr.appendChild(td)
  let inp = kernel.ce('input', {
    id: 'mtgradiofirst',
    type: 'radio',
    name: 'choice'
  })
  inp.setAttribute('checked', 'checked')
  td.appendChild(inp)
  tr = kernel.ce('TR')
  tab.appendChild(tr)
  td = kernel.ce('TD')
  tr.appendChild(td)
  label = kernel.ce('label', {
    for: 'mtgradiolast'
  })
  $(label).html(kernel.getStr('ChoixTrans3') + ':')
  td.appendChild(label)
  td = kernel.ce('TD')
  tr.appendChild(td)
  inp = kernel.ce('input', {
    id: 'mtgradiolast',
    type: 'radio',
    name: 'choice'
  })
  td.appendChild(inp)
  // Création de la boîte de dialogue par jqueryui
  this.create('ChoixAPrec', 450)
}

ChoixModificationImageDlg.prototype = new MtgDlg()

ChoixModificationImageDlg.prototype.OK = function () {
  // var time = +new Date();
  // if (time - this.timeStart < MtgDlg.delay) return; // Moins d'une seconde dans doute mauvais endroit de clic sur un bouton
  var premierChoisi = $('#mtgradiofirst').prop('checked')
  this.destroy()
  if (premierChoisi) this.callBack1(); else this.callBack2()
}
