/*
 * Created by yvesb on 15/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('./../global/jQuery-ui')

module.exports = ConfirmDlg

function ConfirmDlg (app, message, callBackOK, callBackNo) {
  MtgDlg.call(this, app, 'confirmDlg')
  var label = kernel.ce('label')
  $(label).html(kernel.getStr(message))
  this.appendChild(label)
  var self = this
  // Création de la boîte de dialogue par jqueryui
  var buttons = {}
  buttons[kernel.getStr('Oui')] = function (ev) {
    if (callBackOK) callBackOK()
    self.stopEvent(ev)
    self.destroy()
  }
  buttons[kernel.getStr('Non')] = function (ev) {
    if (callBackNo) callBackNo()
    self.stopEvent(ev)
    self.destroy()
  }

  // Attention : Pour cette boîte de dialogue ne pas appeler create
  $('#' + self.id).dialog({
    modal: true,
    title: kernel.getStr(''),
    buttons: buttons,
    close: function (ev) {
      if (callBackNo) callBackNo()
      self.stopEvent(ev)
      self.destroy()
    },
    width: 500,
    closeOnEscape: false,
    // On centre la boîte de dialogue sur le div parent de l'application
    position: { my: 'center', at: 'center', of: '#divMtgDlg' }
  })
}

ConfirmDlg.prototype = new MtgDlg()
