const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
//
const $ = require('./../global/jQuery-ui')
const EditeurNomCalcul = require('./EditeurNomCalcul')
const MtgInput = require('./MtgInput')
const NatCal = require('../types/NatCal')
const CImplementationProto = require('../objets/CImplementationProto')

module.exports = DeterminantDlg

/**
 * Dialogue pour créer le déterminant d'une matrice
 * @param app
 * @constructor
 */
function DeterminantDlg (app) {
  MtgDlg.call(this, app, 'DetDlg')
  const self = this
  const list = app.listePr
  this.listeObj = list.listeParNatCal(app, NatCal.NTteMatrice, -1)
  const tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  let tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  const tabHaut = kernel.ce('table')
  tr.appendChild(tabHaut)
  tr = kernel.ce('tr')
  tabHaut.appendChild(tr)
  const div = kernel.ce('div')
  tr.appendChild(div)
  let label = kernel.ce('label')
  $(label).html(kernel.getStr('NomCalcul') + ' : ')
  div.appendChild(label)
  var inputName = new MtgInput({
    id: 'inputName'
  })
  inputName.onkeyup = function (ev) {
    this.demarquePourErreur()
    if (ev.keyCode === 13) {
      $(this).blur() // Nécéssaire sur ipad pour une raison que j'ignore
      self.OK()
    }
  }
  div.appendChild(inputName)
  tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  const tabMil = kernel.ce('table')
  tr.appendChild(tabMil)
  tr = kernel.ce('tr')
  tabMil.appendChild(tr)
  label = kernel.ce('label')
  tr.appendChild(label)
  $(label).html(kernel.getStr('Det') + ' ' + kernel.getStr('de') + ' : ')
  tr = kernel.ce('tr')
  tabMil.appendChild(tr)
  this.select = kernel.ce('SELECT', {
    size: 8, // Le nombre de lignes visibles par défaut
    style: 'width:180px'
  })
  this.select.onchange = function () {
    self.onSelectChange()
  }
  tr.appendChild(this.select)
  // C'est là qu'on ajoute les noms des valeurs numériques disponibles dans la liste déroulante
  for (let i = 0; i < this.listeObj.noms.length; i++) {
    var option = kernel.ce('Option', {
      class: 'mtgOption'
    })
    if (i === 0) option.setAttribute('selected', 'selected')
    $(option).html(this.listeObj.noms[i])
    this.select.appendChild(option)
  }

  const tabBas = kernel.ce('table')
  tr.appendChild(tabBas)
  tr = kernel.ce('tr')
  tabBas.appendChild(tr)
  label = kernel.ce('label')
  $(label).html(kernel.getStr('Info'))
  tr.appendChild(label)
  tr = kernel.ce('tr')
  tabBas.appendChild(tr)
  var inputinf = kernel.ce('textarea', {
    id: 'mtginfo',
    disabled: 'true',
    cols: 40,
    rows: 4
  })
  tr.appendChild(inputinf)
  this.editeurName = new EditeurNomCalcul(app, !this.modification, inputName)
  this.onSelectChange()
  this.create('Det', 450)
}

DeterminantDlg.prototype = new MtgDlg()

DeterminantDlg.prototype.onSelectChange = function () {
  const ind = this.select.selectedIndex
  if (ind === -1) return
  const el = this.listeObj.pointeurs[ind]
  $('#mtginfo').text(el.infoHist())
}

DeterminantDlg.prototype.onOpen = function () {
  MtgDlg.prototype.onOpen.call(this)
  setTimeout(function () { // Ne marche pas sans un setTimeOut
    $('#inputName').focus() // Pour que le focus soit donné à l'éditeur au départ ou quand un  message d'erreur est affiché
  }, 100)
}

DeterminantDlg.prototype.OK = function () {
  const app = this.app
  const list = app.listePr
  // if (app.lastDlgId() !== this.id) return;
  if (this.editeurName.validate()) {
    // Pour créer le calcul on implémente une macro-construction
    const proto = app.docConsAv.getPrototype('det')
    proto.get(0).elementAssocie = this.listeObj.pointeurs[this.select.selectedIndex] // La matrice sélectionnée
    const impProto = new CImplementationProto(list, proto)
    impProto.implemente(app.dimf, proto)
    impProto.nomProto = kernel.getStr('Det')
    // Le dernier objet créé est le déterminant. On le renomme
    list.get(list.longueur() - 1).nomCalcul = $('#inputName').val()
    this.app.gestionnaire.enregistreFigureEnCours('Det')
    this.destroy()
  }
}
