/*
 * Created by yvesb on 16/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const AvertDlg = require('./AvertDlg')
const $ = require('jquery')
module.exports = DisplayCodeDlg

function DisplayCodeDlg (app, code, title) {
  MtgDlg.call(this, app, 'CodeDlg')
  var self = this
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)

  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var textarea = kernel.ce('textarea', {
    id: 'ta',
    cols: 80,
    rows: 20
  })
  tr.appendChild(textarea)
  var sel = $(textarea)
  sel.css('font-size', '13px')
  sel.val(code)
  setTimeout(function () {
    sel.select()
  }, 500)
  // Attention : Pour cette boîte de dialogue ne pas appeler create
  var buttons = {}
  if (document.execCommand) {
    buttons[kernel.getStr('CopyCode')] = function () {
      sel.select()
      new AvertDlg(self.app, kernel.getStr(document.execCommand('copy') ? 'CodeOK' : 'CodeNotOK'))
    }
    buttons[kernel.getStr('Fermer')] = function (ev) {
      self.onClose(ev)
    }
  }
  // Cette boîte de dialogue n'a qu'un bouton : On n'appelle pas create
  $('#' + self.id).dialog({
    modal: true,
    title: kernel.getStr(title),
    buttons: buttons,
    close: function (ev) {
      self.onClose(ev)
    },
    width: 650,
    closeOnEscape: false,
    // On affiche la boîte de dialogue sur le div parent de l'application en haut et à droite
    position: { my: 'right top', at: 'right top', of: '#divMtgDlg' }
  })
}

DisplayCodeDlg.prototype = new MtgDlg()
