/*
 * Created by yvesb on 16/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('jquery')
module.exports = FigParCodeDlg

function FigParCodeDlg (app, callBackOK, callBackCancel) {
  MtgDlg.call(this, app, 'FigParCodeDlg', callBackOK, callBackCancel)
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var label = kernel.ce('label')
  $(label).html(kernel.getStr('FigParCode'))
  tr.appendChild(label)
  tr = kernel.ce('label')
  tabPrincipal.appendChild(tr)
  var textarea = kernel.ce('textarea', {
    id: 'base64',
    cols: 80,
    rows: 20,
    style: 'font-size:13px;'
  })
  tr.appendChild(textarea)
  this.create('Base64', 650)
}

FigParCodeDlg.prototype = new MtgDlg()

FigParCodeDlg.prototype.onOpen = function () {
  MtgDlg.prototype.onOpen.call(this)
  setTimeout(function () { // Ne marche pas sans un setTimeOut
    $('#base64').focus() // Pour que le focus soit donné à l'éditeur au départ ou quand un  message d'erreur est affiché
  }, 100)
}

FigParCodeDlg.prototype.OK = function () {
  this.app.setFigByCode($('#base64').val())
  this.destroy()
  // On met à jour les icônes de la barre horizontale
  this.app.updateToolbar()
  this.callBackOK()
}
