/*
 * Created by yvesb on 20/05/2017.
 */

/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const EditeurValeurReelle = require('./EditeurValeurReelle')
const $ = require('./../global/jQuery-ui')
const PaneBoutonsValFonc = require('./PaneBoutonsValFonc')
const CValeur = require('../objets/CValeur')
const CImplementationProto = require('../objets/CImplementationProto')

const PaneListeReperes = require('./PaneListeReperes')
const MtgInput = require('./MtgInput')
module.exports = GraduationsAxesDlg

function GraduationsAxesDlg (app, callBackOK, callBackCancel) {
  MtgDlg.call(this, app, 'CourbeDlg', callBackOK, callBackCancel)
  var self = this
  var list = app.listePr
  // 4 CValeur pour stocker les valeurs pour l'équation, a, b et c.
  this.valgradx = new CValeur(list, 1)
  this.valgrady = new CValeur(list, 1)
  this.valnbgradx = new CValeur(list, 20)
  this.valnbgrady = new CValeur(list, 20)
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)

  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  // En haut deux boutons radio pour le choix entre garduation simple et graduation trigo
  var div = kernel.ce('div')
  tr.appendChild(div)
  var radio = kernel.ce('input', {
    type: 'radio',
    id: 'radio1',
    name: 'typegrad'
  })
  div.appendChild(radio)
  radio.setAttribute('checked', 'checked')
  radio.onchange = function () {
    $('#trgradx').css('visibility', 'visible')
    $(self.paneBoutonsValFoncgradx).css('visibility', 'visible')
  }
  let label = kernel.ce('label', {
    for: 'radio1'
  })
  div.appendChild(label)
  $(label).html(kernel.getStr('NewRepDlg13'))
  radio = kernel.ce('input', {
    type: 'radio',
    id: 'radio2',
    name: 'typegrad',
    style: 'margin-left:20px'
  })
  div.appendChild(radio)
  radio.onchange = function () {
    $('#trgradx').css('visibility', 'hidden')
    $(self.paneBoutonsValFoncgradx).css('visibility', 'hidden')
  }
  label = kernel.ce('label', {
    for: 'radio2'
  })
  div.appendChild(label)
  $(label).html(kernel.getStr('NewRepDlg14'))

  tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)

  var trPrincipal = kernel.ce('tr')
  tabPrincipal.appendChild(trPrincipal)
  var td = kernel.ce('td')
  trPrincipal.appendChild(td)
  var tabGauche = kernel.ce('table')
  td.appendChild(tabGauche)
  tr = kernel.ce('tr')
  tabGauche.appendChild(tr)
  tr = kernel.ce('tr', {
    id: 'trgradx'
  })
  tabGauche.appendChild(tr)
  td = kernel.ce('td')
  tr.appendChild(td)
  label = kernel.ce('label')
  td.appendChild(label)
  $(label).html(kernel.getStr('Unitex')) // Unité sur l'axe des abscisses
  td = kernel.ce('td')
  tr.appendChild(td)
  this.inputgradx = new MtgInput({
    size: 16
  })
  $(this.inputgradx).val('1')
  td.appendChild(this.inputgradx)
  this.paneBoutonsValFoncgradx = new PaneBoutonsValFonc(this.app, this, this.inputgradx, true, -1)
  tabGauche.appendChild(this.paneBoutonsValFoncgradx)

  tr = kernel.ce('tr')
  tabGauche.appendChild(tr)
  td = kernel.ce('td')
  tr.appendChild(td)
  label = kernel.ce('label')
  td.appendChild(label)
  $(label).html(kernel.getStr('NbGradx')) // Nombre de graduations sur l'axe (xx')
  td = kernel.ce('td')
  tr.appendChild(td)
  this.inputnbgradx = new MtgInput({
    size: 16
  })
  $(this.inputnbgradx).val('20')
  td.appendChild(this.inputnbgradx)
  var paneBoutonsValFonc = new PaneBoutonsValFonc(this.app, this, this.inputnbgradx, true, -1)
  tabGauche.appendChild(paneBoutonsValFonc)

  tr = kernel.ce('tr')
  tabGauche.appendChild(tr)
  td = kernel.ce('td')
  tr.appendChild(td)
  label = kernel.ce('label')
  td.appendChild(label)
  $(label).html(kernel.getStr('Unitey')) // Pas de graduation sur l'axe (yy')
  td = kernel.ce('td')
  tr.appendChild(td)
  this.inputgrady = new MtgInput({
    size: 16
  })
  $(this.inputgrady).val('1')
  td.appendChild(this.inputgrady)
  paneBoutonsValFonc = new PaneBoutonsValFonc(this.app, this, this.inputgrady, true, -1)
  tabGauche.appendChild(paneBoutonsValFonc)

  tr = kernel.ce('tr')
  tabGauche.appendChild(tr)
  td = kernel.ce('td')
  tr.appendChild(td)
  label = kernel.ce('label')
  td.appendChild(label)
  $(label).html(kernel.getStr('NbGrady')) // Nombre de graduations sur l'axe (yy')
  td = kernel.ce('td')
  tr.appendChild(td)
  this.inputnbgrady = new MtgInput({
    size: 16
  })
  $(this.inputnbgrady).val('20')
  td.appendChild(this.inputnbgrady)
  paneBoutonsValFonc = new PaneBoutonsValFonc(this.app, this, this.inputnbgrady, true, -1)
  tabGauche.appendChild(paneBoutonsValFonc)

  td = kernel.ce('td')
  trPrincipal.appendChild(td)
  // A droite un panneau de choix de repère
  var indmax = list.longueur() - 1
  this.paneListeRep = new PaneListeReperes(app, indmax)
  td.appendChild(this.paneListeRep.getTab())

  this.editeurgradx = new EditeurValeurReelle(app, this.inputgradx, indmax, this.valgradx, null)
  this.editeurnbgradx = new EditeurValeurReelle(app, this.inputnbgradx, indmax, this.valnbgradx, null)
  this.editeurgrady = new EditeurValeurReelle(app, this.inputgrady, indmax, this.valgrady, null)
  this.editeurnbgrady = new EditeurValeurReelle(app, this.inputnbgrady, indmax, this.valnbgrady, null)

  this.create('GraduationAxes', 650)
}

GraduationsAxesDlg.prototype = new MtgDlg()

GraduationsAxesDlg.prototype.OK = function () {
  var gradx, nbgradx, grady, nbgrady
  var app = this.app
  var list = app.listePr
  var gradSimple = $('#radio1').prop('checked')
  if ((gradSimple ? this.editeurgradx.validate() : true) && this.editeurnbgradx.validate() &&
    this.editeurgrady.validate() && this.editeurnbgrady.validate()) {
    // Si les valeurs choisies pne sont pas des références à des valeurs existantes
    // on crée de nouveux calculs qu'on ajoute à la figure
    if (gradSimple) {
      gradx = this.valgradx.getCalcForImpProto(app, 'gradx', true)
    }
    nbgradx = this.valnbgradx.getCalcForImpProto(app, 'nbgradx', true)
    grady = this.valgrady.getCalcForImpProto(app, 'grady', true)
    nbgrady = this.valnbgrady.getCalcForImpProto(app, 'nbgrady', true)
    var proto = app.docCons.getPrototype(gradSimple ? 'GraduationAxesRepereAvecPas' : 'GraduationReperePourTrigoAvecPas')
    var i = 0
    proto.get(i++).elementAssocie = this.paneListeRep.getSelectedRep() // Pointe sur le repère
    if (gradSimple) proto.get(i++).elementAssocie = gradx
    proto.get(i++).elementAssocie = nbgradx
    proto.get(i++).elementAssocie = grady
    proto.get(i).elementAssocie = nbgrady
    var impProto = new CImplementationProto(list, proto)
    impProto.implemente(app.dimf, proto)
    impProto.nomProto = kernel.getStr('GraduationAxes')
    var indImpProto = list.indexOf(impProto)
    list.positionne(false, app.dimf)
    list.setReady4MathJax() // Nécessaire en cas de graduation trigonométrique qui utilise des CLatex
    list.afficheTout(indImpProto, app.svgFigure, true, app.doc.couleurFond, app.doc.opacity)
    app.outilGraduationAxes.saveFig()
    this.callBackOK()
    this.destroy()
  }
}
