/*
 * Created by yvesb on 15/04/2017.
 */
/*
 * Created by yvesb on 01/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const NatCal = require('../types/NatCal')
const PaneListeReperes = require('./PaneListeReperes')
const $ = require('./../global/jQuery-ui')
require('jquery-textrange')
module.exports = GrapheSuiteRecDlg

function GrapheSuiteRecDlg (app, grapheSuite, bReel, modification, callBackOK, callBackCancel) {
  MtgDlg.call(this, app, 'GrapheSuiteDlg', callBackOK, callBackCancel)
  this.grapheSuite = grapheSuite
  this.bReel = bReel
  this.modification = modification
  var self = this
  var list = app.listePr
  var indmax = modification ? list.indexOf(grapheSuite) - 1 : list.longueur() - 1
  this.inf = list.listeParNatCal(app, bReel ? NatCal.NSuiteRecurrenteReelle : NatCal.NSuiteRecurrenteComplexe, indmax)
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var tabHaut = kernel.ce('table')
  tr.appendChild(tabHaut)
  tr = kernel.ce('tr')
  $(tr).css('vertical-align', 'top')
  tabHaut.appendChild(tr)
  var td = kernel.ce('td')
  tr.appendChild(td)
  var caption = kernel.ce('caption', {
    class: 'mtgcaption',
    style: 'width:180px'
  })
  $(caption).html(kernel.getStr('graphesrDlg3'))
  td.appendChild(caption)
  this.select = kernel.ce('select', {
    size: 6, // Le nombre de lignes visibles par défaut
    style: 'width:180px'
  })
  this.select.onchange = function () {
    self.onSelectChange()
  }
  td.appendChild(this.select)
  // C'est là qu'on ajoute les noms des valeurs numériques disponibles dans la liste déroulante
  for (var i = 0; i < this.inf.noms.length; i++) {
    var option = kernel.ce('Option', {
      class: 'mtgOption'
    })
    if (modification ? (this.inf.pointeurs[i] === grapheSuite.suiteAssociee) : i === 0) option.setAttribute('selected', 'selected')
    $(option).html(this.inf.noms[i])
    this.select.appendChild(option)
  }
  td = kernel.ce('td')
  tr.appendChild(td)
  this.paneListeReperes = new PaneListeReperes(app, indmax)
  td.appendChild(this.paneListeReperes.getTab())
  tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var paneBas = kernel.ce('table')
  tr.appendChild(paneBas)
  var div = kernel.ce('div')
  tr.appendChild(div)
  var label = kernel.ce('label', {
    for: 'cb'
  })
  $(label).html(kernel.getStr(bReel ? 'graphesrDlg1' : 'graphesrDlg2'))
  div.appendChild(label)
  var cb = kernel.ce('input', {
    type: 'checkbox',
    id: 'cb'
  })
  div.appendChild(cb)
  // En plus de la version Java, un textarea d'info sur la suite sélectionnée
  tr = kernel.ce('tr')
  paneBas.appendChild(tr)
  label = kernel.ce('label')
  $(label).html(kernel.getStr('InfoSuit'))
  tr.appendChild(label)
  tr = kernel.ce('tr')
  paneBas.appendChild(tr)
  var inputinf = kernel.ce('textarea', {
    id: 'info',
    disabled: 'true',
    cols: 50,
    rows: 4
  })
  tr.appendChild(inputinf)

  if (modification) {
    if (bReel) {
      if (grapheSuite.traitsDeRappelSurAbscisses) $(cb).attr('checked', 'checked')
    } else {
      if (grapheSuite.pointsRelies) $(cb).attr('checked', 'checked')
    }
  } else $(cb).attr('checked', 'checked')
  if (modification) this.paneListeReperes.selectRep(grapheSuite.repereAssocie)
  this.onSelectChange()
  this.create(bReel ? 'GrapheSuiteRec' : 'GrapheSuiteRecComp', 500)
}

GrapheSuiteRecDlg.prototype = new MtgDlg()

GrapheSuiteRecDlg.prototype.onSelectChange = function () {
  $('#info').val(this.inf.pointeurs[this.select.selectedIndex].infoHist())
}

GrapheSuiteRecDlg.prototype.OK = function () {
  this.grapheSuite.suiteAssociee = this.inf.pointeurs[this.select.selectedIndex]
  this.grapheSuite.repereAssocie = this.paneListeReperes.getSelectedRep()
  var b = $('#cb').prop('checked')
  if (this.bReel) this.grapheSuite.traitsDeRappelSurAbscisses = b
  else this.grapheSuite.pointsRelies = b
  if (!this.modification) this.grapheSuite.updateObjetsInternes()
  if (this.modification) this.app.gestionnaire.enregistreFigureEnCours('ModifObj')
  this.destroy()
  if (this.callBackOK !== null) this.callBackOK()
}
