/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MacroDlg = require('./MacroDlg')
const $ = require('jquery')

module.exports = MacJouantSonDlg

/**
 * Dialogue de création ou modification d'une macro jouant un fichier sonore
 * @constructor
 * @param app La mtgApp propriétaire
 * @param mac La macro qui doit être modifiée
 * @param {boolean} modification  true si le dialogue est ouvert pour modifier une macro déjà existante
 */
function MacJouantSonDlg (app, mac, modification, callBackOK, callBackCancel) {
  MacroDlg.call(this, app, mac, modification, callBackOK, callBackCancel)
  var tabPrincipal = kernel.ce('table')
  this.appendChild(tabPrincipal)
  // Ajout de l'éditeur d'intitulé //////////////////////////////
  this.addEditInt(tabPrincipal)
  /// ///////////////////////////////////////////////////////////////
  // Ajout du pane d'information sur la macro //////////////////////
  this.addPaneInfo(tabPrincipal)
  /// ///////////////////////////////////////////////////////////////
  // On ajoute bouton de navigation pour le choix du fichier   /////
  /// ///////////////////////////////////////////////////////////////
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var div = kernel.ce('div')
  tr.appendChild(div)
  var label = kernel.ce('label')
  $(label).html(kernel.getStr('Path') + ' ')
  div.appendChild(label)
  var input = kernel.ce('input', {
    id: 'mtginput',
    type: 'text'
  })
  div.appendChild(input)
  /*
  label = kernel.ce("label", {
    for : "file"
  });
  */
  if (modification) $(input).val(mac.wavePath)
  /// ///////////////////////////////////////////////////////////////
  this.addPaneBas(tabPrincipal)
  this.create('MacJouantSon', 500)
}

MacJouantSonDlg.prototype = new MacroDlg()

MacJouantSonDlg.prototype.OK = function () {
  // if (this.app.lastDlgId() !== this.id) return;
  var mac = this.mac
  var ch = $('#inputint').val()
  if (ch !== '') {
    mac.intitule = ch
    mac.wavePath = $('#mtginput').val()
    if (this.modification) this.app.gestionnaire.enregistreFigureEnCours('ModifObj')
    this.destroy()
    if (this.callBackOK !== null) this.callBackOK()
  } else this.avertIncorrect()
}
