/*
 * Created by yvesb on 01/02/2017.
 */
/*
 * Created by yvesb on 02/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const MtgDlg = require('./MtgDlg')
const kernel = require('../kernel/kernel')
const NewRepDlg = require('./NewRepDlg')
const NewRepMilliDlg = require('./NewRepMilliDlg')
const FigParCodeDlg = require('./FigParCodeDlg')
const NewFigBaseDlg = require('./NewFigBaseDlg')
const figures = require('../kernel/figures')
const $ = require('./../global/jQuery-ui')

module.exports = NewFigDlg

function NewFigDlg (app, callBackOK, callBackCancel) {
  var i; var choix; var tabPrincipal; var tr; var td; var label; var inp; var tab2
  var self = this
  MtgDlg.call(this, app, 'newFigDlg', callBackOK, callBackCancel)
  tabPrincipal = kernel.ce('table', {
    cellspacing: 5
  })
  // Choix du type de figure
  this.appendChild(tabPrincipal)
  for (i = 1; i < 12; i++) {
    tr = kernel.ce('tr')
    tabPrincipal.appendChild(tr)
    td = kernel.ce('td')
    tr.appendChild(td)
    label = kernel.ce('label', {
      for: 'mtgchoix' + i
    })
    $(label).html(kernel.getStr('newFig' + i))
    td.appendChild(label)
    td = kernel.ce('TD')
    tr.appendChild(td)
    inp = kernel.ce('input', {
      id: 'mtgchoix' + i,
      type: 'radio',
      name: 'mtchoix'
    })
    td.appendChild(inp)
    inp.onclick = function () {
      self.onclick()
    }
    if (i === 1) inp.setAttribute('checked', 'checked')
    //
    // Choix de l'unité d'angle de la figure
  }
  tabPrincipal.appendChild(kernel.ce('tr'))
  tr = kernel.ce('tr', {
    align: 'center'
  })
  tabPrincipal.appendChild(tr)
  tab2 = kernel.ce('table', {
    cellspacing: 5,
    id: 'tab2'
  })
  tr.appendChild(tab2)
  tr = kernel.ce('tr')
  tab2.appendChild(tr)
  label = kernel.ce('label', {
    style: 'color:blue'
  })

  $(label).html(kernel.getStr('UniteAngFig'))
  tr.appendChild(label)
  choix = ['Degre', 'Radian']
  for (i = 0; i < 2; i++) {
    tr = kernel.ce('TR')
    tab2.appendChild(tr)
    td = kernel.ce('TD')
    tr.appendChild(td)
    label = kernel.ce('label', {
      for: 'mtgua' + i
    })
    $(label).html(kernel.getStr(choix[i]))
    td.appendChild(label)
    td = kernel.ce('TD')
    tr.appendChild(td)
    inp = kernel.ce('input', {
      id: 'mtgua' + i,
      type: 'radio',
      name: 'mtgua'
    })
    td.appendChild(inp)
    if (i === 1 - app.listePr.uniteAngle) inp.setAttribute('checked', 'checked')
  }
  // Création de la boîte de dialogue par jqueryui
  this.create('NewFig', 459)
}

NewFigDlg.prototype = new MtgDlg()

NewFigDlg.prototype.onclick = function () {
  for (var ind = 1; ind < 10; ind++) {
    if ($('#mtgchoix' + ind).prop('checked')) break
  }
  $('#tab2').css('display', ((ind <= 7) && (ind !== 5)) ? 'inline' : 'none')
}

NewFigDlg.prototype.OK = function () {
  var code; var app = this.app
  var uniteAngle = $('#' + 'mtgua0').prop('checked') ? kernel.uniteAngle.degre : kernel.uniteAngle.radian
  var list = app.listePr

  for (var ind = 1; ind < 11; ind++) {
    if ($('#mtgchoix' + ind).prop('checked')) break
  }
  switch (ind) {
    case 1 :
      new NewRepDlg(this.app, uniteAngle, this.callBackOK)
      break
    case 2 :
      new NewRepMilliDlg(this.app, uniteAngle, this.callBackOK)
      break
    case 3 :
      list.deleteComponents()
      list.retireTout()
      app.retireTout()
      app.resetDoc()
      app.prepareTracesEtImageFond()
      app.initAvecLongueurUnite(uniteAngle)
      app.updateToolsToolBar()
      app.creeCommentaireDesignation()
      app.calculateAndDisplay(false)
      if (app.cadre !== null) app.createCadre(app.widthCadre, app.heightCadre)
      app.reInitConst() // Pour réinitialiser une éventuelle construction en cours
      if (app.electron) {
        app.gestionnaire.initialise()
        resetDocument() // eslint-disable-line no-undef
        // resetDocument est défini dans index.html
      } else app.gestionnaire.enregistreFigureEnCours('NewFig')
      // On met à jour les icônes de la barre horizontale
      app.updateToolbar()
      break
    case 4 :
      list.deleteComponents()
      list.retireTout()
      app.retireTout()
      app.resetDoc()
      app.prepareTracesEtImageFond()
      app.initSansLongueurUnite(uniteAngle)
      app.updateToolsToolBar()
      app.creeCommentaireDesignation()
      app.calculateAndDisplay(false)
      if (app.cadre !== null) app.createCadre(app.widthCadre, app.heightCadre)
      app.reInitConst() // Pour réinitialiser une éventuelle construction en cours
      if (app.electron) {
        app.gestionnaire.initialise()
        resetDocument() // eslint-disable-line no-undef
      } else app.gestionnaire.enregistreFigureEnCours('NewFig')
      // On met à jour les icônes de la barre horizontale
      app.updateToolbar()
      break
    case 5 :
      var tab = []
      for (var i = 0; i < 14; i++) tab.push('fig' + i)
      new NewFigBaseDlg(app, tab, false, this.callBackOK)
      break
    case 6 :
      if (uniteAngle === kernel.uniteAngle.degre) {
        app.setFigByCode(figures.figRepModif, false)
        list.uniteAngle = kernel.uniteAngle.degre
        list.giveFormula2('plat', '180')
        list.giveFormula2('angvar', '60')
        code = app.doc.getBase64Code()
        app.setFigByCode(code)
      } else app.setFigByCode(figures.figRepModif)
      // On met à jour les icônes de la barre horizontale
      app.updateToolbar()
      this.callBackOK()
      break
    case 7 :
      if (uniteAngle === kernel.uniteAngle.degre) {
        app.setFigByCode(figures.figRepModifVect, false)
        list.uniteAngle = kernel.uniteAngle.degre
        list.giveFormula2('plat', '180')
        list.giveFormula2('angvar', '60')
        code = app.doc.getBase64Code()
        app.setFigByCode(code)
      } else app.setFigByCode(figures.figRepModifVect)
      // On met à jour les icônes de la barre horizontale
      app.updateToolbar()
      this.callBackOK()
      break
    case 8 :
      new NewFigBaseDlg(app, ['cour', 'courParam', 'courPol', 'graSuiteunfn', 'graSuitRecPrPt', 'graSuitRecPrTer'],
        true, this.callBackOK)
      break
    case 9:
      new NewFigBaseDlg(app, ['loiBin', 'loiBinIntConf', 'loiBinApp', 'loiExp', 'loiNorm', 'loiNormeualpha', 'loiNormInv'],
        true, this.callBackOK)
      break
    case 10 :
      new NewFigBaseDlg(app, ['reporthog', 'reporthon', 'cube', 'boite', 'cyl', 'coneSimp', 'coneDb', 'tetra', 'tetrareg',
        'pyrcarre', 'pyrregbasecar', 'pyrrect', 'prismtriang', 'prismtrap', 'surf'], true, this.callBackOK)
      break
    case 11 :
      // new FigParCodeDlg(app, this.callBackOK, this.callBackOK);
      new FigParCodeDlg(app, this.callBackOK, this.callBackOK)
  }
  // this.callBackOK();
  this.destroy()
}
