/*
 * Created by yvesb on 03/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const PaneAnimation = require('./PaneAnimation')
const $ = require('./../global/jQuery-ui')
module.exports = OptionsAnimDlg

function OptionsAnimDlg (app, callBackOK) {
  MtgDlg.call(this, app, 'AnimDlg', callBackOK)
  var tabPrincipal = kernel.ce('table')
  $(tabPrincipal).css('margin', 'auto')
  this.appendChild(tabPrincipal)
  this.paneAnimation = new PaneAnimation(app, app.pref_Anim, true, true, false)
  tabPrincipal.appendChild(this.paneAnimation.container) // On rajoute le panneau
  // Création de la boîte de dialogue par jqueryui
  this.create('OptionsAnim', 450)
}

OptionsAnimDlg.prototype = new MtgDlg()

OptionsAnimDlg.prototype.onOpen = function () {
  MtgDlg.prototype.onOpen.call(this)
  setTimeout(function () { // Ne marche pas sans un setTimeOut
    $('#mtginput').focus() // Pour que le focus soit donné à l'éditeur au départ ou quand un  message d'erreur est affiché
  }, 100)
}

OptionsAnimDlg.prototype.OK = function () {
  if (this.paneAnimation.getinfoAnim()) {
    var app = this.app
    var mac = app.macroAnimation
    var pref = app.pref_Anim
    mac.nombrePointsPourAnimation = pref.nbPts
    mac.frequenceAnimationMacro = pref.freq
    mac.animationCyclique = pref.animCycl
    mac.inverserSens = pref.invSens
    this.destroy()
    if (this.callBackOK !== null) this.callBackOK()
  }
}
