/*
 * Created by yvesb on 06/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const NatCal = require('../types/NatCal')
const $ = require('./../global/jQuery-ui')
require('jquery-textrange')

module.exports = PaneChoixVar

/**
 * Boîte de dialogue proposant une liste formé de toutes les variables existantes
 * @param {boolean} bHor true si la liste des varaibles et le pane d'info sont sur une même ligne et false sinon
 * @param app La MtgApp Propriétaire
 * @param {string} title le titre à afficher au-dessus de la liste
 * @constructor
 */
function PaneChoixVar (app, bHor, title) {
  var tabPrincipal, tabHaut, tr, td, i, liste, option, caption, self
  var tit = kernel.getStr(arguments.length === 2 ? 'Variable' : title)
  liste = app.listePr
  self = this
  this.inf = liste.listeParNatCal(app, NatCal.NVariable, -1)
  tabPrincipal = kernel.ce('table', {
    cellspacing: 2
  })
  this.container = tabPrincipal
  tr = kernel.ce('TR')
  tabPrincipal.appendChild(tr)
  tabHaut = kernel.ce('table', {
    cellspacing: 5
  })
  tr.appendChild(tabHaut)
  tr = kernel.ce('tr')
  tabHaut.appendChild(tr)
  td = kernel.ce('td')
  $(td).css('vertical-align', 'top')
  caption = kernel.ce('caption', {
    class: 'mtgcaption',
    style: 'width:120px'
  })
  td.appendChild(caption)
  $(caption).html(tit)

  tr.appendChild(td)
  this.select = kernel.ce('select', {
    size: 5, // Le nombre de lignes visibles par défaut
    style: 'width:150px'
  })
  this.select.onchange = function () {
    self.onSelectChange()
  }

  td.appendChild(this.select)
  // C'est là qu'on ajoute les noms des valeurs numériques disponibles dans la liste déroulante
  for (i = 0; i < this.inf.noms.length; i++) {
    option = kernel.ce('Option', {
      class: 'mtgOption'
    })
    if (i === 0) option.setAttribute('selected', 'selected')
    $(option).html(this.inf.noms[i])
    option.ondblclick = function () { self.OK() }
    this.select.appendChild(option)
  }
  if (!bHor) {
    tr = kernel.ce('TR')
    tabPrincipal.appendChild(tr)
  }
  td = kernel.ce('td')
  tr.appendChild(td)
  caption = kernel.ce('caption', {
    class: 'mtgcaption',
    style: 'width:250px'
  })
  td.appendChild(caption)
  $(caption).html(kernel.getStr('ChoixValeurDlg3'))
  this.textarea = kernel.ce('textarea', {
    cols: 40,
    rows: 5,
    disabled: 'true'
  })
  $(this.textarea).css('font-size', '13px')
  td.appendChild(this.textarea)
  this.onSelectChange()
}

PaneChoixVar.prototype.onSelectChange = function () {
  var ind, el
  ind = this.select.selectedIndex
  el = this.inf.pointeurs[ind]
  $(this.textarea).text(el.infoHist())
}

PaneChoixVar.prototype.getVar = function () {
  return this.inf.pointeurs[this.select.selectedIndex]
}

/**
 * Fonction sélectionnant dans la liste la variable va
 * @param va
 */
PaneChoixVar.prototype.selectVar = function (va) {
  var inf = this.inf
  for (var i = 0; i < inf.noms.length; i++) {
    if (inf.pointeurs[i] === va) {
      this.select.selectedIndex = i
      break
    }
  }
}
