/*
 * Created by yvesb on 19/10/2016.
 */
const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const $ = require('./../global/jQuery-ui')

module.exports = PremierDernierDlg

/**
 * Ouvre la boite de dialogue pour choisir entre le premier et le dernier objet
 * @param app
 * @param outilPointage
 * @param cible
 * @param premierObjet
 * @param dernierObjet
 * @param callBackOK
 * @constructor
 */
function PremierDernierDlg (app, outilPointage, cible, premierObjet, dernierObjet, callBackOK) {
  MtgDlg.call(this, app, 'premierDernierDlg', callBackOK)
  // Il peut arriver que l'endroit où on a cliqué soit aussi l'endroit d'un des deux boutons
  // OK ou Cancel et que la boîte se referme tout de suite.
  // Pour éviter cela on regardera le temps entre le début de la création de la boîte
  // et l'appui sur un de ces deux boutons
  this.outilPointage = outilPointage
  this.cible = cible
  this.premierObjet = premierObjet
  this.dernierObjet = dernierObjet
  var tab = kernel.ce('table', {
    cellspacing: 10
  })
  this.appendChild(tab)
  var th = kernel.ce('TH')
  tab.appendChild(th)
  var label = kernel.ce('label')
  $(label).html(kernel.getStr('ChoixEntre') + ' : ')
  th.appendChild(label)
  var tr = kernel.ce('TR')
  tab.appendChild(tr)
  label = kernel.ce('label', {
    for: 'mtgradiofirst'
  })
  $(label).html(kernel.getStr('PremierObj') + ':')
  tr.appendChild(label)
  var inp = kernel.ce('input', {
    id: 'mtgradiofirst',
    type: 'radio',
    name: 'mtgradio'
  })
  // inp.setAttribute("checked",true);
  tr.appendChild(inp)
  tr = kernel.ce('TR')
  tab.appendChild(tr)
  label = kernel.ce('label', {
    for: 'mtgradiolast'
  })
  $(label).html(kernel.getStr('DernierObj') + ':')
  tr.appendChild(label)
  inp = kernel.ce('input', {
    id: 'mtgradiolast',
    type: 'radio',
    name: 'mtgradio'
  })
  inp.setAttribute('checked', true)
  tr.appendChild(inp)
  // Création de la boîte de dialogue par jqueryui
  this.create('ChoixAPrec', 400)
}

PremierDernierDlg.prototype = new MtgDlg()

PremierDernierDlg.prototype.OK = function () {
  const premierChoisi = $('#mtgradiofirst').prop('checked')
  this.outilPointage[this.cible] = premierChoisi ? this.premierObjet : this.dernierObjet
  if (this.callBackOK !== null) this.callBackOK()
  this.destroy()
}
