/*
 * Created by yvesb on 18/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const kernel = require('../kernel/kernel')
const MtgDlg = require('./MtgDlg')
const MtgInput = require('./MtgInput')
const AvertDlg = require('./AvertDlg')
const DataOutputStream = require('../entreesSorties/DataOutputStream')
const FileSaver = require('file-saver')
const $ = require('./../global/jQuery-ui')
module.exports = SaveConstDlg

function SaveConstDlg (app, proto) {
  MtgDlg.call(this, app, 'SaveConstDlg')
  this.proto = proto
  var self = this
  var tabPrincipal = kernel.ce('table', {
    cellspacing: 10
  })
  this.appendChild(tabPrincipal)
  var tr = kernel.ce('tr')
  tabPrincipal.appendChild(tr)
  var div = kernel.ce('div')
  tr.appendChild(div)
  var label = kernel.ce('label')
  $(label).html(kernel.getStr('saveDlg1'))
  div.appendChild(label)
  this.input = new MtgInput({
    id: 'mtginput'
  })
  div.appendChild(this.input)
  this.input.onkeyup = function (ev) {
    this.demarquePourErreur()
    if (ev.keyCode === 13) {
      $(this).blur() // Nécéssaire sur ipad pour une raison que j'ignore
      self.OK()
    }
  }
  this.create('SaveConst', 550)
}

SaveConstDlg.prototype = new MtgDlg()

SaveConstDlg.prototype.OK = function () {
  var ch = $('#mtginput').val()
  // On regarde si la chaîne entrée est non-vide et ne contient que des caractères ascii
  if ((ch === '') || ch.match(/\W/)) {
    this.input.marquePourErreur()
    new AvertDlg(this.app, 'NomFichierErr', function () {
      $('#mtginput').focus()
    })
  }
  var oups = new DataOutputStream()
  this.proto.write(oups)
  var ba = oups.ba
  var len = ba.length
  var buffer = new ArrayBuffer(ba.length)
  var dataView = new DataView(buffer)
  for (var i = 0; i < len; i++) dataView.setUint8(i, ba[i])
  FileSaver.saveAs(new Blob([buffer], { type: '' }), ch + '.mgc') // eslint-disable-line no-undef
  this.destroy()
}
