/*
 * Created by yvesb on 11/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
// y est l'ordonnée réelle du coin supérieur gauche du bouton relativement à la barre d'outils de droite
const Button = require('./Button')
const constantes = require('../kernel/constantes')

module.exports = MarqueAngleButton

function MarqueAngleButton (app, style, fileName, row, col, y) {
  Button.call(this, app, fileName, 'ChoixMarqueAng', constantes.buttonMarqueWidth, constantes.buttonMarqueWidth)
  this.style = style
  this.row = row
  this.col = col
  this.y = y
  this.target = 'right'
  this.build()
  this.container.setAttribute('transform', 'translate(' + col * this.w + ',' + row * this.h + ')')
  app.marqueAnglePanel.appendChild(this.container)
  this.container.setAttribute('visibility', 'visible')
}

MarqueAngleButton.prototype = new Button()

MarqueAngleButton.prototype.singleClickAction = function () {
  this.app.styleMarqueAngle = this.style
  this.app.selectButton(this.style, this.app.marqueAngleButtons)
}
