/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

module.exports = COb
/**
 * Objet de base de MathGraph32. Contient un numéro de version
 * Les classes hériteront toutes de COb et devront redéfinir numeroVersion
 * dans leur protoype si elles utilisent un numéro de version différent
 * @constructor
 * @param {CListeObjets} listeProprietaire
 * @returns {undefined}
 */
function COb (listeProprietaire) {
  if (arguments.length === 0) return // Ajout version WebPack
  this.nVersion = this.numeroVersion()
  this.listeProprietaire = listeProprietaire
}
/**
 * Fonction renvoyant le numéro de version de l'objet en accord avec la version Java
 * @returns {Number}
 */
COb.prototype.numeroVersion = function () { return 1 }
/**
 * Fonction lisant l'objet dans le flux binaire inps
 * A redéfinir pour les descendants
 * @param {DataInputStream} inps
 * @param {CListeObjets} list
 * @returns {undefined}
 */
COb.prototype.read = function (inps, list) {
  this.listeProprietaire = list
}
// Ne fait rien mais gardé quand même pour compatibilit java
/**
 * Fonction enregistrant l'objet dans le flux binaire oups
 * A redéfinir pour les descendants
 * @param {DataOutputStream} oups
 * @param {CListeObjets} list
 * @returns {undefined}
 */
COb.prototype.write = function (oups, list) {
}
