/*
 * Created by yvesb on 06/06/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CArcDeCercleAncetre = require('../objets/CArcDeCercleAncetre')
const kernel = require('../kernel/kernel')
const Vect = require('../types/Vect')
module.exports = CArcDeCercleAncetre

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CArcDeCercleAncetre.prototype.genereNom = function () {
  CArcDeCercleAncetre.ind++
  return kernel.getStr('rarc') + CArcDeCercleAncetre.ind
}

CArcDeCercleAncetre.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  var list = this.listeProprietaire
  var x1 = list.tikzXcoord(this.a.x, dimf, bu)
  var y1 = list.tikzYcoord(this.a.y, dimf, bu)
  var ray = list.tikzLongueur(this.rayon, dimf, bu)
  var u = new Vect(this.centreX, this.centreY, this.origine_x, this.origine_y)
  var ang1 = u.angleRad()
  var ang2 = ang1 + this.valeurAngleAuCentre
  if (ang2 < 0) ang2 = ang2 + 2 * Math.PI
  if (ang2 >= 2 * Math.PI) ang2 = ang2 - 2 * Math.PI
  if (ang2 < ang1) ang2 = ang2 + 2 * Math.PI

  ang1 *= kernel.ConvRadDeg
  ang2 *= kernel.ConvRadDeg
  return '\\draw ' + this.tikzLineStyle(dimf, coefmult) + '(' + kernel.chaineNombre(x1, 3) + ',' + kernel.chaineNombre(y1, 3) + ') arc ' +
    '(' + kernel.chaineNombre(ang1, 3) + ' : ' + kernel.chaineNombre(ang2, 3) + ' : ' + kernel.chaineNombre(ray, 3) + ');'
}
