/*
 * Created by yvesb on 22/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CAutrePointIntersectionDroiteCercle = require('../objets/CAutrePointIntersectionDroiteCercle')
const CPt = require('../objets/CPt')
const kernel = require('../kernel/kernel')
module.exports = CAutrePointIntersectionDroiteCercle

CAutrePointIntersectionDroiteCercle.prototype.info = function () {
  var ch = this.nom + ' : '
  ch += kernel.getStr('chinfo193') + ' ' + this.d.getNom() + ' ' + kernel.getStr('chinfo194') + ' ' + this.c.nom +
    ', ' + kernel.getStr('chinfo227') + ' ' + this.pointExclu.nom
  return ch
}

CAutrePointIntersectionDroiteCercle.prototype.appartientDroiteParDefinition = function (droite) {
  return CPt.prototype.appartientDroiteParDefinition.call(this, droite) || (droite === this.d)
}

CAutrePointIntersectionDroiteCercle.prototype.appartientCercleParDefinition = function (cercle) {
  return CPt.prototype.appartientCercleParDefinition.call(this, cercle) || (cercle === this.c)
}

CAutrePointIntersectionDroiteCercle.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.c.depDe4Rec(p) || this.d.depDe4Rec(p) || this.pointExclu.depDe4Rec(p))
}

CAutrePointIntersectionDroiteCercle.prototype.estDefiniParObjDs = function (listeOb) {
  return this.c.estDefPar(listeOb) &&
  this.d.estDefPar(listeOb) &&
  this.pointExclu.estDefPar(listeOb)
}
