/*
 * Created by yvesb on 30/05/2021.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CCalcMat = require('../objets/CCalcMat')
const CalcMatDlg = require('../dialogs/CalcMatDlg')
const kernel = require('../kernel/kernel')
module.exports = CCalcMat

CCalcMat.prototype.info = function () {
  return this.getNom() + ' = ' + this.chaineCalcul
}

CCalcMat.prototype.infoHist = function () {
  let ch = kernel.getStr('CalcMat') + ' ' + this.getNom() + ' = ' + this.chaineCalcul
  const resultat = this.resultat
  if (this.existe) {
    if (typeof resultat === 'number') {
      ch += '\n' + kernel.getStr('Matrice') + ' 1x1'
      ch += '\n' + kernel.chaineNombre(resultat, 12)
    } else {
      const size = resultat.size()
      const n = size[0]
      const p = size[1]
      ch += '\n' + kernel.getStr('Matrice') + ' ' + n + 'x' + p
      for (let i = 0; i < n; i++) {
        ch += '\n'
        for (let j = 0; j < p; j++) {
          if (j !== 0) ch += '   '
          const nb = resultat.get([i, j])
          ch += (nb >= 0 ? '  ' : '') + kernel.chaineNombre(nb, 12)
        }
      }
    }
  } else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CCalcMat.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CCalcMat.prototype.modifDlg = function (app, callBack1, callBack2) {
  new CalcMatDlg(app, this, true, callBack1, callBack2)
}
