/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CCalculComplexe = require('../objets/CCalculComplexe')
const kernel = require('../kernel/kernel')
const CalculDlg = require('../dialogs/CalculDlg')
module.exports = CCalculComplexe

CCalculComplexe.prototype.info = function () {
  return this.getNom() + ' = ' + this.chaineCalcul + ' (' + kernel.getStr('CalculComp') + ')'
}

CCalculComplexe.prototype.infoHist = function () {
  var ch = this.getNom() + ' : ' + kernel.getStr('CalculComp') + '\n' + this.getNom() + ' = ' + this.chaineCalcul
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + this.rendChaineValeurComplexe(12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CCalculComplexe.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CCalculComplexe.prototype.modifDlg = function (app, callBack1, callBack2) {
  new CalculDlg(app, this, true, false, callBack1, callBack2)
}
