/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CCercleOR = require('../objets/CCercleOR')
const RayonDlg = require('../dialogs/RayonDlg')
const CCercle = require('../objets/CCercle')
const CTransformation = require('../objets/CTransformation')
const kernel = require('../kernel/kernel')

module.exports = CCercleOR

CCercleOR.prototype.utiliseLongueurUnite = function () {
  return !this.inPixels
}

CCercleOR.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo195') + ' ' + this.o.nom + ' ' +
    kernel.getStr('chinfo197') + ' ' + this.r.chaineInfo()
}

CCercleOR.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CCercleOR.prototype.modifDlg = function (app, callBack1, callBack2) {
  new RayonDlg(app, this, true, callBack1, callBack2)
}

CCercleOR.prototype.contientParDefinition = function (po) {
  // if (this.o === po) return true; // Correction version 6.0
  if (po.estPointImage()) {
    // CPointImage ptim = (CPointImage) po;
    if (po.transformation.natureTransformation() === CTransformation.rotation) {
      var rot = po.transformation
      return po.antecedent.appartientCercleParDefinition(this) && (rot.centre === this.o)
    } else return false
  } else return false
}

CCercleOR.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCercle.prototype.depDe4Rec.call(this, p) ||
    this.o.depDe4Rec(p) || this.r.depDe4Rec(p) || this.listeProprietaire.pointeurLongueurUnite.depDe4Rec(p))
}

CCercleOR.prototype.adaptRes = function (coef) {
  CCercle.prototype.adaptRes.call(this, coef)
  if (this.inPixels) this.coefMult = coef
}

CCercleOR.prototype.estDefiniParObjDs = function (listeOb) {
  return this.o.estDefPar(listeOb) &&
    this.r.estDefiniParObjDs(listeOb)
}

CCercleOR.prototype.estCercleParCentre = function () {
  return true
}
