/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CDemiDroiteImage = require('../objets/CDemiDroiteImage')
const CDemiDroite = require('../objets/CDemiDroite')
const CTransformation = require('../objets/CTransformation')
const kernel = require('../kernel/kernel')

module.exports = CDemiDroiteImage

CDemiDroiteImage.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo36') + ' ' + this.antecedent.nom + ' ' +
    kernel.getStr('par') + ' ' + this.transformation.complementInfo()
}

CDemiDroiteImage.prototype.associeATransformation = function (trans) {
  this.transformation = trans
}

CDemiDroiteImage.prototype.antecedentDirect = function () {
  return this.transformation
}

CDemiDroiteImage.prototype.modifiableParMenu = function () {
  return !this.estElementFinal && this.transformation.imageModifiableParMenu()
}

CDemiDroiteImage.prototype.contientParDefinition = function (po) {
  if (po.estPointImage()) { return (this.transformation === po.transformation) && (po.antecedent.appartientDroiteParDefinition(this.antecedent)) } else return false
}
CDemiDroiteImage.prototype.estParalleleParDefinition = function (dte) {
  return (dte === this) ||
    (((this.transformation.natureTransformation() & CTransformation.tteTransImDtePar) !== 0) &&
    (this.antecedent.estParalleleParDefinition(dte) || dte.estParalleleParDefinition(this.antecedent)))
}

CDemiDroiteImage.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CDemiDroite.prototype.depDe4Rec.call(this, p) ||
    this.antecedent.depDe4Rec(p) || this.transformation.depDe4Rec(p))
}

/**
 * Fonction qui renvoie true seulement pour les objets qui sont des objets images d'un autre par une transformation
 * @returns {boolean}
 */
CDemiDroiteImage.prototype.estImageParTrans = function () {
  return true
}

CDemiDroiteImage.prototype.estDefiniParObjDs = function (listeOb) {
  return this.antecedent.estDefPar(listeOb) &&
  this.transformation.estDefPar(listeOb)
}
