/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CDerivee = require('../objets/CDerivee')
const kernel = require('../kernel/kernel')
const CFonc = require('../objets/CFonc')
const DeriveeDlg = require('../dialogs/DeriveeDlg')
module.exports = CDerivee

CDerivee.prototype.info = function () {
  return this.infoHist()
}

CDerivee.prototype.infoHist = function () {
  return this.getNom() + ' : ' + kernel.getStr('ch112') + ' ' + this.fonctionAssociee.getNom()
}

CDerivee.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CDerivee.prototype.modifDlg = function (app, callBack1, callBack2) {
  new DeriveeDlg(app, this, true, callBack1, callBack2)
}

CDerivee.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CFonc.prototype.depDe4Rec.call(this, p) || this.fonctionAssociee.depDe4Rec(p))
}

CDerivee.prototype.estDefiniParObjDs = function (listeOb) {
  return this.fonctionAssociee.estDefPar(listeOb)
}
