/*
 * Created by yvesb on 28/11/2016.
 */

/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CDeriveePartielle = require('../objets/CDeriveePartielle')
const kernel = require('../kernel/kernel')
const CFoncNVar = require('../objets/CFoncNVar')
const DeriveePartielleDlg = require('../dialogs/DeriveePartDlg')
module.exports = CDeriveePartielle

/**
 * Fonction renvoyant un tableau de chaîne de caractères représentant les noms des variables utilisée pour la fonction
 * @returns {String}
 */
CDeriveePartielle.prototype.getVariable = function () {
  return this.fonctionAssociee.getVariable()
}

CDeriveePartielle.prototype.info = function () {
  var chaineVariable = this.getVariable()
  var ch = this.getNom() + '('
  for (var i = 0; i < this.nbVar; i++) {
    ch = ch + chaineVariable[i]
    if (i !== this.nbVar - 1) { ch = ch + ',' }
  }
  return ch + ') : ' + kernel.getStr('Fonction') + ' ' + kernel.getStr('ch190')
}

CDeriveePartielle.prototype.infoHist = function () {
  return this.getNom() + ' : ' + kernel.getStr('Fonction') + ' ' + kernel.getStr('ch190') + '\n' + this.fonctionAssociee.getNom() + ' ' +
    kernel.getStr('ch191') + ' ' + this.getVariable()[this.indiceVariableDerivation]
}

CDeriveePartielle.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CDeriveePartielle.prototype.modifDlg = function (app, callBack1, callBack2) {
  new DeriveePartielleDlg(app, this, true, callBack1, callBack2)
}

CDeriveePartielle.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CFoncNVar.prototype.depDe4Rec.call(this, p) || this.fonctionAssociee.depDe4Rec(p))
}

CDeriveePartielle.prototype.estDefiniParObjDs = function (listeOb) {
  return this.fonctionAssociee.estDefPar(listeOb)
}
