/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CFoncComplexeNVar = require('../objets/CFoncComplexeNVar')
const kernel = require('../kernel/kernel')
const FonctionDlg = require('../dialogs/FonctionDlg')
module.exports = CFoncComplexeNVar

CFoncComplexeNVar.prototype.info = function () {
  var ch = this.getNom() + '('
  for (var i = 0; i < this.nbVar; i++) {
    ch = ch + this.chaineVariable[i]
    if (i !== this.nbVar - 1) ch = ch + ','
  }
  ch = ch + ')' + ' = ' + this.chaineCalcul + ' (' + kernel.getStr('FoncComp') + ')'
  return ch
}
CFoncComplexeNVar.prototype.infoHist = function () {
  var ch = this.getNom() + ' : ' + kernel.getStr('FoncComp') + ' ' + kernel.getStr('ch87') + '\n' + this.info()
  if (!this.existe) ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CFoncComplexeNVar.prototype.modifDlg = function (app, callBack1, callBack2) {
  new FonctionDlg(app, this, true, false, callBack1, callBack2)
}
