/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CFoncNVar = require('../objets/CFoncNVar')
const kernel = require('../kernel/kernel')
const FonctionDlg = require('../dialogs/FonctionDlg')
module.exports = CFoncNVar

/**
 * Fonction renvoyant un tableau de chaîne de caractères représentant les noms des variables utilisée pour la fonction
 * @returns {String}
 */
CFoncNVar.prototype.getVariable = function () {
  return this.chaineVariable
}

CFoncNVar.prototype.info = function () {
  var ch = this.getNom() + '('
  for (var i = 0; i < this.nbVar; i++) {
    ch = ch + this.chaineVariable[i]
    if (i !== this.nbVar - 1) { ch = ch + ',' }
  }
  return ch + ')' + ' = ' + this.chaineCalcul
}

CFoncNVar.prototype.infoHist = function () {
  var ch = this.getNom() + ' : ' + kernel.getStr('Fonction') + ' ' + kernel.getStr('ch87') + '\n' + this.info()
  if (!this.existe) { ch = ch + '\n' + kernel.getStr('ch18') }
  return ch
}

CFoncNVar.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CFoncNVar.prototype.modifDlg = function (app, callBack1, callBack2) {
  new FonctionDlg(app, this, true, true, callBack1, callBack2)
}
