/*
 * Created by yvesb on 23/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CIntDroiteDroite = require('../objets/CIntDroiteDroite')
const CPt = require('../objets/CPt')
const kernel = require('../kernel/kernel')
module.exports = CIntDroiteDroite

CIntDroiteDroite.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo193') + ' ' + this.droite1.getNom() + ' ' +
    kernel.getStr('chinfo194') + ' ' + this.droite2.getNom()
}

CIntDroiteDroite.prototype.appartientDroiteParDefinition = function (droite) {
  return CPt.prototype.appartientDroiteParDefinition.call(this, droite) || (droite === this.droite1) || (droite === this.droite2)
}

CIntDroiteDroite.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.droite1.depDe4Rec(p) || this.droite2.depDe4Rec(p))
}

CIntDroiteDroite.prototype.estDefiniParObjDs = function (listeOb) {
  return this.droite1.estDefPar(listeOb) &&
  this.droite2.estDefPar(listeOb)
}
