/*
 * Created by yvesb on 29/05/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CLieuObjetParVariable = require('../objets/CLieuObjetParVariable')
const CLieuObjetAncetre = require('../objets/CLieuObjetAncetre')
const kernel = require('../kernel/kernel')
module.exports = CLieuObjetParVariable

CLieuObjetParVariable.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('LieuObj') + ' ' + kernel.getStr('de') + ' ' + this.elementAssocie.getNom() +
    ' ' + kernel.getStr('chinfo207') + ' ' + this.variableGeneratrice.nomCalcul
}

CLieuObjetParVariable.prototype.positionneTikz = function (infoRandom, dimfen) {
  var valeur, valeurMinimale, valeurMaximale, valeurInitiale, pas
  CLieuObjetAncetre.prototype.positionneTikz.call(this, infoRandom, dimfen)
  var vg = this.variableGeneratrice
  this.existe = this.existe && (this.nombreObjetsPourLieuObjet() <= CLieuObjetAncetre.nombreMaxiPourLieuObjet)
  var dnbt = Math.round(this.nombreTraces.rendValeur())
  this.existe = this.existe && (dnbt >= 2) && (dnbt <= CLieuObjetAncetre.nombreMaxiPourLieuObjet)
  if (!this.existe) return
  var nbt = Math.round(dnbt)
  if (nbt !== this.listeCopiesObjet.longueur()) this.ajusteListeCopieObjets()
  valeurMinimale = vg.valeurMini
  valeurMaximale = vg.valeurMaxi
  valeurInitiale = vg.valeurActuelle
  pas = (valeurMaximale - valeurMinimale) / (nbt - 1)
  valeur = valeurMinimale

  var elementAssocieMasque = this.elementAssocie.masque
  this.elementAssocie.montre()
  this.existe = false
  var nb = nbt - 1
  for (var i = 0; i < nbt; i++) {
    valeur = (i === 0) ? valeurMinimale : ((i === nb) ? valeurMaximale : valeur + pas)
    vg.donneValeur(valeur)
    this.listeElementsAncetres.positionneTikz(infoRandom, dimfen)
    this.existe = this.existe || this.elementAssocie.existe
    var ptelg = this.listeCopiesObjet.get(i)
    ptelg.setCloneTikz(this.elementAssocie)
    ptelg.montre()
  }
  this.elementAssocie.masque = elementAssocieMasque
  // On redonne à la variable génératrice sa valeur initiale
  vg.donneValeur(valeurInitiale)
  this.listeElementsAncetres.positionne(infoRandom, dimfen)
}

CLieuObjetParVariable.prototype.estDefiniParObjDs = function (listeOb) {
  return CLieuObjetAncetre.prototype.estDefiniParObjDs.call(this, listeOb) &&
  this.variableGeneratrice.estDefPar(listeOb)
  // && this.nombreTraces.estDefiniParObjDs(listeOb); // Supprimé version 6.3.0. Inutile
}
