/*
 * Created by yvesb on 17/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const kernel = require('../kernel/kernel')
const CLignePolygonaleAncetre = require('../objets/CLignePolygonaleAncetre')
const CElementLigne = require('../objets/CElementLigne')

module.exports = CLignePolygonaleAncetre

CLignePolygonaleAncetre.prototype.getNom = function () {
  return kernel.getStr('LigneBrisee') + ' ' + this.nomSommets()
}

CLignePolygonaleAncetre.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  var resultat = CElementLigne.prototype.depDe4Rec.call(this, p)
  for (var i = 0; (i < this.colPoints.length) && !resultat; i++) {
    var ptp = this.colPoints[i].pointeurSurPoint
    resultat = resultat || ptp.depDe4Rec(p)
  }
  return this.memDep4Rec(resultat)
}

CLignePolygonaleAncetre.prototype.distancePointPourSurface = function (xp, yp, masquage) {
  var dis
  if (!this.existe) return -1
  else {
    dis = kernel.MAX_VALUE
    for (var i = 0; i < this.nombrePoints - 1; i++) {
      this.point1.placeEn(this.absPoints[i], this.ordPoints[i])
      this.point2.placeEn(this.absPoints[i + 1], this.ordPoints[i + 1])
      this.segment.positionne()
      var d = this.segment.distancePoint(xp, yp, true)
      if ((d !== -1) && (d < dis)) dis = d
    }
  }
  if (dis === kernel.MAX_VALUE) dis = -1
  return dis
}

CLignePolygonaleAncetre.prototype.distancePoint = function (xp, yp, masquage) {
  if (!(this.existe) || (masquage && this.masque)) return -1
  else return this.distancePointPourSurface(xp, yp, masquage)
}

CLignePolygonaleAncetre.prototype.estDefiniParObjDs = function (listeOb) {
  for (var i = 0; i < this.colPoints.length; i++) {
    if (!this.colPoints[i].pointeurSurPoint.estDefPar(listeOb)) return false
  }
  return true
}
