/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CListeObjets = require('../objets/CListeObjets')
const Pointeur = require('../types/Pointeur')
const NatObj = require('../types/NatObj')
const NatCal = require('../types/NatCal')
const Nat = require('../types/Nat')
const CPointBase = require('../objets/CPointBase')
const CPointLieDroite = require('../objets/CPointLieDroite')
const Color = require('../types/Color')
const MotifPoint = require('../types/MotifPoint')
const CDroite = require('../objets/CDroite')
const CDroiteDirectionFixe = require('../objets/CDroiteDirectionFixe')
const CDroiteAB = require('../objets/CDroiteAB')
const CDroitePerpendiculaire = require('../objets/CDroitePerpendiculaire')
const CCercleOA = require('../objets/CCercleOA')
const CIntDroiteCercle = require('../objets/CIntDroiteCercle')
const CPointLieBipoint = require('../objets/CPointLieBipoint')
const CRepere = require('../objets/CRepere')
const CLongueur = require('../objets/CLongueur')
const StyleTrait = require('../types/StyleTrait')
const StyleFleche = require('../types/StyleFleche')
const CLatex = require('../objets/CLatex')
const StyleEncadrement = require('../types/StyleEncadrement')
const CAffLiePt = require('../objets/CAffLiePt')
const CPointLieCercle = require('../objets/CPointLieCercle')
const CVecteur = require('../objets/CVecteur')
const CCalcConst = require('../objets/CCalcConst')
const kernel = require('../kernel/kernel')
const PositionDroites = require('../types/PositionDroites')
const PositionDroiteCercle = require('../types/PositionDroiteCercle')
const PositionCercleCercle = require('../types/PositionCercleCercle')
const CSegment = require('../objets/CSegment')
const CMilieu = require('../objets/CMilieu')
const CCommentaire = require('../objets/CCommentaire')
const CDemiDroiteOA = require('../objets/CDemiDroiteOA')
const CTranslation = require('../objets/CTranslation')
const CMesureX = require('../objets/CMesureX')
const CAppelFonction = require('../objets/CAppelFonction')
const CPointDansRepere = require('../objets/CPointDansRepere')
const CResultatValeur = require('../objets/CResultatValeur')
const InfoLieu = require('../types/InfoLieu')
const CLieuDePoints = require('../objets/CLieuDePoints')
const CCalcul = require('../objets/CCalcul')
const CValeur = require('../objets/CValeur')
const CPointImage = require('../objets/CPointImage')
const CConstante = require('../objets/CConstante')
const COperation = require('../objets/COperation').default
const CHomothetie = require('../objets/CHomothetie')
const Ope = require('../types/Ope')
/// //////////////////////////////////////////////////////////
// Constantes importées pour le protocole de la figure
const CAbscisseOrigineRep = require('../objets/CAbscisseOrigineRep')
const COrdonneeOrigineRep = require('../objets/COrdonneeOrigineRep')
const CUnitexRep = require('../objets/CUnitexRep')
const CUniteyRep = require('../objets/CUniteyRep')
const CArcDeCercleAncetre = require('../objets/CArcDeCercleAncetre')
const CCercle = require('../objets/CCercle')
const CDemiDroite = require('../objets/CDemiDroite')
const CDemiPlan = require('../objets/CDemiPlan')
const CEditeurFormule = require('../objets/CEditeurFormule')
const CGrapheSuiteRec = require('../objets/CGrapheSuiteRec')
const CGrapheSuiteRecComplexe = require('../objets/CGrapheSuiteRecComplexe')
const CImage = require('../objets/CImage')
const CLieuDeBase = require('../objets/CLieuDeBase')
const CLieuDiscretDeBase = require('../objets/CLieuDiscretDeBase')
const CLieuObjetAncetre = require('../objets/CLieuObjetAncetre')
const CMacro = require('../objets/CMacro')
const CMarqueAngleAncetre = require('../objets/CMarqueAngleAncetre')
const CMarqueSegment = require('../objets/CMarqueSegment')
const CPt = require('../objets/CPt')
const CDroiteAncetre = require('../objets/CDroiteAncetre')
const CSurface = require('../objets/CSurface')
const CValeurAffichee = require('../objets/CValeurAffichee')
const ConfirmDlg = require('../dialogs/ConfirmDlg')

module.exports = CListeObjets

CListeObjets.prototype.depDe4Rec = function (el) {
  let i
  for (i = 0; i < this.longueur(); i++) {
    if (this.get(i).depDe4Rec(el)) return true
  }
  return false
}

CListeObjets.prototype.ajouteCourbe = function (app, repere, droiteIntervalle, fonction,
  nomPointLieAxe, nomCalculAbscisse, nomCalculOrdonnee, nombrePoints,
  pointLieCache, pointCourbeCache, gestionAutoDiscontinuite) {
  // On génère une abscisse aléatoire pour le point lié à l'axe des
  // abscisses

  var abs1 = droiteIntervalle.abscisseMinimale()
  var abs2 = droiteIntervalle.abscisseMaximale()
  var d = abs2 - abs1
  var bl = Color.black
  abs1 = abs1 + d / 10
  abs2 = abs2 - d / 10
  var abs = abs1 + (abs2 - abs1) * Math.random()
  // var pointLieDroite = new CPointLieDroite(listePr, null, false, Color.black, false, 0d, 0d,
  //  pointLieCache, nomPointLieAxe, frame.pref_indiceTaillePoliceNom, MotifPoint.PetitRond, true, abs,
  //  droiteIntervalle, false);
  var pointLieDroite = new CPointLieDroite(this, null, false, bl, false, 0, 3, pointLieCache, '', app.getTaillePoliceNom(),
    MotifPoint.petitRond, false, true, abs, droiteIntervalle)
  pointLieDroite.donneNom(nomPointLieAxe)
  this.add(pointLieDroite)
  // On crée la mesure de l'abscisse du point qu'on vient de créer
  // Modifié version 5.0
  var calculAbscisse = new CMesureX(this, null, false, nomCalculAbscisse, repere, pointLieDroite)
  this.add(calculAbscisse)
  var ordonnee = new CAppelFonction(this, fonction, new CResultatValeur(this, calculAbscisse))
  var calculOrdonnee = new CCalcul(this, null, false, nomCalculOrdonnee, ordonnee.chaineCalculSansPar(null), ordonnee)
  this.add(calculOrdonnee)
  // Il faut maintenant créer le point repéré de la courbe dont
  // les positions successives généreront cette courbe
  var pointCourbe = new CPointDansRepere(this, null, false, bl, false, 0, 3, pointCourbeCache, '', app.getTaillePoliceNom(),
    MotifPoint.petitRond, false, repere, new CValeur(this, new CResultatValeur(this, calculAbscisse)),
    new CValeur(this, new CResultatValeur(this, calculOrdonnee)))
  this.add(pointCourbe)
  // Il faut maintenant créer la courbe comme un lieu de points
  var infoLieu = new InfoLieu(nombrePoints, false, gestionAutoDiscontinuite)
  var lieu = new CLieuDePoints(this, null, false, app.getCouleur(), false, app.getStyleTrait(), pointCourbe,
    infoLieu, pointLieDroite)
  this.add(lieu)
  lieu.etablitListeElementsAncetres()
  // On regarde si le lieu créé est visible
  this.positionne(false, app.dimf)
  if (!lieu.dansFen(app.dimf)) {
    new ConfirmDlg(app, 'Lieuhf', null, function () {
      app.detruitDerniersElements(6)
    })
  }
}

CListeObjets.prototype.ajouteCourbeSurR = function (app, repere, fonction, nomPointLieAxe, nomCalculAbscisse,
  nomCalculOrdonnee, nombrePoints, pointLieCache, pointCourbeCache, gestionAutoDiscontinuite) {
  // On regarde si le repère possède déjà un axe des abscisses
  var list = app.listePr
  var axe = this.existeDroiteABDefiniePar(repere.o, repere.i)
  if (axe === null) {
    // axe = new CDroiteAB(frame.cadreActif().listePr, null, false, Color.black, StyleTrait.traitFin, repere.O, repere.I,
    //  frame.pref_indiceTaillePoliceNom);
    axe = new CDroiteAB(list, null, false, Color.black, false, 0, 0, false, '', app.getTaillePoliceNom(), StyleTrait.stfc(list),
      CDroite.abscisseNomParDefaut, repere.o, repere.i)
    this.add(axe)
  }
  this.ajouteCourbe(app, repere, axe, fonction, nomPointLieAxe, nomCalculAbscisse, nomCalculOrdonnee, nombrePoints,
    pointLieCache, pointCourbeCache, gestionAutoDiscontinuite)
}

/**
 * Fonction ajoutant dans le repère repere la courbe d'une fonction sur l'intervalle [a;b]
 * @param app L'application propriétaire
 * @param repere Le repère dans lequel la courbe doit être tracée
 * @param fonction La fonction dont la courbe doit être tracée
 * @param nomPointLieAxe Le nom du point lié à l'axe (qui doit êgtre ici un segment)
 * @param nomCalculAbscisse Le nom de la mesure de l'abscisse de ce point lié
 * @param nomCalculOrdonnee Le nom de l'image de l'abscisse par la fonction
 * @param nombrePoints Le nomnbre de points de la courbe
 * @param pointLieCache true si le point lié doit être caché
 * @param pointCourbeCache true su le point générateur de la courbe doit être caché
 * @param gestionAutoDiscontinuite true pour une gestion auto des discontinuités de la courbe
 * @param a Un CValeur contenant la valeur de a
 * @param b Un CValeur contenant la valeur de b
 */
CListeObjets.prototype.ajouteCourbeSurab = function (app, repere, fonction, nomPointLieAxe, nomCalculAbscisse,
  nomCalculOrdonnee, nombrePoints, pointLieCache, pointCourbeCache, gestionAutoDiscontinuite, a, b) {
  // On regarde si le repère possède déjà un axe des abscisses

  var pta = a.existePtAbs(this, repere)
  if (pta === null) {
    pta = new CPointDansRepere(this, null, false, Color.black, false, 3, 0, false, '', app.getTaillePoliceNom(),
      MotifPoint.petitRond, false, repere, a, new CValeur(this, 0))
    this.add(pta)
  }
  var ptb = b.existePtAbs(this, repere)
  if (ptb === null) {
    ptb = new CPointDansRepere(this, null, false, Color.black, false, 3, 0, false, '', app.getTaillePoliceNom(),
      MotifPoint.petitRond, false, repere, b, new CValeur(this, 0))
    this.add(ptb)
  }
  var seg = new CSegment(this, null, false, Color.black, false, StyleTrait.stfc(this), pta, ptb)
  this.add(seg)
  this.ajouteCourbe(app, repere, seg, fonction, nomPointLieAxe, nomCalculAbscisse, nomCalculOrdonnee, nombrePoints,
    pointLieCache, pointCourbeCache, gestionAutoDiscontinuite)
}

/**
 * Fonction ajoutant dans le repère repere la courbe d'une fonction sur l'intervalle [a;+infini[
 * @param app Application propriétaire
 * @param {CRepere} repere  Le repère dans lequel la courbe doit être tracée
 * @param {CFonc} fonction  La fonction dont la courbe doit être tracée
 * @param {string} nomPointLieAxe  Le nom du point lié à l'axe (qui doit être ici un segment)
 * @param {string} nomCalculAbscisse  Le nom de la mesure de l'abscisse de ce point lié
 * @param {string} nomCalculOrdonnee  Le nom de l'image de l'abscisse par la fonction
 * @param {int} nombrePoints  Le nombre de points de la courbe
 * @param {boolean} pointLieCache  true si le point lié doit être caché
 * @param {boolean} pointCourbeCache  true su le point générateur de la courbe doit être caché
 * @param {boolean} gestionAutoDiscontinuite  true pour une gestion auto des discontinuités de la courbe
 * @param {CValeur} a  Un CValeur contenant la valeur de a
 */
CListeObjets.prototype.ajouteCourbeSuraInf = function (app, repere, fonction, nomPointLieAxe, nomCalculAbscisse,
  nomCalculOrdonnee, nombrePoints, pointLieCache, pointCourbeCache, gestionAutoDiscontinuite, a) {
  // On regarde si le repère possède déjà un axe des abscisses
  var pta = a.existePtAbs(this, repere)
  if (pta === null) {
    pta = new CPointDansRepere(this, null, false, Color.black, false, 3, 0, false, '', app.getTaillePoliceNom(),
      MotifPoint.petitRond, false, repere, a, new CValeur(this, 0))
    this.add(pta)
  }
  var trans = new CTranslation(this, null, false, repere.o, repere.i)
  this.add(trans)
  var ptim = new CPointImage(this, null, false, Color.black, false, 3, 0, false, '', app.getTaillePoliceNom(),
    MotifPoint.petitRond, false, pta, trans)
  this.add(ptim)
  var ddte = new CDemiDroiteOA(this, null, false, Color.black, false, StyleTrait.stfc(this), pta, ptim)
  this.add(ddte)
  this.ajouteCourbe(app, repere, ddte, fonction, nomPointLieAxe, nomCalculAbscisse, nomCalculOrdonnee, nombrePoints,
    pointLieCache, pointCourbeCache, gestionAutoDiscontinuite)
}

/**
 * Fonction ajoutant dans le repère repere la courbe d'une fonction sur l'intervalle ]-infini;a]
 * @param app L'application propriétaire
 * @param repere Le repère dans lequel la courbe doit être tracée
 * @param fonction La fonction dont la courbe doit être tracée
 * @param nomPointLieAxe Le nom du point lié à l'axe (qui doit êgtre ici un segment)
 * @param nomCalculAbscisse Le nom de la mesure de l'abscisse de ce point lié
 * @param nomCalculOrdonnee Le nom de l'image de l'abscisse par la fonction
 * @param nombrePoints Le nomnbre de points de la courbe
 * @param pointLieCache true si le point lié doit être caché
 * @param pointCourbeCache true su le point générateur de la courbe doit être caché
 * @param gestionAutoDiscontinuite true pour une gestion auto des discontinuités de la courbe
 * @param a Un CValeur contenant la valeur de a
 */
CListeObjets.prototype.ajouteCourbeSurInfa = function (app, repere, fonction, nomPointLieAxe, nomCalculAbscisse,
  nomCalculOrdonnee, nombrePoints, pointLieCache, pointCourbeCache, gestionAutoDiscontinuite, a) {
  // On regarde si le repère possède déjà un axe des abscisses
  var pta = a.existePtAbs(this, repere)
  if (pta === null) {
    pta = new CPointDansRepere(this, null, false, Color.black, false, 3, 0, false, '', app.getTaillePoliceNom(),
      MotifPoint.petitRond, false, repere, a, new CValeur(this, 0))
    this.add(pta)
  }
  var trans = new CTranslation(this, null, false, repere.i, repere.o)
  this.add(trans)
  var ptim = new CPointImage(this, null, false, Color.black, false, 3, 0, false, '', app.getTaillePoliceNom(),
    MotifPoint.petitRond, false, pta, trans)
  this.add(ptim)
  var ddte = new CDemiDroiteOA(this, null, false, Color.black, false, StyleTrait.stfc(this), pta, ptim)
  this.add(ddte)
  this.ajouteCourbe(app, repere, ddte, fonction, nomPointLieAxe, nomCalculAbscisse, nomCalculOrdonnee, nombrePoints,
    pointLieCache, pointCourbeCache, gestionAutoDiscontinuite)
}

/**
 * Fonction renvoyant un objet formé d'éléments de la liste du type d'objet graphique nat
 * qui ne sont pas des objest intermédiaires de construction
 * pointeurs : tableau contenant des pointeurs sur les objets trouvés
 * noms : tableau contenant les noms des onjets correspondant
 * @param app L'application MtgApp propriétaire
 * @param nat Nature des objets à afficher
 * @param indmax Indice du dernier objet à afficher (-1 pour afficher tous les objets compatibles)
 * @param exclu éventuel objet à ne pas faire figurer dans la liste
 * @returns {{pointeurs: Array, noms: Array}}
 */
CListeObjets.prototype.listeParNatCal = function (app, nat, indmax, exclu = null) {
  var i; var el; var valide
  var pointeurs = []
  var noms = []
  var indfin = indmax === -1 ? this.longueur() - 1 : indmax
  for (i = 0; i <= indfin; i++) {
    el = this.get(i)
    valide = (el !== exclu) && !el.estElementIntermediaire() && el.estDeNatureCalcul(nat)
    if (app.estExercice) valide = (valide && (app.listePourConst.indexOf(el) !== -1)) || app.calculOKForConst(el)
    if (valide) {
      pointeurs.push(el)
      noms.push(el.getNom())
    }
  }
  return { pointeurs: pointeurs, noms: noms }
}

/**
 * Fonctions renvoyant un objet formé de deux arrays contenant des pointeurs vers les macros pouvant être une macro de démarrage
 * et leurs intitulés respectifs. Le premier élément de la liste est un pointeur null
 * @returns {{pointeurs: Array, noms: Array}}
 */
CListeObjets.prototype.listeMacPourDem = function () {
  var i; var el
  var pointeurs = [null]
  var noms = [kernel.getStr('NoMac')]
  for (i = 0; i < this.longueur(); i++) {
    el = this.get(i)
    if (el.estDeNature(NatObj.NMacro) && el.utilisablePourDemarrage()) {
      pointeurs.push(el)
      noms.push(el.intitule)
    }
  }
  return { pointeurs: pointeurs, noms: noms }
}

CListeObjets.prototype.listePourHist = function (indstart, objetsInterm, nbObj) {
  var pointeurs = []
  var noms = []
  // var masked = []; // Contiendra l'état de masquage de chaque objet. Il doit être mémorisé
  var maskedNames = [] // Contiendra l'état de masquage du nom de chaque point ou droite
  // car lors du clignotement des objets en cours, leur statut peut changer, masqué ou non
  for (var i = indstart; i <= nbObj; i++) {
    var el = this.get(i)
    if ((!el.estElementIntermediaire() || objetsInterm) && el.estVisibleDansHist()) {
      pointeurs.push(el)
      var info = el.info()
      // if (el.estElementIntermediaire() && el.getNatureCalcul().isNotZero()) info = "*" + info;
      noms.push(info)
      // masked.push(el.estDeNature(NatObj.NTtObj) ? el.masque : null);
      maskedNames.push(el.estDeNature(NatObj.NObjNommable) ? el.nomMasque : null)
    }
  }
  return { pointeurs: pointeurs, noms: noms, namemaskstate: maskedNames }
}

CListeObjets.prototype.contientDeriveeDe = function (fonc) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNatureCalcul(NatCal.NDerivee) && !elb.estElementIntermediaire()) {
      if (elb.fonctionAssociee === fonc) return true
    }
  }
  return false
}

CListeObjets.prototype.listeFonctionsReellesSansDerivees = function (indmax, fonctionARajouter) {
  var pointeurs = []
  var noms = []
  var indfin = indmax === -1 ? this.longueur() - 1 : indmax
  for (var i = 0; i <= indfin; i++) {
    var el = this.get(i)
    if (el.estDeNatureCalcul(NatCal.NFoncR1Var) && !el.estElementIntermediaire()) {
      if ((!this.contientDeriveeDe(el) && el.calcul.deriveePossible(0)) || (el === fonctionARajouter)) {
        pointeurs.push(el)
        noms.push(el.getNom())
      }
    }
  }
  return { pointeurs: pointeurs, noms: noms }
}

CListeObjets.prototype.detruitDernierObjet = function () {
  var ind = this.longueur() - 1
  if (ind >= 0) {
    this.remove(ind)
  }
}

/**
 * Fonction retirant l'objet el de la liste
 * @param el
 */
CListeObjets.prototype.removeObject = function (el) {
  var ind = this.indexOf(el)
  if (ind !== -1) this.col.splice(ind, 1)
}

CListeObjets.prototype.removeByInd = function (ind) {
  this.col.splice(ind, 1)
}

/**
 * Fonction retirant l'objet el de la liste sans utiliser this.get
 * Utilisé dans la reclassement d'objet
 * @param el
 */
CListeObjets.prototype.removeObj = function (el) {
  for (var i = 0; i < this.longueur(); i++) {
    if (this.col[i] === el) this.col.splice(i, 1)
  }
}

/**
 * Fonction retirant de la liste l'objet el
 * @param el
 */
CListeObjets.prototype.detruitObjet = function (el) {
  var ind = this.indexOf(el)
  if (ind >= 0) {
    this.remove(ind)
  }
}

/**
 * Fonction insérant l'objet el à l'index index
 * A noter qu'après appel à cette fontion il faut appeler updateindexes
 * @param index
 * @param elb
 */
CListeObjets.prototype.insert = function (index, elb) {
  if (elb.estDeNatureCalcul(NatCal.NMesureLongueur) && (this.pointeurLongueurUnite === null)) this.pointeurLongueurUnite = elb
  this.col.splice(index, 0, elb)
}

/**
 * Procedure utilisée lors de la création de la liaison entre un point libre
 * et un objet dans le cas où le point libre a été créé avant l'objet. Il faut
 * alors décaler (du dernier au premier) tous les objets créés entre le point
 * libre d'indice IndObj1 et l'objet d'indice indObj2 auquel il faut le lier
 */
/*
CListeObjets.prototype.decaleDependants = function(indObj1, indObj2) {
  var indiceObjet2, indiceDebut;
  var el2 = this.get(indObj2);
  if (el2.estElementFinal) {
    indiceDebut = this.indexOf(el2.impProto) - 1;
    indiceObjet2 = this.indexOf(el2.impProto.dernierObjetFinal());
  }
  else {
    indiceDebut = indObj2 - 1;
    indiceObjet2 = indObj2;
  }
  var objet1 = this.get(indObj1);
  var i = indiceDebut;
  while (i >= indObj1) {
    var element = this.get(i);
    if (element.appartientABlocDependantPourReclassement(objet1)) {
      if (indiceObjet2 === this.longueur() - 1) this.add(element);
      else this.insert(indiceObjet2 + 1, element);
      this.removeByInd(i);
      indiceObjet2--;
      i--;
      // Si l'objet qu'on vient de reclasser est le dernier objet final d'une
      // implémentation de construction
      // il faut recoller le corps de la construction avec lui
      // Modifié version 5.3 : Si element est un objet final ou intermédiaire de construction
      // il faut décaler tout le bloc de la contruction (il peut pour certaines anciennes figures
      // rester des objets intermédiaires ne servant plus
      // if (element.estElementFinal) {
      if (element.impProto !== null) {
        var imp = element.impProto;
        // nb = imp.nbFinaux + imp.nbIntermediaires; // Modifié version 5.3
        var nb = element.index - imp.index;
        for (var k = 0; k < nb; k++) {
          var el1 = this.get(i);
          this.insert(indiceObjet2 + 1, el1);
          this.removeByInd(i);
          indiceObjet2--;
          i--;
        }
      }
    } else {
      // Modifié version 5.3 : Si element est un objet final ou intermédiaire de construction
      // il faut décaler tout le bloc de la contruction (il peut pour certaines anciennes figures
      // rester des objets intermédiaires ne servant plus
      // if (element.estElementFinal) {
      if (element.impProto !== null) {
        // Il ne faut pas désolidariser le dernier élément final de son
        // implémentation de prototype
        imp = element.impProto;
        // var nb = imp.nbFinaux + imp.nbIntermediaires + 1; Modifié version 5.3
        nb = element.index - imp.index + 1;
        i -= nb;
      }
      else i--;
    }
  }
  // Ajout version 4.8.0
  this.updateIndexes();
  //
}
*/
CListeObjets.prototype.decaleDependants = function (indObj1, indObj2) {
  var indiceObjet2, indiceDebut, imp, nb
  var el2 = this.get(indObj2)
  if (el2.estElementFinal) {
    indiceDebut = this.indexOf(el2.impProto) - 1
    indiceObjet2 = this.indexOf(el2.impProto.dernierObjetFinal())
  } else {
    indiceDebut = indObj2 - 1
    indiceObjet2 = indObj2
  }
  var objet1 = this.get(indObj1)
  var i = indiceDebut
  while (i >= indObj1) {
    var element = this.get(i)
    if (element.appartientABlocDependantPourReclassement(objet1)) {
      if (indiceObjet2 === this.longueur() - 1) this.add(element)
      else this.insert(indiceObjet2 + 1, element)
      this.removeByInd(i)
      indiceObjet2--
      i--
      // Si l'objet qu'on vient de reclasser est le dernier objet final d'une
      // implémentation de construction
      // il aut recoller lo corps de la construction avec lui
      if (element.estElementFinal) {
        imp = element.impProto
        nb = imp.nbFinaux + imp.nbIntermediaires
        for (var k = 0; k < nb; k++) {
          var el1 = this.get(i)
          this.insert(indiceObjet2 + 1, el1)
          this.removeByInd(i)
          indiceObjet2--
          i--
        }
      }
    } else {
      if (element.estElementFinal) {
        // Il ne faut pas désolidariser le dernier élément final de son
        // implémentation de prototype
        imp = element.impProto
        nb = imp.nbFinaux + imp.nbIntermediaires + 1
        i -= nb
      } else { i-- }
    }
  }
  // Ajout version 4.8.0
  this.updateIndexes()
  //
}

/**
 * Fonction recherchant si la liste contient une transformation équivalente à la transformation trans
 * Si oui renvoie un pointeur sur cette transformation
 * Si non, renvoir null
 * @param trans
 */
CListeObjets.prototype.transformationConfondueAvec = function (trans) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NTransformation)) {
      if (elb.confonduAvec(trans)) return elb
    }
  }
  return null
}

/**
 * Fonction ajoutant à this les objets graphiques de list qui sont de nature nature, sont visibles, ne sont pas des objets
 * intermédiaitres de construction et qui dépendent de el
 * @param {CListeObjets} list
 * @param {NatObj} nature
 * @param el L'objet dont les objets ajoutés doivent dépendre
 * @param {boolean} bOnlySurfLieuObj  si true, pour les surfaces, ne les rajoute que si elles peuvent générer un lieu d'objets
 * @returns {undefined}
 */
CListeObjets.prototype.ajouteObjetsParNatureDependantDe = function (list, nature, el, bOnlySurfLieuObj) {
  for (var i = 0; i < list.col.length; i++) {
    var elb = list.get(i)
    var elbok = elb.estDeNature(nature) && !elb.masque && !elb.estElementIntermediaire() && elb.depDe(el)
    if (bOnlySurfLieuObj) elbok = elbok && (!elb.estDeNature(NatObj.NSurface) || elb.peutGenererLieuObjet())
    if (elbok) this.add(elb)
  }
}

CListeObjets.prototype.metAJourParNatureObjet = function (nat) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(nat)) elb.metAJour()
  }
}

/**
 * Fonction renvoyant true si la liste contient au moins un objet qui dépend
 * des positions générées pas les déplacements du point lié point lié
 *
 * @param pointLie
 * @returns {boolean}
 */

CListeObjets.prototype.contientObjetGenereParPointLie = function (pointLie) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estGenereParPointLie(pointLie)) return true
  }
  return false
}

/**
 * Fonction ajoutant à this les éléments de list de nature graphique nature qui ne sont pas masqués
 * @param {type} list
 * @param {type} nature
 * @returns {undefined}
 */
CListeObjets.prototype.ajouteObjetsParNatureNonMasques = function (list, nature) {
  for (var i = 0; i < list.longueur(); i++) {
    var el = list.get(i)
    if (!el.masque && el.estDeNature(nature)) this.add(el)
  }
}

/**
 * Fonction renvoyant un pointeur sur la valeur réelle ou complexe de nom nomValeur.
 * Si indiceMaxi vaut -1 ou est absent la recherche se fait jusqu'à la fin de la liste.
 * Les éléments intermédiares de construction sont sautés.
 * Sinon, si l'élément est trouév mais son indice supérieur à indiceMaix,
 * definiApres.getValue() renvoie true.
 * Si l'élément n'est pas trouvé, rencovie null.
 * @param {String} nomValeur
 * @param {number} indiceMaxi
 * @param {Pointeur} definiApres
 * @returns {CElementBase}
 */
CListeObjets.prototype.pointeurValeurReelleOuComplexe = function (nomValeur, indiceMaxi, definiApres) {
  var defap
  if (arguments.length <= 2) defap = new Pointeur()
  else defap = definiApres
  if (arguments.length === 1) indiceMaxi = this.longueur() - 1
  else if (indiceMaxi === -1) indiceMaxi = this.col.longueur() - 1
  defap.setValue(false)
  var i = 0
  var elb = null
  var trouve = false
  while ((!(trouve)) && (i <= indiceMaxi)) {
    elb = this.get(i)
    if (!elb.estElementIntermediaire() && elb.estDeNatureCalcul(NatCal.NTteValROuC)) {
      if (elb.chaineEgaleANom(nomValeur)) trouve = true
      else i++
    } else i++
  }
  if (trouve) return elb
  else {
    i = indiceMaxi + 1
    while (!trouve && (i < this.longueur())) {
      elb = this.get(i)
      if (elb.estDeNatureCalcul(NatCal.NTteValROuC)) {
        if (elb.chaineEgaleANom(nomValeur)) trouve = true
        else i++
      } else i++
    }
    if (trouve) defap.setValue(true)
    return null
  }
}

/**
 * Fonction renvoyant le nombre d'objets de la liste dépendant de pt
 * @param {CElementBase} pt
 * @returns {number}
 */
CListeObjets.prototype.nombreDependants = function (pt) {
  var res = 0
  for (var i = 0; i < this.col.length; i++) {
    if (this.get(i).depDe(pt)) res++
  }
  return res
}

/**
 * Retire de la liste les n derniers éléments.
 * @param {type} n
 * @returns {undefined}
 */
CListeObjets.prototype.retireNDerniersElements = function (n) {
  for (var i = 0; i < n; i++) this.col.pop()
}

/**
 * Fonction renvoyant le nombre d'objets de type calcul compatible avec nat
 * @param nat La nature de calcul recherchée
 * @param binterm Si true on recherche aussi dans les objets intermédiaires de construction. false si paramètre absent.
 * @returns {number}
 */

CListeObjets.prototype.nombreObjetsCalcul = function (nat, binterm = false) {
  var nb = 0
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNatureCalcul(nat) && (binterm || !el.estElementIntermediaire())) nb++
  }
  return nb
}

CListeObjets.prototype.utiliseLongueurUnite = function () {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.utiliseLongueurUnite()) return true
  }
  return false
}

/**
 * Fonction renvoyant un pointeur vers le premier objet de classe className qui soit confondu avec obj
 * Renvoie null si aucun élément n'est trouvé
 * @param className
 * @param obj
 * @returns {*}
 */
CListeObjets.confonduAvec = function (className, obj) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (!el.estElementIntermediaire() && (el.className === className) && el.confonduAvec(obj)) return el
  }
  return null
}

/**
 * Fonction renvoyant null si la liste ne contient pas de point image de pt
 * par la transformation transf et sinon un pointeur sur ce point image.
 * @param {CPt} pt
 * @param {CTransformation} transf
 * @returns {CPointImage}
 */
CListeObjets.prototype.pointImageDePar = function (pt, transf) {
  for (var i = 0; i < this.col.length; i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NPoint)) {
      if (elb.estPointImage()) {
        if ((elb.transformation === transf) && (elb.antecedent === pt)) return elb
      }
    }
  }
  return null
}

// Abandonné
/*
CListeObjets.prototype.metAJourPourCreation = function () {
  var i, elb;
  for (i = 0; i <= this.longueur(); i++) {
    elb = this.get(i);
    elb.metAjourPourCreation();
  }
};
*/

CListeObjets.prototype.insereElement = function (el, indice) {
  this.col.splice(indice, 0, el)
}

CListeObjets.prototype.removegElements = function (svg, bMemeInterm = false, indStart = 0, indMax = null) {
  var indFin = (indMax === null) ? this.longueur() - 1 : indMax
  for (var i = indStart; i <= indFin; i++) {
    var el = this.get(i)
    try {
      if ((!el.estElementIntermediaire() || bMemeInterm) && el.estDeNature(NatObj.NTtObj)) {
        svg.removeChild(el.g)
        el.g = null
        if ((el.estDeNature(NatObj.NObjNommable) || (el.estDeNature(NatObj.NObjetDuplique))) && (el.gname !== null)) {
          svg.removeChild(el.gname)
          el.gname = null
        } else if (el.estDeNature(NatObj.NEditeurFormule) && !el.masque && el.affichageFormule && el.glatex) {
          // Pour les éditeurs de formules avec affichage de la formule il faut aussi retirer l'affichage LaTeX correspondant
          svg.removeChild(el.glatex)
        }
      }
    } catch (e) {
      el.g = null
      if ((el.estDeNature(NatObj.NObjNommable) || (el.estDeNature(NatObj.NObjetDuplique))) && (el.gname !== null)) el.gname = null
    }
  }
}

CListeObjets.prototype.nombreImagesParTransformation = function (transf) {
  var ind = transf.index
  var res = 0
  for (var i = ind + 1; i < this.longueur(); i++) {
    var elb = this.get(i)
    var elb2 = elb.antecedentDirect()
    if ((elb2 !== elb) && (elb2 === transf)) res++
  }
  return res
}

/**
 * Fonctions envoyant le nombre d'imagespar la tansformation transf autres que exclu
 * @param transf
 * @param exclu
 * @returns {number}
 */
CListeObjets.prototype.nombreImagesParTransformationNonDepDe = function (transf, exclu) {
  // var ind = indexOf(transf);
  var ind = transf.index
  var res = 0
  for (var i = ind + 1; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (!elb.depDe(exclu)) {
      var elb2 = elb.antecedentDirect()
      // if ((elb2 != elb) && (elb2.getNature() == NatObj.NTransformation) && (elb2 == transf))
      if ((elb2 !== elb) && (elb2 === transf)) res++
    }
  }
  return res
}

/*
CListeObjets.prototype.detruitDependants = function (pt, svg) {
  // Ajout version 3.4.2
  this.initialiseDependances();
  var existeImplementationsProtoOrphelines = false;
  var index = this.col.length - 1;
  while (index >= 0) {
    var elb = this.get(index);
    if (elb.depDe(pt)) {
      if (elb === this.pointeurLongueurUnite) this.pointeurLongueurUnite = null;
      if (elb.estElementFinal) {
        elb.impProto.nbFinaux--;
        elb.impProto.determineNombreObjetsIntermediaires();
        existeImplementationsProtoOrphelines = existeImplementationsProtoOrphelines
          || (elb.impProto.nbFinaux === 0);
      }
      // Ligne suivante modifié pour simplification
      // this.remove(elb.index); // Attention : ce remove(CObject obj) est redéfini pour détruire aussi le composant MtgFormulaEditor
      this.remove(index); // Attention : ce remove(CObject obj) est redéfini pour détruire aussi le composant MtgFormulaEditor
      if (elb.estDeNature(NatObj.NTtObj)) elb.removegElement(svg); // On retire le gElement qui représente l'objet
      // associé à un CEditeurFormule
    }
    if (elb === pt) break;
    index--;
  }
  if (existeImplementationsProtoOrphelines) this.retireImplementationsProtoOrphelines(svg);
  this.updateIndexes();
};
*/
/**
 * Fonction retirant de la liste les objets qui dépendent de pt
 * Nommée retireDependants dans la version Java
 * @param {type} pt
 * @param svg Le svg contenant la figure
 * @param {boolean} bRemovegElements Si true en retire du SVG les g Elements de chaque objet détruit
 * Ce parramètre sera falase quand on détruit un objet dans l'historique
 * @returns {undefined}
 */

CListeObjets.prototype.detruitDependants = function (pt, svg, bRemovegElements = true) {
  // Ajout version 3.4.2
  this.initialiseDependances()
  var existeImplementationsProtoATraiter = false
  var index = this.col.length - 1
  while (index >= 0) {
    var elb = this.get(index)
    if (elb.depDe(pt) || ((elb.impProto !== null) && elb.impProto.depDe(pt))) {
      if (elb === this.pointeurLongueurUnite) this.pointeurLongueurUnite = null
      var impProto = elb.impProto
      if (impProto !== null) {
        existeImplementationsProtoATraiter = true
        if (elb.estElementFinal) {
          impProto.nbFinaux--
        } else {
          impProto.nbIntermediaires--
        }
      }
      // Ligne suivante modifié pour simplification
      // this.remove(elb.index); // Attention : ce remove(CObject obj) est redéfini pour détruire aussi le composant MtgFormulaEditor
      this.remove(index) // Attention : ce remove(CObject obj) est redéfini pour détruire aussi le composant MtgFormulaEditor
      if (bRemovegElements && elb.estDeNature(NatObj.NTtObj)) elb.removegElement(svg) // On retire le gElement qui représente l'objet
      // associé à un CEditeurFormule
    }
    if (elb === pt) break
    index--
  }
  if (existeImplementationsProtoATraiter) this.traiteImplementationsProto(svg)
  this.updateIndexes()
}

/**
 * Fonction retirant de la liste les CImplementationProto qui sont orphelines (tous
 * les éléments finaux de la construction ont été détruits) ou retirant de ces CImplementationProto
 * les objets intermédiaires de fin qui ne sont plus utiles (arrive quand l'utilisateur a supprimé
 * certains objets finaux.
 * @returns {undefined}
 */
CListeObjets.prototype.traiteImplementationsProto = function (svg) {
  // for (var i = 0; i < this.longueur(); i++) {
  var i = 0; var j
  while (i < this.longueur()) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NImpProto)) {
      if (elb.nbFinaux === 0) {
        // this.detruitDependants(elb, svg);
        // i = 0; // On recommence depuis le début
        for (j = 0; j <= elb.nbIntermediaires; j++) this.remove(i)
      } else {
        var deb = i + elb.nbFinaux + elb.nbIntermediaires
        if (this.get(deb).estElementIntermediaire()) {
          // Si le dernier élément d'une CImplémentationProto est un objet intermédiaire
          // Il faut détruire tous les objets intermédiaires finaux.
          for (j = deb; j > i; j--) {
            if (this.get(j).estElementIntermediaire()) {
              this.remove(j)
              elb.nbIntermediaires--
            } else break
          }
        }
        i += elb.nbFinaux + elb.nbIntermediaires + 1
      }
    } else i++
  }
}

/**
 * Fonction renvoyant le premier objet de la liste qui existe (si bMustExist = true) et qui est un repère
 * qui n'est pas un objet intermédiaire de construction.
 * @param bMustExist Si true le repère doit exister, sinon il peut ne pas exister (utiliser pour la création
 * d'une figure avec papier millimétré)
 * @returns {*}
 */
CListeObjets.prototype.premierRepVis = function (bMustExist = true) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    // Corrigé version 6.3.0
    // if ((elb.getNatureCalcul() === NatCal.NRepere) && !elb.estElementIntermediaire()) return elb;
    if ((elb.getNatureCalcul() === NatCal.NRepere) && (bMustExist ? elb.existe : true) && !elb.estElementIntermediaire()) return elb
  }
  return null
}

CListeObjets.prototype.ajouteRepereOrthonormal = function (dimf, quadrillageHor,
  quadrillageVer, pointille, nomO, nomI, nomJ, nomVecteuri,
  nomVecteurj, originex, originey, unitex, unitey, nomsIJmasques) {
  // var stfp = StyleTrait.stfp(this);
  var stfc = StyleTrait.stfc(this)
  var petitRond = MotifPoint.petitRond
  var res = dimf.y / 20 // Arbitraire version js
  var absnom = CDroite.abscisseNomParDefaut
  var bl = Color.black
  // res contient la résolution de l'écran en points par cm
  var o = new CPointBase(this, null, false, bl, false, -12, 0, false, nomO, 14, petitRond,
    false, true, dimf.x / 2, dimf.y / 2)
  this.add(o)
  // Ensuite une droite horizontale passant par ce point cachée
  var ptdh = new CDroiteDirectionFixe(this, null, false, bl, false, 0, 0, true, '', 14, stfc,
    absnom, o, true, 1)
  this.add(ptdh)
  // On ajoute un point nommé lié à la droite horizontale
  var i = new CPointLieDroite(this, null, false, bl, nomsIJmasques, -6, 0, false, nomI, 14, petitRond,
    false, true, res, ptdh)
  this.add(i)
  // Une droite représentant l'axe des abscisses.
  var ptd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 16, stfc, absnom, o, i)
  this.add(ptd)
  // On crée une perpendiculaire
  var perp = new CDroitePerpendiculaire(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, ptd)
  this.add(perp)
  // On crée un cercle de centre O et passant par I
  var cercle = new CCercleOA(this, null, false, bl, true, stfc, o, i)
  this.add(cercle)
  // On crée l'intersection de ce cercle avec la perpendiculaire
  var inter = new CIntDroiteCercle(this, null, false, perp, cercle)
  this.add(inter)
  // Puis deux points représentant les deux points d'intersection
  // Le premier point est caché sans nom
  var k = new CPointLieBipoint(this, null, false, bl, false, 0, 0, true, '', 14,
    petitRond, false, inter, 1)
  this.add(k)
  var j = new CPointLieBipoint(this, null, false, bl, nomsIJmasques, -12, -4, false, nomJ, 14,
    petitRond, false, inter, 2)
  this.add(j)
  // puis le repère
  this.finitRep(o, i, j, nomVecteuri, nomVecteurj, originex, originey, quadrillageVer, quadrillageHor,
    pointille, unitex, unitey)
}

CListeObjets.prototype.ajouteRepereOrthogonal = function (dimf, quadrillageHor,
  quadrillageVer, pointille, nomO, nomI, nomJ, nomVecteuri,
  nomVecteurj, originex, originey, unitex, unitey, nomsIJmasques) {
  // var stfp = StyleTrait.stfp(this);
  var stfc = StyleTrait.stfc(this)
  var petitRond = MotifPoint.petitRond
  var resx = dimf.x / 20 // Arbitraire version js
  var resy = dimf.y / 15 // Arbitraire version js
  var absnom = CDroite.abscisseNomParDefaut
  var bl = Color.black
  // res contient la résolution de l'écran en points par cm
  var o = new CPointBase(this, null, false, bl, false, -12, 0, false, nomO, 14, petitRond,
    false, true, dimf.x / 2, dimf.y / 2)
  this.add(o)
  // Ensuite une droite horizontale passant par ce point cachée
  var ptdh = new CDroiteDirectionFixe(this, null, false, bl, false, 0, 0, true, '', 14, stfc,
    absnom, o, true, 1)
  this.add(ptdh)
  // On ajoute un point nommé lié à la droite horizontale
  var i = new CPointLieDroite(this, null, false, bl, nomsIJmasques, -6, 0, false, nomI, 14, petitRond,
    false, true, resx, ptdh)
  this.add(i)
  // Une droite représentant l'axe des abscisses.
  var ptd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, i)
  this.add(ptd)
  // On crée une perpendiculaire
  var perp = new CDroitePerpendiculaire(this, null, false, bl, false, 0, 0, true, '', 14, stfc, absnom, o, ptdh)
  this.add(perp)
  var j = new CPointLieDroite(this, null, false, bl, nomsIJmasques, -11, 0, false, nomJ, 14, petitRond,
    false, true, -resy, perp)
  // this, null, false, bl, false, -11, 0, false, "", 14, stfc, false, true, absnom, perp)
  this.add(j)
  var axeOrd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, j)
  this.add(axeOrd)
  // puis le repère
  this.finitRep(o, i, j, nomVecteuri, nomVecteurj, originex, originey, quadrillageVer, quadrillageHor,
    pointille, unitex, unitey)
}

CListeObjets.prototype.ajouteRepereOblique = function (dimf, quadrillageHor,
  quadrillageVer, pointille, nomO, nomI, nomJ, nomVecteuri,
  nomVecteurj, originex, originey, unitex, unitey, nomsIJmasques) {
  // var stfp = StyleTrait.stfp(this);
  var stfc = StyleTrait.stfc(this)
  var petitRond = MotifPoint.petitRond
  var resx = dimf.x / 20 // Arbitraire version js
  var resy = dimf.y / 15 // Arbitraire version js
  var absnom = CDroite.abscisseNomParDefaut
  var bl = Color.black
  // res contient la résolution de l'écran en points par cm
  var o = new CPointBase(this, null, false, bl, false, -17, 0, false, nomO, 14, petitRond,
    false, true, dimf.x / 2, dimf.y / 2)
  this.add(o)
  // Ensuite une droite horizontale passant par ce point cachée
  var ptdh = new CDroiteDirectionFixe(this, null, false, bl, false, 0, 0, true, '', 14, stfc,
    absnom, o, true, 1)
  this.add(ptdh)
  // On ajoute un point nommé lié à la droite horizontale
  var i = new CPointLieDroite(this, null, false, bl, nomsIJmasques, -10, 0, false, nomI, 14, petitRond,
    false, true, resx, ptdh)
  this.add(i)
  // Une droite représentant l'axe des abscisses.
  var ptd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, i)
  this.add(ptd)
  var j = new CPointBase(this, null, false, bl, nomsIJmasques, -11, -4, false, nomJ, 14, petitRond,
    false, true, dimf.x / 2 + resx / 4, dimf.y / 2 - resy / 2)
  this.add(j)
  var axeOrd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, j)
  this.add(axeOrd)
  // puis le repère
  this.finitRep(o, i, j, nomVecteuri, nomVecteurj, originex, originey, quadrillageVer, quadrillageHor,
    pointille, unitex, unitey)
}

CListeObjets.prototype.ajouteRepereObliqueNorme = function (dimf, quadrillageHor,
  quadrillageVer, pointille, nomO, nomI, nomJ, nomVecteuri,
  nomVecteurj, originex, originey, unitex, unitey, nomsIJmasques) {
  // var stfp = StyleTrait.stfp(this);
  var stfc = StyleTrait.stfc(this)
  var petitRond = MotifPoint.petitRond
  var resx = dimf.x / 20 // Arbitraire version js
  var absnom = CDroite.abscisseNomParDefaut
  var bl = Color.black
  // res contient la résolution de l'écran en points par cm
  var o = new CPointBase(this, null, false, bl, false, -17, 0, false, nomO, 14, petitRond,
    false, true, dimf.x / 2, dimf.y / 2)
  this.add(o)
  // Ensuite une droite horizontale passant par ce point cachée
  var ptdh = new CDroiteDirectionFixe(this, null, false, bl, false, 0, 0, true, '', 14, stfc,
    absnom, o, true, 1)
  this.add(ptdh)
  // On ajoute un point nommé lié à la droite horizontale
  var i = new CPointLieDroite(this, null, false, bl, nomsIJmasques, -10, 0, false, nomI, 14, petitRond,
    false, true, resx, ptdh)
  this.add(i)
  // Une droite représentant l'axe des abscisses.
  var ptd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, i)
  this.add(ptd)
  // On crée un cercle de centre O et passant par I
  var cercle = new CCercleOA(this, null, false, bl, true, stfc, o, i)
  this.add(cercle)
  var j = new CPointLieCercle(this, null, false, bl, nomsIJmasques, -12, 0, false, nomJ, 14, MotifPoint.petitRond, false, true, Math.PI / 3, cercle)
  this.add(j)
  var axeOrd = new CDroiteAB(this, null, false, bl, false, 0, 0, false, '', 14, stfc, absnom, o, j)
  this.add(axeOrd)
  // puis le repère
  this.finitRep(o, i, j, nomVecteuri, nomVecteurj, originex, originey, quadrillageVer, quadrillageHor,
    pointille, unitex, unitey)
}

/**
 * Fonction finissnat la création d'un repère ajouté à une nnouvelle figure
 * @param o L'origine
 * @param i Le point de coordonnées (1;0)
 * @param j Le point de coordonnées (1;0)
 * @param nomVecteuri Le nom du vecteur i ("" si pas de vecteur)
 * @param nomVecteurj Le nom du vecteur j ("" si pas de vecteur)
 * @param originex L'abscisse à l'origine
 * @param originey L'ordonnée à l'origine
 * @param quadrillageVer true si quadriallage vertical
 * @param quadrillageHor true si quadrillage horizontal
 * @param pointille true si pointillés
 * @param unitex L'unité sur l'axe des x
 * @param unitey L'unité sur l'axe des y
 */
CListeObjets.prototype.finitRep = function (o, i, j, nomVecteuri, nomVecteurj, originex, originey,
  quadrillageVer, quadrillageHor, pointille, unitex, unitey) {
  var lon
  var bl = Color.black
  // var stfp = StyleTrait.stfp(this);
  var stfc = StyleTrait.stfc(this)

  var rep = new CRepere(this, null, false, (pointille && !quadrillageHor && !quadrillageVer) ? new Color(164, 164, 164)
    : new Color(230, 230, 230), false, stfc, o, i, j, originex, originey, quadrillageVer, quadrillageHor, pointille, unitex, unitey)
  this.add(rep)
  // On crée la longueur OI qu'on établit comme longueur nité de la liste
  // this, null, false, O, I);
  var unitexrep = new CUnitexRep(this, null, false, 'unit', rep)
  this.add(unitexrep)
  var hom = new CHomothetie(this, null, false, o, new CValeur(this, new COperation(this, new CConstante(this, 1),
    new CResultatValeur(this, unitexrep), Ope.Divi)))
  this.add(hom)
  var ptim = new CPointImage(this, null, false, bl, false, 0, 0, true, 'W"', 16, MotifPoint.rond, false, i, hom)
  this.add(ptim)
  lon = new CLongueur(this, null, false, o, ptim)
  this.pointeurLongueurUnite = lon
  this.add(lon)
  if (nomVecteuri.length !== 0) {
    var vecti = new CVecteur(this, null, false, bl, false, stfc, o, i, StyleFleche.FlecheCourtePleine)
    this.add(vecti)
    var commi = new CLatex(this, null, false, bl, 0, 0, -10, 2, false, i, 16, StyleEncadrement.Sans, false,
      Color.white, CAffLiePt.alignHorRight,
      CAffLiePt.alignVerTop, '\\vec{' + nomVecteuri + '}')
    // commi.creeFormule();
    // commi.setReady4MathJax();
    this.add(commi)
  }
  if (nomVecteurj.length !== 0) {
    var vectj = new CVecteur(this, null, false, bl, false, stfc, o, j, StyleFleche.FlecheCourtePleine)
    this.add(vectj)
    var commj = new CLatex(this, null, false, bl, 0, 0, -8, 5, false, j, 16, StyleEncadrement.Sans, false,
      Color.white, CAffLiePt.alignHorRight,
      CAffLiePt.alignVerTop, '\\vec{' + nomVecteurj + '}')
    //  commj.creeFormule();
    // commj.setReady4MathJax();
    this.add(commj)
  }
}

/**
 * Fonction renvoyant le premier objet de nature calcul nat qui n'est pas un objet intermédiaire de construciton
 * @param nat
 * @returns {*}
 */

CListeObjets.prototype.premierParNatCal = function (nat) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if ((elb.estDeNatureCalcul(nat)) && !elb.estElementIntermediaire()) return elb
  }
  return null
}

/**
 * Fonction renvoyant l'objet d'indice index (l'objet n° index - 1) de nature nat
 * @param nat
 * @param index
 * @param bInterm Si true on cherche aussi dans les objets intermédiaires de construction
 * @returns {*}
 */
CListeObjets.prototype.premierParNat = function (nat, index = 0, bInterm = false) {
  var ind = 0
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if ((elb.estDeNature(nat)) && (bInterm || !elb.estElementIntermediaire())) {
      if (ind === index) return elb
      else ind++
    }
  }
  return null
}

CListeObjets.prototype.ajouteConstantePi = function () {
  var ptCalc = new CCalcConst(this, null, false)
  ptCalc.nomCalcul = 'pi'
  ptCalc.chaineCalcul = '3.14159265358979323846'
  ptCalc.creeCalcul()
  ptCalc.calculeValeurConstante()
  this.add(ptCalc)
}

/**
 * Renvoie true si la liste contient un point dont les coordonnées sont
 * "presque" égales à x et y et qui soit sur les el1 et el2
 * Dans la version JavaScript el1 et el2 peuvent pointer indifféremmen sur une droite ou un cercle
 * Si oui renvoit un pointeur sur ce point, sinon renvoie null
 * @param x
 * @param y
 * @param el1
 * @param el2
 * @param bEstExercice true si on est en mode exercice de construction Dans ce cas on n'utilise pas de technique intelligente
 * d'appartenance à el1 et el2 et on considère que le point existe déjà s'il est très proche d'un point déjà créé.
 * @returns {boolean}
 */
CListeObjets.prototype.existePointConfonduPourIntersection = function (x, y, el1, el2, bEstExercice) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NTtPoint)) {
      // Modification version 3.9 : Si l'intersection a déjà été créée pour un objet intermédiaire de construction
      // on crée de nouveau l'objet
      if (!elb.estElementIntermediaire() && elb.existe) {
        var presqueEgaux = kernel.zero(elb.x - x) && kernel.zero(elb.y - y)
        if (bEstExercice) {
          if (presqueEgaux) return elb
        } else {
          if (presqueEgaux && elb.appartientParDefinition(el1) && elb.appartientParDefinition(el2)) {
            return elb
          }
        }
      }
    }
  }
  return null
}

/**
 * Etudie l'intersection de el1 et el2 a déjà été créé.
 * si el1 et el2 sont deux droites, renvoie true si le point d'intersection
 * existe déjà dans la figure.
 * S'il s'agit d'une droite et un cercle ou de deux cercles, dejaCree.getValue()
 * renvoie ttrue quand les deux points d'intersection ont déjà été créés et false sinon.
 * et si un des deux points d'intersection a déjà été créé, renvoie un
 * pointeur sur ce point. Sinon renvoit null.
 * @param {boolean} bEstExercice  true si on est en mode exercice de construction
 * @param {CElementGraphique} el1  droite ou cercle
 * @param {CElementGraphique} el2  droite ou cercle
 * @param {Pointeur} dejaCree  Renvoie true quand les deux points d'intersection
 * ont déjà été créés et false sinon.
 * @returns {CPointAncetre}
 */

CListeObjets.prototype.pointIntersectionDejaCree = function (bEstExercice, el1, el2, dejaCree) {
  var positionRelative
  var pointInt1 = {}
  if (arguments.length === 3) { // : Cas de deux droites. Renvoie un booléen}
    positionRelative = kernel.intersection(el1.point_x, el1.point_y, el1.vect, el2.point_x,
      el2.point_y, el2.vect, pointInt1)
    if (positionRelative !== PositionDroites.Paralleles) { return this.existePointConfonduPourIntersection(pointInt1.x, pointInt1.y, el1, el2, bEstExercice) } else return null
  } else {
    if (el1.estDeNature(NatObj.NTteDroite) && el2.estDeNature(NatObj.NTtCercle)) {
      var pointInt2 = {}
      dejaCree.setValue(false)
      positionRelative = kernel.intersectionDroiteCercle(el1.point_x, el1.point_y, el1.vect,
        el2.centreX, el2.centreY, el2.rayon, pointInt1, pointInt2)
      var ptPoint1 = this.existePointConfonduPourIntersection(pointInt1.x, pointInt1.y, el1, el2, bEstExercice)
      var ptPoint2 = this.existePointConfonduPourIntersection(pointInt2.x, pointInt2.y, el1, el2, bEstExercice)
      if (positionRelative === PositionDroiteCercle.Secants) {
        dejaCree.setValue((ptPoint1 !== null) && (ptPoint2 !== null))
        if (dejaCree.getValue()) return null
        else {
          if (ptPoint1 !== null) return ptPoint1
          else {
            if (ptPoint2 !== null) return ptPoint2
            else return null
          }
        }
      } else {
        if (positionRelative === PositionDroiteCercle.Tangents) {
          dejaCree.setValue(ptPoint1 !== null)
          if (dejaCree.getValue()) return ptPoint1
          else return null
        } else return null
      }
    } else { // Cas de deux cercles
      pointInt2 = { x: 0, y: 0 }
      dejaCree.setValue(false)
      positionRelative = kernel.intersectionCercleCercle(el1.centreX, el1.centreY, el1.rayon,
        el2.centreX, el2.centreY, el2.rayon, pointInt1, pointInt2)
      ptPoint1 = this.existePointConfonduPourIntersection(pointInt1.x, pointInt1.y, el1, el2, bEstExercice)
      ptPoint2 = this.existePointConfonduPourIntersection(pointInt2.x, pointInt2.y, el1, el2, bEstExercice)
      if (positionRelative === PositionCercleCercle.Secants) {
        dejaCree.setValue((ptPoint1 !== null) && (ptPoint2 !== null))
        if (dejaCree.getValue()) return null
        else {
          if (ptPoint1 !== null) return ptPoint1
          else {
            if (ptPoint2 !== null) return ptPoint2
            else return null
          }
        }
      } else {
        if (positionRelative === PositionCercleCercle.Tangents) {
          dejaCree.setValue(ptPoint1 !== null)
          if (dejaCree.getValue()) return ptPoint1
          else return null
        } else return null
      }
    }
  }
}
/**
 * Fonction renvoyant true si les points pt1 et pt2 sont par définition sur une droite
 * parallèle à droite.
 * @param {CPt} pt1  Le premier point testé.
 * @param {CPt} pt2  Le secondd point testé.
 * @param {CDroiteAncetre} droite
 * @returns {boolean}
 */
CListeObjets.prototype.sontParDefinitionSurParallele = function (pt1, pt2, droite) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NTteDroiteSaufVect)) {
      if (pt1.appartientDroiteParDefinition(elb) && pt2.appartientDroiteParDefinition(elb) &&
        (elb.estParalleleParDefinition(droite) || droite.estParalleleParDefinition(elb))) return true
    }
  }
  return false
}

// Ajout version 6.0
/**
 * Fonction renvoyant true si le point po appartient à une droite parallèle à dte par définition
 * @param po
 * @param dte
 */
CListeObjets.prototype.appDteParParDef = function (po, dte) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NTteDroiteSaufVect)) {
      if (po.appartientDroiteParDefinition(elb) && (dte.estParalleleParDefinition(elb) || elb.estParalleleParDefinition(dte))) return true
    }
  }
  return false
}

CListeObjets.prototype.ajouteLongueurUnite = function (dimf) {
  var stfc = StyleTrait.stfc(this)
  var petitRond = MotifPoint.petitRond
  var res = dimf.y / 20 // Arbitraire version js
  var absnom = CDroite.abscisseNomParDefaut
  var bl = Color.black

  // D'abord un point libre nommé U caché par défaut
  // Changement pour vrsion 3.3 : Le point U est punaisé par défaut et ainsi en zoomant sur la figure il restera visible
  // var ptb = new CPointBase(this, null, false, Couleur.TraduitCouleur(1), false, -10d*k, 4d*k, false, "U",
  //  (int)(k*11), MotifPoint.PetitRond, false, res / 2, res / 2, false);
  var ptb = new CPointBase(this, null, false, bl, false, -10, 4, false, 'U', 14, petitRond, false, false, res / 2, res / 2)
  this.add(ptb)
  // Ensuite une droite horizontale passant par ce point
  // var ptd = new CDroiteDirectionFixe(this, null, false, Couleur.TraduitCouleur(1), false,
  //  0d, 0d, true, "", (int)(k*13), StyleTrait.traitFin, CDroite.abscisseNomParDefaut, ptb, true, 1);
  var ptd = new CDroiteDirectionFixe(this, null, false, bl, false, 0, 0, true, '', 16, stfc, absnom, ptb, true, 1)
  this.add(ptd)
  // On ajoute un point lié à la droite horizontale
  // var ptl = new CPointLieDroite(this, null, false, Couleur.TraduitCouleur(1), false, 3d*k, 4d*k,
  //  false, "V", (int)(k*11), MotifPoint.PetitRond, true, res, ptd, false);
  var ptl = new CPointLieDroite(this, null, false, bl, false, -2, 4, false, 'V', 14, petitRond, false, true, res, ptd)
  this.add(ptl)
  // On crée un segment joignant ces deux points
  // var ptseg = new CSegment(this, null, false, Couleur.TraduitCouleur(1), false, StyleTrait.traitFin,
  //  ptb, ptl);
  var ptseg = new CSegment(this, null, false, bl, false, stfc, ptb, ptl)

  this.add(ptseg)
  // On crée maintenant le milieu de ce segment
  // var ptm = new CMilieu(this, null, false, Couleur.TraduitCouleur(1), false, 0d, 0d, true, "", (int)(k*13),
  //  MotifPoint.PetitRond, ptb, ptl, false);
  var ptm = new CMilieu(this, null, false, bl, false, 0, 3, true, '', 16, petitRond, false, ptb, ptl)
  this.add(ptm)
  // On ajoute un commentaire lié à ce milieu contenant la lettre 1
  // Ligne suivante modifiée version 2.0
  // var ptcom = new CCommentaire(this, null, false, Couleur.TraduitCouleur(1), 0d, 0d, 0d, 6d,
  //  false, ptm, (int)(k*11), StyleEncadrement.Sans, false, documentProprietaire.couleurFond, "1", CAffLiePt.alignHorCent,
  //  CAffLiePt.alignVerTop);
  var com = new CCommentaire(this, null, false, bl, 0, 0, 0, 6, false, ptm, 12, StyleEncadrement.Sans, false,
    Color.white, CAffLiePt.alignHorCent,
    CAffLiePt.alignVerTop, '1')
  this.add(com)
  com.determineDependances()
  // On crée maintenant la longueur unité
  var lon = new CLongueur(this, null, false, ptb, ptl)
  this.add(lon)
  this.pointeurLongueurUnite = lon
}

/**
 * Fonction renvoyant un pointeur sur la droite passant par a et b si elle existe et null sinon
 * @param a {CPt}
 * @param b {CPt}
 * @returns {*}
 */
CListeObjets.prototype.existeDroiteABDefiniePar = function (a, b) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.className === 'CDroiteAB') {
      if (((el.a === a) && (el.b === b)) || ((el.b === a) && (el.a === b))) return el
    }
  }
  return null
}

/**
 * Fonction affectant à tous les svg elements des surfaces de la figure l'opacité opacity
 * @param opacity
 */
CListeObjets.prototype.setOpacity = function (opacity) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNature(NatObj.NSurface) || el.estDeNature(NatObj.NDemiPlan)) el.setOpacity(opacity)
  }
}

CListeObjets.prototype.nomIndispensable = function (el) {
  for (var i = 0; i < this.longueur(); i++) {
    if (this.get(i).nomIndispensable(el)) return true
  }
  return false
}

CListeObjets.prototype.metAJourObjetsDependantDe = function (elb) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.depDe(elb)) el.metAJour()
  }
}

CListeObjets.prototype.premierObjetNomProcheDe = function (typeCherche, x, y, type, listeExclusion) {
  var i, ptel, dis
  // lorsque la liste est vide, aucun objet n'est proche
  if (this.longueur() === 0) return null
  for (i = 0; i < this.longueur(); i++) {
    ptel = this.get(i)
    if ((listeExclusion.indexOf(ptel) === -1) && ptel.estDeNature(typeCherche) && !(ptel.masque || ptel.nomMasque)) {
      dis = ptel.distanceNom(x, y, type === 'touch' ? 32 : 16)
      if (dis === 0) return ptel // On est à l'intérieur de l'affichage du nom de l'objet
    }
  }
  return null // Aucun nom d'objet proche
}

/**
 * Fonction demandant à chaque objet pour lequel c'est nécéssaire de se préparer
 * pour le traitement par MathJax qui sera fait via une fonction de callback.
 * Appelée quand pn utilise l'outil Rideau.
 * @returns {undefined}
 */
CListeObjets.prototype.setReady4MathJaxEvenMasked = function () {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.existe && !el.estElementIntermediaire()) el.setReady4MathJaxEvenMasked()
  }
}

CListeObjets.prototype.updateEvenMasked = function (svg, couleurFond, transparence) {
  this.setReady4MathJaxEvenMasked()
  /* Modifié version 6.4.1
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    MathJax.Hub.Queue([this.callBack, elb, svg, couleurFond, transparence, false])
  }
  */
  const self = this
  for (let i = 0; i < this.longueur(); i++) {
    const elb = this.get(i)
    MathJax.Hub.Queue(function () {
      self.callBack(elb, svg, couleurFond, transparence, false)
    })
  }
}

/**
 * Fonction ajoutant à this les points de la liste listeSource dont l'étatt de masquage est basque
 * @param listeSource
 * @param bmarque
 */
CListeObjets.prototype.ajoutePointsMarquesPourTrace = function (listeSource, bmarque) {
  for (var i = 0; i < listeSource.longueur(); i++) {
    var elb = listeSource.get(i)
    if (elb.estDeNature(NatObj.NTtPoint) && !elb.estElementIntermediaire() && !elb.masque) {
      if (elb.marquePourTrace === bmarque) this.add(elb)
    }
  }
}

CListeObjets.prototype.remplaceObjet = function (oldObj, newObj) {
  var ind = this.indexOf(oldObj)
  this.col[ind] = newObj
  newObj.index = ind
}

/**
 * Fonction ajoutant à this les points mobiles non intermédiaires dont l'état de liberté est égal à libres
 * @param listeSource
 * @param blibres
 */
CListeObjets.prototype.ajoutePointsLibresVisibles = function (listeSource, blibres) {
  for (var i = 0; i < listeSource.longueur(); i++) {
    var elb = listeSource.get(i)
    if (elb.estDeNature(NatObj.NPointMobile) && !elb.estElementIntermediaire()) {
      if (!elb.masque) {
        if (elb.pointLibre === blibres) { this.add(elb) }
      }
    }
  }
}

CListeObjets.prototype.ajoutePointsLiesVisiblesDontDepend = function (listeSource, elb) {
  var indelb = listeSource.indexOf(elb)
  for (var i = 0; i <= indelb; i++) {
    var el = listeSource.get(i)
    if (el.estDeNature(NatObj.NPointLie)) {
      if (!el.masque && elb.depDe(el) && !this.contains(el)) this.add(el)
    }
  }
}

/**
 * Fonction rajoutant à this les objets de list qui sont des affichages :
 * liés à un point si blie ets true
 * non liés à un point si blie est false
 * @param list
 * @param blie
 */
CListeObjets.prototype.ajouteAffichagesLiesAPointVisibles = function (list, blie) {
  for (var i = 0; i < list.longueur(); i++) {
    var el = list.get(i)
    if (!el.estElementFinal && el.estDeNature(NatObj.NAffLieAPoint)) {
      if (!el.masque && (blie ? (el.pointLie !== null) : (el.pointLie === null))) this.add(el)
    }
  }
}

/**
 * Fonction ajoutant à this les points liés non punaisés contenus dans list
 * @param list
 */
CListeObjets.prototype.ajoutePointsLiesNonPun = function (list) {
  var lon = list.longueur()
  for (var i = 0; i < lon; i++) {
    var el = list.get(i)
    if (el.estDeNature(NatObj.NPointLie)) {
      if (!el.masque && el.pointLibre) this.add(el)
    }
  }
}

/**
 * Fonction retirant du body tous les div servant à modifier, incrémenter ou décrémenter une variable
 */
CListeObjets.prototype.removePaneVariables = function (div) {
  for (var i = this.longueur() - 1; i >= 0; i--) {
    var el = this.get(i)
    // Lors des implémentations de proto il peut y avoir des variables ajoutées avec panneau associé
    // mais pas encore créées, et dans ce cas el.div est undefined
    if (el.getNatureCalcul() === NatCal.NVariable && el.dialogueAssocie && el.div) {
      div.removeChild(el.div)
    }
  }
}

CListeObjets.prototype.metAJourSurfacesAyantPourBord = function (lieu) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNature(NatObj.NSurface) && el.aPourBord(lieu)) el.metAJourTableaux()
  }
}

/**
 * Fonction renvoyant le nombre d'objet dont la nature graphique est une des natures
 * contenues dans nat (par un et binaire).
 * @param {Nat} nat
 * @returns {number}
 */
/* Non utilisé pour le moment
 CListeObjets.prototype.nombreObjetsParNature = function(nat) {
 var compt = 0;
 var trouve = false;
 for (var i = 0; (i < this.col.length) && !(trouve); i++) {
 if ( this.get(i).estDeNature(nat)) compt++;
 }
 return compt;
 };
 */
/**
 * Fonction renvoyant le nombre d'objet dont la nature graphique est une des natures
 * contenues dans nat (par un et binaire). Les natures cherchées eoivent être graphiques.
 * @param {Nat} nat
 * @returns {number}
 */

CListeObjets.prototype.nombreObjetsParNatureVisibles = function (nat) {
  var compt = 0
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (!elb.estElementIntermediaire() && elb.estDeNature(nat) && !elb.masque) compt++
  }
  return compt
}

/**
 * Fonction renvoyant :
 * Si blie est true le nombre d'affichages liés à un point visibles
 * Si blie est false, le nombre d'affichages non liés à un point visibles
 * @param blie
 * @returns {number}
 */
CListeObjets.prototype.nombreAffichagesLiesAPointVisibles = function (blie) {
  var res = 0
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NAffLieAPoint)) {
      if (!elb.masque && (blie ? elb.pointLie !== null : elb.pointLie === null)) res++
    }
  }
  return res
}

/**
 * Spécial version mtgApp
 * Remplace dans les CCommentaire et CLatex utilisant des affichages dynamiques dépendant de el ancienNom par nouveauNom
 * @param ancienNom
 * @param nouveauNom
 * @param el l'élément dont le commentaire ou le Clatex doit dépendre pour que le remplacement soit effectué
 */
CListeObjets.prototype.remplaceNomValeurDynamiqueDansCommentairesOuLatexDepDe = function (ancienNom, nouveauNom, el) {
  var i, elb
  for (i = 0; i < this.longueur(); i++) {
    elb = this.get(i)
    if (elb.estDeNature(NatObj.NComouLatex) && elb.depDe(el)) elb.remplaceNomValeurDynamique(ancienNom, nouveauNom)
  }
}

/**
 * Fonction reconstruisant les chaînes de calcul de tous les calculs ou
 * fonctions utilisateur dépendant de el.
 * @returns {undefined}
 */
CListeObjets.prototype.reconstruitChainesCalculDepDe = function (el) {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNatureCalcul(NatCal.NCalcOuFoncNonConstante) && elb.depDe(el)) { elb.reconstruitChaineCalcul() }
  }
}

/**
 * Fonction renvoyant l'indice du premier objet qui ne soit pas une variable
 * ou un calcul constant. Est utilisé pour le reclassement d'objets en début
 * de liste
 * @returns {number}
 */
CListeObjets.prototype.indicePremierElementNonVariable = function () {
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    var nat = elb.getNatureCalcul()
    if ((nat !== NatCal.NVariable) && (elb.className !== 'CCalcConst')) break
  }
  return i
}

/*
CListeObjets.prototype.reclasseVersDebutAvecDependants = function(elb) {
  var el, nb;
  var indiceMiniDebut = this.indicePremierElementNonVariable();
  var indiceItem = this.indexOf(elb);
  if (indiceItem === indiceMiniDebut) return false;
  // On recherche à partir du début de la liste la position
  // du premier item dont elb ne dépend pas
  // On ne commence qu'au deuxième objet car le premier est la constante pi
  var indiceMiniGauche = 1;
  var dependant = true;
  var i = indiceMiniDebut;
  while ((i <= indiceItem) && dependant) {
    el = this.get(i);
    if (el.getNature() === NatObj.NImpProto) {
      // CImplementationProto imp = (CImplementationProto) el;
      dependant = elb.depDe4Rec(el);
      nb = el.nbFinaux + el.nbIntermediaires;
      if (dependant) i += nb + 1;
      else
        indiceMiniGauche = i;
    } else {
      if (elb.depDe4Rec(el))
        i++;
      else {
        dependant = false;
        indiceMiniGauche = i;
      }
    }
  }
  if (dependant) return false; // elb qu'on veut reclasser dépend de tous les objets
                  // précédents
  i = indiceMiniGauche + 1;
  while (i <= indiceItem) {
    el = this.get(i);
    // Il ne faut pas séparer les éléments d'une implémentation de prototype
    if (el.getNature() === NatObj.NImpProto) {
      // CImplementationProto imp = (CImplementationProto) el;
      nb = el.nbFinaux + el.nbIntermediaires + 1;
      if (elb.depDe4Rec(el)) {
        for (var k = 0; k < nb; k++) {
          var el1 = this.get(i + k);
          this.removeByInd(i + k);
          this.insereElement(el1, indiceMiniGauche + k);
        }
        indiceMiniGauche += nb;
        i += nb;
      } else {
        i += nb;
      }
    } else {
      if (elb.depDe4Rec(el)) {
        this.removeByInd(i);
        this.insereElement(el, indiceMiniGauche);
        indiceMiniGauche++;
      }
      i++;
    }
  }
  this.updateIndexes();
  return true;
}
*/

CListeObjets.prototype.reclasseVersDebutAvecDependants = function (elb) {
  var el, nb
  var indiceMiniDebut = this.indicePremierElementNonVariable()
  var indiceItem = this.indexOf(elb)
  if (indiceItem === indiceMiniDebut) return false
  // On recherche à partir du début de la liste la position
  // du premier item dont elb ne dépend pas
  // On ne commence qu'au deuxième objet car le premier est la constante pi
  var indiceMiniGauche = 1
  var dependant = true
  var i = indiceMiniDebut
  while ((i <= indiceItem) && dependant) {
    el = this.get(i)
    if (el.estDeNature(NatObj.NImpProto)) {
      // CImplementationProto imp = (CImplementationProto) el;
      dependant = elb.depDe4Rec(el)
      nb = el.nbFinaux + el.nbIntermediaires
      if (dependant) i += nb + 1
      else { indiceMiniGauche = i }
    } else {
      if (elb.depDe4Rec(el)) { i++ } else {
        dependant = false
        indiceMiniGauche = i
      }
    }
  }
  if (dependant) return false // elb qu'on veut reclasser dépend de tous les objets
  // précédents
  i = indiceMiniGauche + 1
  while (i <= indiceItem) {
    el = this.get(i)
    // Il ne faut pas séparer les éléments d'une implémentation de prototype
    if (el.estDeNature(NatObj.NImpProto)) {
      // CImplementationProto imp = (CImplementationProto) el;
      nb = el.nbFinaux + el.nbIntermediaires + 1
      if (elb.depDe4Rec(el)) {
        for (var k = 0; k < nb; k++) {
          var el1 = this.get(i + k)
          this.removeByInd(i + k)
          this.insereElement(el1, indiceMiniGauche + k)
        }
        indiceMiniGauche += nb
        i += nb
      } else {
        i += nb
      }
    } else {
      if (elb.depDe4Rec(el)) {
        this.removeByInd(i)
        this.insereElement(el, indiceMiniGauche)
        indiceMiniGauche++
      }
      i++
    }
  }
  this.updateIndexes()
  this.determineDependancesCommentaires()
  return true
}

/**
 * Fonction décalant le plus possible vers la fin de la liste l'élément elb
 *
 * @param elb
 * @return true si le décalage est possible et 0 sinon
 */
/*
CListeObjets.prototype.reclasseVersFinAvecDependants = function(elb) {
  // Si l'élément à reclasser est un élément final d'une implémentation de
  // prototype, c'est le dernier élément final
  // qu'il faut reclasser vers la fin
  var i, indexItem, indexFin, element, imp, nb,
    indDebut = 0
  // if (elb.estElementFinal) { // Modifié version 5.3
  if (elb.impProto !== null) {
    indexItem = this.indexOf(elb.impProto);
    indexFin = this.indexOf(elb.impProto.dernierObjetFinal());
  } else {
    indexItem = this.indexOf(elb);
    indexFin = indexItem;
  }
  if (indexFin === this.longueur() - 1) return false;
  // On recherche à partir de la fin de la liste la position
  // du premier item qui ne dépende pas de elb
  var indMaxiDroite = this.longueur() - 1;
  var dependant = true;
  for (i = this.longueur() - 1; (i !== indexFin) && dependant; i--) {
    element = this.get(i);
    // if (element.estElementFinal) { // Modifié version 5.3
    if (element.impProto !== null) {
      imp = element.impProto;
      if (!element.appartientABlocDependantPourReclassement(elb)) {
        dependant = false;
        // indDebut = i - imp.nbFinaux - imp.nbIntermediaires - 1; // Modifié version 5.3
        indDebut = i - (element.index - imp.index) - 1;
        indMaxiDroite = i;
      }
      // i = i - imp.nbFinaux - imp.nbIntermediaires - 1; // Modifié version 5.3
      // Il ne faut pas soustraire 1 car cela va être fait en revenant au début de la boucle
      i = i - (element.index - imp.index);
    } else {
      if (!element.dependDeBlocPourReclassement(elb)) {
        dependant = false;
        indDebut = i - 1;
        indMaxiDroite = i;
      }
    }
  }
  if (dependant) return false;
  // indMaxiDroite est l'indice du premier élément qui ne dépend pas de elb à
  // partir de la fin de la liste
  i = indDebut;
  while (i >= indexItem) {
    element = this.get(i);
    if (element.appartientABlocDependantPourReclassement(elb)) {
      if (indMaxiDroite === this.longueur() - 1) this.add(element);
      else this.insereElement(element, indMaxiDroite + 1);
      this.removeByInd(i);
      indMaxiDroite--;
      i--;
      // Si l'objet qu'on vient de reclasser est le dernier objet final d'une
      // implémentation de construction
      // il faut recoller le corps de la construction avec lui
      if (element.estElementFinal) {
        imp = element.impProto;
        nb = imp.nbFinaux + imp.nbIntermediaires;
        for (var k = 0; k < nb; k++) {
          var el1 = this.get(i);
          if (indMaxiDroite === this.longueur() - 1) this.add(el1);
          else this.insereElement(el1, indMaxiDroite + 1);
          this.removeByInd(i);
          indMaxiDroite--;
          i--;
        }
      }
    }
    else {
      if (element.estElementFinal) {
        // Il ne faut pas désolidariser le dernier élément final de son
        // implémentation de prototype
        imp = element.impProto;
        nb = imp.nbFinaux + imp.nbIntermediaires + 1;
        i -= nb;
      } else
        i--;
    }
  }
  this.updateIndexes();
  //
  return true;
}
*/

CListeObjets.prototype.reclasseVersFinAvecDependants = function (elb) {
  // Si l'élément à reclasser est un élément final d'une implémentation de
  // prototype, c'est le dernier élément final
  // qu'il faut reclasser vers la fin
  var i; var indexItem; var indexFin; var element; var imp; var nb
  var indDebut = 0
  if (elb.estElementFinal) {
    indexItem = this.indexOf(elb.impProto)
    indexFin = this.indexOf(elb.impProto.dernierObjetFinal())
  } else {
    indexItem = this.indexOf(elb)
    indexFin = indexItem
  }
  if (indexFin === this.longueur() - 1) return false
  // On recherche à partir de la fin de la liste la position
  // du premier item qui ne dépende pas de elb
  var indMaxiDroite = this.longueur() - 1
  var dependant = true
  for (i = this.longueur() - 1; (i !== indexFin) && dependant; i--) {
    element = this.get(i)
    if (element.estElementFinal) {
      imp = element.impProto
      if (!element.appartientABlocDependantPourReclassement(elb)) {
        dependant = false
        indDebut = i - imp.nbFinaux - imp.nbIntermediaires - 1
        indMaxiDroite = i
      }
      // Modifié version 5.4 : Il ne faut pas soustraire 1 car cela va être fait en revenant au début de la boucle
      // i = i - imp.nbFinaux - imp.nbIntermediaires - 1;
      i = i - imp.nbFinaux - imp.nbIntermediaires
    } else {
      if (!element.dependDeBlocPourReclassement(elb)) {
        dependant = false
        indDebut = i - 1
        indMaxiDroite = i
      }
    }
  }
  if (dependant) return false
  // indMaxiDroite est l'indice du premier élément qui ne dépend pas de elb à
  // partir de la fin de la liste
  i = indDebut
  while (i >= indexItem) {
    element = this.get(i)
    if (element.appartientABlocDependantPourReclassement(elb)) {
      if (indMaxiDroite === this.longueur() - 1) this.add(element)
      else this.insereElement(element, indMaxiDroite + 1)
      this.removeByInd(i)
      indMaxiDroite--
      i--
      // Si l'objet qu'on vient de reclasser est le dernier objet final d'une
      // implémentation de construction
      // il faut recoller le corps de la construction avec lui
      if (element.estElementFinal) {
        imp = element.impProto
        nb = imp.nbFinaux + imp.nbIntermediaires
        for (var k = 0; k < nb; k++) {
          var el1 = this.get(i)
          if (indMaxiDroite === this.longueur() - 1) this.add(el1)
          else this.insereElement(el1, indMaxiDroite + 1)
          this.removeByInd(i)
          indMaxiDroite--
          i--
        }
      }
    } else {
      if (element.estElementFinal) {
        // Il ne faut pas désolidariser le dernier élément final de son
        // implémentation de prototype
        imp = element.impProto
        nb = imp.nbFinaux + imp.nbIntermediaires + 1
        i -= nb
      } else { i-- }
    }
  }
  this.updateIndexes()
  this.determineDependancesCommentaires()
  //
  return true
}

/*
CListeObjets.prototype.reclassUpOneStep = function(elb) {
  var el = null;
  // var indicemini = 0;
  // var indDebut = 0;
  for (var indDebut = 0; indDebut < this.longueur(); indDebut++) {
    var elt = this.get(indDebut);
    if (!elt.estDeNatureCalcul(Nat.or(NatCal.NCalculReelConstant, NatCal.NVariable))) break;
  }
  var indicemini = indDebut;
  // Si l'élément à remonter est un élément final de construction ou une CImplementationProto il faut remonter tout le bloc.
  // Modifié version 5.3 car dans certaines anciennes figures le derier élément peut être un objet intermédiaire
  // var imp = elb.estElementFinal ? elb.impProto : (elb.estDeNature(NatObj.NImpProto) ? elb : null);
  var imp = (elb.impProto !== null) ? elb.impProto : (elb.estDeNature(NatObj.NImpProto) ? elb : null);
  var indelb = (imp !== null) ? this.indexOf(imp) : this.indexOf(elb);
  // On recherche vers le début à partir de elb l'indice du premier élément dont ne dépend pas elb;
  // int i = indelb;
  var trouve = false;
  // var inddest = (imp === null) ? indelb : indelb + imp.nbFinaux + imp.nbIntermediaires; // Modifié version 5.3
  var inddest = (imp === null) ? indelb : indelb + elb.index - imp.index;
  var i = indelb;
  while (!trouve && (i > indicemini)) {
    i--;
    el = this.get(i);
    // if (el.estElementFinal) { // Modifié version 5.3
    if (el.impProto !== null) {
      var imp2 = el.impProto;
      if (!elb.appartientABlocDependantPourReclassement(el)) {
        trouve = true;
        // indDebut = i - imp2.nbFinaux - imp2.nbIntermediaires; // Modifié version 5.3
        indDebut = i - (el.index - imp2.index);
        el = imp2;
        break;
      }
      // i = i - imp2.nbFinaux - imp2 .nbIntermediaires; // Modifié version 5.3
      i = i - (el.index - imp2.index);
    } else {
      if (!elb.dependDeBlocPourReclassement(el)) {
        trouve = true;
        indDebut = i;
        break;
      }
    }
  }
  if (!trouve) return false;
  if (el.estDeNature(NatObj.NImpProto)) {
    for (var j = 0; j <= el.nbFinaux + el.nbIntermediaires; j++) {
      var e = this.get(indDebut);
      this.removeByInd(indDebut);
      if (inddest === this.longueur()) this.add(e);
      else this.insert(inddest, e);
    }
  }
  else {
    this.removeObj(el);
    if (inddest === this.longueur()) this.add(el);
    else this.insert(inddest, el);
  }
  this.updateIndexes();
  return true;
}
*/

CListeObjets.prototype.reclassUpOneStep = function (elb) {
  var el = null
  // var indicemini = 0;
  // var indDebut = 0;
  for (var indDebut = 0; indDebut < this.longueur(); indDebut++) {
    var elt = this.get(indDebut)
    if (!elt.estDeNatureCalcul(Nat.or(NatCal.NCalculReelConstant, NatCal.NVariable))) break
  }
  var indicemini = indDebut
  // Si l'élément à remonter est un élément final de construction ou une CImplementationProto il faut remonter tout le bloc.
  var imp = elb.estElementFinal ? elb.impProto : (elb.estDeNature(NatObj.NImpProto) ? elb : null)
  var indelb = (imp !== null) ? this.indexOf(imp) : this.indexOf(elb)
  // On recherche vers le début à partir de elb l'indice du premier élément dont ne dépend pas elb;
  // int i = indelb;
  var trouve = false
  var inddest = (imp === null) ? indelb : indelb + imp.nbFinaux + imp.nbIntermediaires
  var i = indelb
  while (!trouve && (i > indicemini)) {
    i--
    el = this.get(i)
    if (el.estElementFinal) {
      var imp2 = el.impProto
      if (!elb.appartientABlocDependantPourReclassement(el)) {
        trouve = true
        indDebut = i - imp2.nbFinaux - imp2.nbIntermediaires
        el = imp2
        break
      }
      i = i - imp2.nbFinaux - imp2.nbIntermediaires
    } else {
      if (!elb.dependDeBlocPourReclassement(el)) {
        trouve = true
        indDebut = i
        break
      }
    }
  }
  if (!trouve) return false
  if (el.estDeNature(NatObj.NImpProto)) {
    for (var j = 0; j <= el.nbFinaux + el.nbIntermediaires; j++) {
      var e = this.get(indDebut)
      this.removeByInd(indDebut)
      if (inddest === this.longueur()) this.add(e)
      else this.insert(inddest, e)
    }
  } else {
    this.removeObj(el)
    if (inddest === this.longueur()) this.add(el)
    else this.insert(inddest, el)
  }
  this.updateIndexes()
  this.determineDependancesCommentaires()
  return true
}

/*
CListeObjets.prototype.reclassDownOneStep = function(elb) {
  var i, imp;
  var el = null;
  // Si l'élément à remonter est un élément final de construction il faut remonter tout le bloc.
  // Modifié version 5.3
  // var indelb = elb.estElementFinal ? this.indexOf(elb.impProto) : this.indexOf(elb);
  var indelb = (elb.impProto !== null) ? this.indexOf(elb.impProto) : this.indexOf(elb);
  // if (indelb == 0) return false; // On ne peut pas reclasser la constante pi vers la fin
  // if (elb.estElementFinal || elb.estDeNature(NatObj.NImpProto)) { // Modifié version 5.3
  if ((elb.impProto !== null) || elb.estDeNature(NatObj.NImpProto)) {
    // imp = elb.estElementFinal ? elb.impProto : elb; // Modifié version 5.3
    imp = (elb.impProto !== null) ? elb.impProto : elb;
    i = this.indexOf(imp) + imp.nbFinaux + imp.nbIntermediaires;
    if (i+1 === this.longueur()) return false;
  }
  else if (indelb === this.longueur()-1) return false;
  else i = indelb;
  var trouve = false;
  while (!trouve && (i<this.longueur()-1)) {
    i++;
    el = this.get(i);
    if (el.estDeNature(NatObj.NImpProto)) {
      i++;
      el = this.get(i);
    }
    if (!el.appartientABlocDependantPourReclassement(elb)) trouve = true;
    else {
      if (el.impProto !== null) {
        imp = el.impProto;
        i = this.indexOf(imp) + imp.nbFinaux + imp.nbIntermediaires;
      }
    }
  }
  if (!trouve) return false;
  if (el.impProto !== null) {
    imp = el.impProto;
    i = this.indexOf(imp);
    for (var j = 0; j <= imp.nbFinaux + imp.nbIntermediaires; j++) {
      var e = this.get(i+j);
      // remove(e);
      this.removeByInd(i+j);
      this.insert(indelb + j, e);
    }
  }
  else {
    this.removeObj(el);
    this.insert(indelb, el);
  }
  this.updateIndexes();
  return true;
}
*/

CListeObjets.prototype.reclassDownOneStep = function (elb) {
  var i, imp
  var el = null
  // Si l'élément à remonter est un élément final de construction il faut remonter tout le bloc.
  var indelb = elb.estElementFinal ? this.indexOf(elb.impProto) : this.indexOf(elb)
  // if (indelb == 0) return false; // On ne peut pas reclasser la constante pi vers la fin
  if (elb.estElementFinal || elb.estDeNature(NatObj.NImpProto)) {
    imp = elb.estElementFinal ? elb.impProto : elb
    i = this.indexOf(imp) + imp.nbFinaux + imp.nbIntermediaires
    if (i + 1 === this.longueur()) return false
  } else if (indelb === this.longueur() - 1) return false
  else i = indelb
  var trouve = false
  while (!trouve && (i < this.longueur() - 1)) {
    i++
    el = this.get(i)
    if (el.estDeNature(NatObj.NImpProto)) {
      i++
      el = this.get(i)
    }
    if (!el.appartientABlocDependantPourReclassement(elb)) trouve = true
    else {
      if (el.impProto !== null) {
        imp = el.impProto
        i = this.indexOf(imp) + imp.nbFinaux + imp.nbIntermediaires
      }
    }
  }
  if (!trouve) return false
  if (el.impProto !== null) {
    imp = el.impProto
    i = this.indexOf(imp)
    for (var j = 0; j <= imp.nbFinaux + imp.nbIntermediaires; j++) {
      var e = this.get(i + j)
      // remove(e);
      this.removeByInd(i + j)
      this.insert(indelb + j, e)
    }
  } else {
    this.removeObj(el)
    this.insert(indelb, el)
  }
  this.updateIndexes()
  this.determineDependancesCommentaires()
  return true
}

/**
 * Fonction retirant du svg de la figure tous les gElements représentant les éléments graphiques
 * et les recréant en rajoutant aussi les gElements représentant les objets ùmasqués si bMemeMasque
 * est true et ceux représentant les objets intermédiaires de constructions
 * @param svg
 * @param couleurFond
 * @param opacity
 * @param bMemeMasques
 * @param bInterm
 * @param inddeb L'inide de début de traitement
 * @param nbObjMax Le nombre d'objets à utiliser
 */
CListeObjets.prototype.prepareForProtocol = function (svg, couleurFond, opacity, bMemeMasques, bInterm, inddeb, nbObjMax) {
  this.setReady4MathJax(bMemeMasques, bInterm)
  var self = this
  MathJax.Hub.Queue(function () {
    for (var i = inddeb; i <= nbObjMax; i++) {
      var elb = self.get(i)
      if (elb.estDeNature(NatObj.NTtObj) && (!elb.estElementIntermediaire() || bInterm)) {
        elb.creeAffichage(svg, !bMemeMasques, couleurFond, opacity)
        // Au départ tous les gElements représentant les objets graphiques sont masqué
        elb.showgElt(false)
      }
    }
  })
}

/**
 * Fonction montrant ou cachant les gElements des objets graphiques de la figure pour la boîte de dialogue
 * de protocole de la figure depuis l'indice indstart jusqu'à l'indice indFin
 * @param indStart
 * @param indFin
 * @param bMemeMasques Si true, on montre aussi les éléments cachés
 * @param bInterm Si true on montre aussi les objets intermédiares de construction
 * @param {int} indmax L'indice maxi permis dans la liste d'objets
 */
CListeObjets.prototype.displayForProtocol = function (indStart, indFin, bMemeMasques, bInterm, indMax) {
  for (var i = indStart; i <= indMax; i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NTtObj) && (!elb.estElementIntermediaire() || bInterm)) {
      if (i <= indFin) {
        /*
         $(elb.g).attr("visibility", b ? "visible" : "hidden");
         if (elb.estDeNature(NatObj.NObjNommable)) $(elb.gname).attr("visibility", b ? "visible" : "hidden");
         */
        elb.showgElt(bMemeMasques || !elb.masque)
      } else elb.showgElt(false)
    }
  }
}

CListeObjets.prototype.listeNoms = function () {
  var s = this.longueur()
  var ch = ''
  for (var i = 0; i < s; i++) {
    var el = this.get(i)
    var st = el.getNom()
    ch += (st === '') ? el.nom : st
    if (i !== s - 1) ch += ', '
  }
  return ch
}

/**
 * Fonction ajoutant à la liste list les éléments de this qui n'ont pas de nom
 * et générant un nom pour ces objets. et rendant tous ces noms non masqués
 * @param list
 * @param interm Si true on renomme aussi les objets intermédiaires
 */
/*
CListeObjets.prototype.genereNoms = function(list, interm) {
  var i, el,
    nbObjInterm = 1;
  CAbscisseOrigineRep.ind = 0;
  COrdonneeOrigineRep.ind = 0;
  CUnitexRep.ind = 0;
  CUniteyRep.ind = 0;
  CArcDeCercleAncetre.ind = 0;
  CCercle.ind = 0;
  CCommentaire.ind = 0;
  CDemiDroite.ind = 0;
  CDemiPlan.ind = 0;
  CEditeurFormule.ind = 0;
  CGrapheSuiteRec.ind = 0;
  CGrapheSuiteRecComplexe.ind = 0;
  CImage.ind = 0;
  CLatex.ind = 0;
  CLieuDeBase.ind = 0;
  CLieuDiscretDeBase.ind = 0;
  CLieuObjetAncetre.ind = 0;
  CMacro.ind = 0;
  CMarqueAngleAncetre.ind = 0;
  CMarqueSegment.ind = 0;
  CPt.ind = 0;
  CDroiteAncetre.ind = 0;
  CSurface.ind = 0;
  CValeurAffichee.ind = 0;
  // On regarde combien a figure contient de points ou de droites qu'il faut nommer. Si ce nombre est nférieur à 50
  // On génère des noms construits de façon générique pour les points et droites, ce ui oblige pour chacun à faire une génération
  // aléatoire et peut être chronophage sur les figures très lourdes obtenues par récursion par exemple.
  // Sinon les points auront un nom commençant par Pt et le sdroites par dt
  var compteur = 0;
  for (i = 0; i < this.longueur(); i++) {
    el = this.get(i);
    if (el.getNom() === "") compteur ++;
  }
  if ((compteur <= 100) && (this.longueur() <= 500)) {
    for (i = 0; i < this.longueur(); i++) {
      el = this.get(i);
      if (el.getNom() === "") {
        if ((!el.estElementIntermediaire() || interm)) {
          list.add(el);
          el.nom = el.genereNom();
          if (el.estDeNature(NatObj.NTtObj)) {
            el.nomMasque = false;
            el.tailleNom = 13;
          }
        }
        else {
          el.nom = kernel.getStr("interm") + String(nbObjInterm++);
          list.add(el);
        }
      }
      else {
        if (el.estDeNature(NatObj.NObjNommable)) el.nomMasque = false;
      }
    }
  }
  else {
    for (i = 0; i < this.longueur(); i++) {
      el = this.get(i);
      if (el.getNom().length === 0) {
        if (!el.estElementIntermediaire() || interm) {
          if (el.estDeNature(NatObj.NDroite)) el.nom = el.genereNom(kernel.getStr("rdt"));
          else if (el.estDeNature(NatObj.NTtPoint)) el.nom = el.genereNom(kernel.getStr("rpt"));
          else el.nom = el.genereNom();
          list.add(el);
        }
        else {
          el.nom = kernel.getStr("interm") + String(nbObjInterm++);
          list.add(el);
        }
      }
    }
  }
}
*/
/**
 * Fonction utiliée pour la boîte de dialogue de protocole
 * Génére des noms pour les objets créés à partir de l'indice inddeb
 * @param inddeb
 * @param list
 */
CListeObjets.prototype.genereNoms = function (inddeb, list) {
  var i, el
  CAbscisseOrigineRep.ind = 0
  COrdonneeOrigineRep.ind = 0
  CUnitexRep.ind = 0
  CUniteyRep.ind = 0
  CArcDeCercleAncetre.ind = 0
  CCercle.ind = 0
  CSegment.ind = 0
  CCommentaire.ind = 0
  CDemiDroite.ind = 0
  CDemiPlan.ind = 0
  CEditeurFormule.ind = 0
  CGrapheSuiteRec.ind = 0
  CGrapheSuiteRecComplexe.ind = 0
  CImage.ind = 0
  CLatex.ind = 0
  CLieuDeBase.ind = 0
  CLieuDiscretDeBase.ind = 0
  CLieuObjetAncetre.ind = 0
  CMacro.ind = 0
  CMarqueAngleAncetre.ind = 0
  CMarqueSegment.ind = 0
  CPt.ind = 0
  CDroiteAncetre.ind = 0
  CSurface.ind = 0
  CValeurAffichee.ind = 0
  // On regarde combien a figure contient de points ou de droites qu'il faut nommer. Si ce nombre est nférieur à 50
  // On génère des noms construits de façon générique pour les points et droites, ce ui oblige pour chacun à faire une génération
  // aléatoire et peut être chronophage sur les figures très lourdes obtenues par récursion par exemple.
  // Sinon les points auront un nom commençant par Pt et le sdroites par dt
  var compteur = 0
  for (i = inddeb; i < this.longueur(); i++) {
    el = this.get(i)
    if (el.getNom() === '') compteur++
  }
  var nomsDynamiques = (compteur <= 100) && (this.longueur() <= 500)
  for (i = inddeb; i < this.longueur(); i++) {
    el = this.get(i)
    if (el.getNom() === '') {
      list.add(el)
      if (nomsDynamiques) el.nom = el.genereNom()
      else {
        if (el.estDeNature(NatObj.NDroite)) el.nom = el.genereNom(kernel.getStr('rdt'))
        else if (el.estDeNature(NatObj.NSegment)) el.nom = el.genereNom(kernel.getStr('seg'))
        else if (el.estDeNature(NatObj.NTtPoint)) el.nom = el.genereNom(kernel.getStr('rpt'))
        else el.nom = el.genereNom()
      }
      if (el.estDeNature(NatObj.NTtObj)) {
        el.nomMasque = false
        el.tailleNom = 13
      }
    } else {
      if (el.estDeNature(NatObj.NObjNommable)) el.nomMasque = false
    }
  }
}

/**
 * Fonction remettant le champ nom de tous les objets à ""
 * @param taille La taille à affecter aux noms de points ou droites
 */
CListeObjets.prototype.effaceNoms = function (taille) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    el.nom = ''
    if (el.estDeNature(NatObj.NObjNommable)) {
      el.tailleNom = taille
    }
  }
}

/**
 * Fonction renvoyant le nombre de points liés l'objet el qui soient visibles et ne soient pas
 * des objets intermediaires de construction
 * @param el
 * @returns {number}
 */
CListeObjets.prototype.nombrePointsLiesAVisibles = function (el) {
  var compteur = 0
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NPointLie)) {
      if (elb.existe && !elb.masque && (elb.lieA() === el) && !el.estElementIntermediaire()) { compteur++ }
    }
  }
  return compteur
}

CListeObjets.prototype.nombreFonctionsDerivables = function () {
  var res = 0
  for (var i = 0; i < this.longueur(); i++) {
    var elb = this.get(i)
    if (!elb.estElementIntermediaire() && elb.getNatureCalcul() === NatCal.NFonction) {
      if (elb.deriveePossible(0)) res++
    }
  }
  return res
}

/**
 * Fonction supprimant les implémentations de construction de la figure et remplaçant les objets
 * inetrmédiaires et finaux par de varis objets en renommant si nécessaire.
 * @param app L'application
 */
CListeObjets.prototype.fusionImpConst = function (app) {
  var calculIntermediaireRenomme = false
  // On retire d'abord toutes les implémentations de constructions
  var i = 0
  while (i < this.longueur()) {
    var elb = this.get(i)
    if (elb.estDeNature(NatObj.NImpProto)) { this.remove(i) } else i++
  }
  for (i = 0; i < this.longueur(); i++) {
    elb = this.get(i)
    if (elb.estElementIntermediaire()) {
      if (elb.estDeNature(NatObj.NTtObj)) elb.creeAffichage(app.svgFigure, true, app.doc.couleurFond, app.doc.opacity)
      // On renomme les points ou droites intermédiaires si leur nom existe déjà
      if (elb.estDeNature(NatObj.NObjNommable)) {
        var ancienNom = elb.rendNom()
        if (ancienNom !== '') {
          if (this.existePointOuDroiteMemeNom(elb, ancienNom)) {
            var nouveauNom = this.genereNomPourPointOuDroite(ancienNom.charAt(0))
            elb.donneNom(nouveauNom)
          }
        }
      } else {
        // Il faut renommer aussi les calculs intermédiaires ayant même
        // nom que d'autres calculs créés après implémentation de la construction
        if (elb.estDeNatureCalcul(NatCal.NTtCalcNomme)) {
          ancienNom = elb.getNom()
          if (this.existeCalculOuVariableOuFonctionOuParametreMemeNom(elb, ancienNom, true)) {
            nouveauNom = this.genereNomPourCalcul(ancienNom, false)
            this.remplaceNomValeurDynamiqueDansCommentairesOuLatexDepDe(ancienNom, nouveauNom, elb)
            elb.nomCalcul = nouveauNom
            calculIntermediaireRenomme = true
          }
        }
      }
      elb.impProto = null
      elb.estElementFinal = false
    } else {
      if (elb.estElementFinal) {
        elb.impProto = null
        elb.estElementFinal = false
        if (elb.fixed) delete (elb.fixed) // Pour les affichages de longueur orientés.
      }
    }
  }
  // Ajout version 4.8.0
  this.updateIndexes()
  //
  // On reconstruit toutes les formules de la figure
  if (calculIntermediaireRenomme) this.reconstruitChainesCalcul()
}

/**
 * Fonction recalculant les éléments de la liste de nature nat
 * @param nat
 * @param {boolean} infoRandom Si true les calculs aléatoires par rand() sont réinitialisés
 * @param {Dimf} dimfen les dimensions de la fenêtre
 */
CListeObjets.prototype.positionneParNat = function (nat, infoRandom, dimfen) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNature(nat)) el.positionne(infoRandom, dimfen)
  }
}

CListeObjets.prototype.positionneTikz = function (infoRandom, dimfen) {
  for (var i = 0; i < this.longueur(); i++) { this.get(i).positionneTikz(infoRandom, dimfen) }
}

CListeObjets.prototype.tikzXcoord = function (x, dimf, bu) {
  // Si la figure a une longueur unité et qu'on a choisi de l'utiliser, bu.infoLength contient
  // la longueur en cm de la longueur unité
  // Sinon bu.infoLength contient la largeur en com de la figure
  if (bu.useFigUnity) return x / this.pointeurLongueurUnite.rendLongueur() * bu.infoLength
  else return x * bu.infoLength / dimf.x
  // double res = (double) Toolkit.getDefaultToolkit().getScreenResolution() / 2.54;
  // On suppose que la largeur de la figure sera de 12 cm
}

CListeObjets.prototype.tikzYcoord = function (y, dimf, bu) {
  if (bu.useFigUnity) return (dimf.y - y) / this.pointeurLongueurUnite.rendLongueur() * bu.infoLength
  else return (dimf.y - y) * bu.infoLength / dimf.x
}

CListeObjets.prototype.tikzLongueur = function (lon, dimf, bu) {
  if (bu.useFigUnity) {
    return lon / this.pointeurLongueurUnite.rendLongueur() * bu.infoLength
  } else return lon * bu.infoLength / dimf.x
}

CListeObjets.prototype.taillePlus = function (svg) {
  var done = false
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNature(NatObj.NAffLieAPoint)) {
      if (el.taillePolice < 80) {
        el.taillePolice++
        done = true
      }
    } else {
      if (el.estDeNature(NatObj.NObjNommable)) {
        if (el.tailleNom < 80) {
          el.tailleNom++
          done = true
        }
      }
    }
  }
  return done
}

CListeObjets.prototype.tailleMoins = function (svg) {
  var done = false
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNature(NatObj.NAffLieAPointSaufImEd)) {
      if (el.taillePolice > 10) {
        el.taillePolice--
        done = true
      }
    } else {
      if (el.estDeNature(NatObj.NObjNommable)) {
        if (el.tailleNom > 10) {
          el.tailleNom--
          done = true
        }
      }
    }
  }
  return done
}

/**
 * Fonction appelée quand on augment ou diminue la taille de toutes les polices
 * @param svg
 * @param couleurFond
 * @param transparence
 * @param masquage
 */
CListeObjets.prototype.updateDisplays = function (svg, couleurFond, transparence, masquage) {
  this.setReady4MathJax()
  var self = this
  MathJax.Hub.Queue(function () {
    for (var i = 0; i < self.longueur(); i++) {
      var elb = self.get(i)
      // Il faut mettre à jour aussi les lieux d'objets dont l'objet générant le lieu est un affichage
      if (elb.existe && (elb.estDeNature(NatObj.NAffLieAPointSaufImEd) ||
          (elb.estDeNature(NatObj.NLieuObjet) && elb.elementAssocie.estDeNature(NatObj.NAffLieAPoint))) &&
          (elb.hasg(masquage))) {
        var oldg = elb.g
        var newg = elb.createg(svg, couleurFond, transparence)
        svg.replaceChild(newg, oldg)
        elb.g = newg
      } else {
        if (elb.estDeNature(NatObj.NObjNommable) && !elb.estElementIntermediaire() && elb.hasg(masquage)) elb.updateName(svg, true)
      }
    }
  })
}

/**
 * Fonction mettant le membre isToBeUpdated des CLaTeX dependant de elb à true
 * @param elb
 */
CListeObjets.prototype.setDependantLatexToBeUpdated = function (elb) {
  for (var i = 0; i < this.longueur(); i++) {
    var el = this.get(i)
    if (el.estDeNature(NatObj.NLatex) && el.depDe(elb)) el.isToBeUpdated = true
  }
}

/**
 * Fonction renvoyant true si une des macros de construction itérative ou récusive éventuelle de la figure
 * dépend du prototype proto
 * @param {CPrototype} proto
 * @return {boolean}
 */
CListeObjets.prototype.depDeProto = function (proto) {
  for (var i = 0; i < this.longueur(); i++) {
    const el = this.get(i)
    if (el.depDeProto(proto)) return true
  }
  return false
}
