/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMacroIncrementationVariable = require('../objets/CMacroIncrementationVariable')
const CMacro = require('../objets/CMacro')
const kernel = require('../kernel/kernel')
const MacIncDecVarDlg = require('../dialogs/MacIncDecVarDlg')

module.exports = CMacroIncrementationVariable

CMacroIncrementationVariable.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo121') + ' ' + kernel.getStr('chinfo122Bis') +
    ' ' + this.variableAssociee.nomCalcul
}

CMacroIncrementationVariable.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CMacro.prototype.depDe4Rec.call(this, p) ||
    this.variableAssociee.depDe4Rec(p))
}

CMacroIncrementationVariable.prototype.modifDlg = function (app, callBack1, callBack2) {
  new MacIncDecVarDlg(app, true, this, true, callBack1, callBack2)
}

CMacroIncrementationVariable.prototype.estDefiniParObjDs = function (listeOb) {
  return CMacro.prototype.estDefiniParObjDs.call(this, listeOb) &&
    this.variableAssociee.estDefPar(listeOb)
}
