/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMarqueAngleDroit = require('../objets/CMarqueAngleDroit')
const CMarqueAngleAncetre = require('../objets/CMarqueAngleAncetre')
const kernel = require('../kernel/kernel')

module.exports = CMarqueAngleDroit

CMarqueAngleDroit.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo165') + ' ' + kernel.getStr('de') + ' ' + this.perp.getNom() +
    ' ' + kernel.getStr('et') + ' ' + this.perp.d.getNom()
}

CMarqueAngleDroit.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CMarqueAngleAncetre.prototype.depDe4Rec.call(this, p) ||
    this.perp.depDe4Rec(p))
}

CMarqueAngleDroit.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  return '\\draw' + this.tikzLineStyle(dimf, coefmult) + this.tikzPathAngleDroit(dimf, bu) + ';'
}

CMarqueAngleDroit.prototype.estDefiniParObjDs = function (listeOb) {
  return this.perp.estDefPar(listeOb)
}
