/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Vect = require('../types/Vect')
const kernel = require('../kernel/kernel')
const CMarqueAngleOrienteIndirecte = require('../objets/CMarqueAngleOrienteIndirecte')
module.exports = CMarqueAngleOrienteIndirecte

CMarqueAngleOrienteIndirecte.prototype.info = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo69') + ' ' + kernel.getStr('de') +
    ' ' + this.a.nom + this.o.nom + this.b.nom
}

CMarqueAngleOrienteIndirecte.prototype.distancePoint = function (xp, yp, masquage) {
  if (!(this.existe) || (masquage && this.masque)) return -1
  else {
    var appsecteur
    var w = new Vect(this.centreX, this.centreY, xp, yp)
    var ang = w.angleRad()
    if (kernel.zeroAngle(Math.abs(this.ang2rad - this.ang1rad) - Math.PI)) {
      if (this.ang1rad < this.ang2rad) appsecteur = (ang >= this.ang2rad) || (ang <= this.ang1rad)
      else appsecteur = (ang >= this.ang2rad) && (ang <= this.ang1rad)
    } else {
      if (this.ang1rad <= this.ang2rad) appsecteur = (ang >= this.ang2rad) || (ang <= this.ang1rad)
      else appsecteur = (ang >= this.ang2rad) && (ang < this.ang1rad)
    }
    if (appsecteur) return Math.abs(kernel.distancePointPoint(this.centreX, this.centreY, xp, yp) - this.rayon)
    else return -1
  }
}

CMarqueAngleOrienteIndirecte.prototype.tikzPath = function (dimf, bu) {
  var list = this.listeProprietaire
  var centreX = this.centreX
  var centreY = this.centreY
  var b = this.b
  var rayon = this.rayon
  var u = new Vect(centreX, centreY, this.a.x, this.a.y)
  var ang1 = u.angleRad()
  var u1 = new Vect()

  u.vecteurColineaire(rayon, u1)
  var x1 = list.tikzXcoord(centreX + u1.x, dimf, bu)
  var y1 = list.tikzYcoord(centreY + u1.y, dimf, bu)
  var ray = list.tikzLongueur(rayon, dimf, bu)
  var v = new Vect(centreX, centreY, b.x, b.y)
  var mesureAngle = u.mesureAngleVecteurs(v)
  var ang2 = ang1 + mesureAngle
  if (ang2 < 0) ang2 = ang2 + 2 * Math.PI
  if (ang2 >= 2 * Math.PI) ang2 = ang2 - 2 * Math.PI
  if (ang2 > ang1) ang2 = ang2 - 2 * Math.PI
  ang1 *= kernel.ConvRadDeg
  ang2 *= kernel.ConvRadDeg
  return '(' + kernel.chaineNombre(x1, 3) + ',' + kernel.chaineNombre(y1, 3) + ') arc (' +
    kernel.chaineNombre(ang1, 3) + ' : ' + kernel.chaineNombre(ang2, 3) + ' : ' + kernel.chaineNombre(ray, 3) + ')'
}
