/*
 * Created by yvesb on 30/05/2021.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
// const CMatrice = require('../objets/CMatrice')
import CMatrice from '../objets/CMatrice'
const CCalcul = require('../objets/CCalcul')
const kernel = require('../kernel/kernel')
const MatriceDlg = require('../dialogs/MatriceDlg')
// module.exports = CMatrice
export default CMatrice

CMatrice.prototype.info = function () {
  return kernel.getStr('Matrice') + ' ' + this.getNom()
}

CMatrice.prototype.infoHist = function () {
  let ch = kernel.getStr('Matrice') + ' ' + this.getNom()
  ch += '\n' + kernel.getStr('Matrice') + ' ' + this.n + 'x' + this.p
  for (let i = 0; i < this.n; i++) {
    ch += '\n'
    for (let j = 0; j < this.p; j++) {
      if (j !== 0) ch += '   '
      ch += this.tabVal[i][j].chaineInfo()
    }
  }
  ch += '\n' + kernel.getStr('Valeur') + ' :'
  for (let i = 0; i < this.n; i++) {
    ch += '\n'
    for (let j = 0; j < this.p; j++) {
      if (j !== 0) ch += '   '
      ch += kernel.chaineNombre(this.mat.get([i, j]), 12)
    }
  }
  if (!this.existe) ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CMatrice.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  let dep = false
  for (let i = 0; i < this.n; i++) {
    for (let j = 0; j < this.p; j++) {
      dep = dep || this.tabVal[i][j].depDe4Rec(p)
    }
  }
  return this.memDep4Rec(CCalcul.prototype.depDe4Rec.call(this, p) || dep)
}

CMatrice.prototype.estDefiniParObjDs = function (listeOb) {
  let res = true
  for (let i = 0; (i < this.n) && res; i++) {
    for (let j = 0; (j < this.p) && res; j++) {
      res = res && this.tabVal[i][j].estDefiniParObjDs(listeOb)
    }
  }
  return res
}

CMatrice.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CMatrice.prototype.modifDlg = function (app, callBack1, callBack2) {
  new MatriceDlg(app, this, true, callBack1, callBack2)
}
