/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMesureAffixe = require('../objets/CMesureAffixe')
const CCalculAncetre = require('../objets/CCalculAncetre')
const kernel = require('../kernel/kernel')
const ModifRepDlg = require('../dialogs/ModifRepDlg')
module.exports = CMesureAffixe

CMesureAffixe.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCalculAncetre.prototype.depDe4Rec.call(this, p) ||
    this.repereAssocie.depDe4Rec(p) || this.pointMesure.depDe4Rec(p))
}

CMesureAffixe.prototype.info = function () {
  return this.getNom() + ' : ' + kernel.getStr('chinfo108') + ' ' + kernel.getStr('chinfo109') +
    '  ' + this.pointMesure.getNom() + '\n' + kernel.getStr('chinfo110') + ' ' + this.repereAssocie.getNom()
}

CMesureAffixe.prototype.infoHist = function () {
  var ch = this.info()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + this.affixe.chaineValeurComplexe(8)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CMesureAffixe.prototype.estDefiniParObjDs = function (listeOb) {
  return this.repereAssocie.estDefPar(listeOb) &&
  this.pointMesure.estDefPar(listeOb)
}

CMesureAffixe.prototype.modifiableParMenu = function () {
  return true
}

CMesureAffixe.prototype.modifDlg = function (app, callBack1) {
  var self = this
  new ModifRepDlg(app, this, this.repereAssocie, 'MesAffRep', function (rep) {
    self.repereAssocie = rep
    if (callBack1 !== null) callBack1()
  })
}
