/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CMesureAngleGeometrique = require('../objets/CMesureAngleGeometrique')
const kernel = require('../kernel/kernel')
const CValDyn = require('../objets/CValDyn')
module.exports = CMesureAngleGeometrique

CMesureAngleGeometrique.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CValDyn.prototype.depDe4Rec.call(this, p) ||
    this.a.depDe4Rec(p) || this.o.depDe4Rec(p) || this.b.depDe4Rec(p))
}

CMesureAngleGeometrique.prototype.info = function () {
  return this.getNom() + ' : ' + kernel.getStr('chinfo29') + ' ' + this.getNom()
}

CMesureAngleGeometrique.prototype.infoHist = function () {
  var ch = this.info()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.mesure, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CMesureAngleGeometrique.prototype.estDefiniParObjDs = function (listeOb) {
  return this.a.estDefPar(listeOb) &&
  this.o.estDefPar(listeOb) &&
  this.b.estDefPar(listeOb)
}
