/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CMesureCoefDir = require('../objets/CMesureCoefDir')
const kernel = require('../kernel/kernel')
const CCalculAncetre = require('../objets/CCalculAncetre')
const ModifRepDlg = require('../dialogs/ModifRepDlg')
module.exports = CMesureCoefDir

CMesureCoefDir.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCalculAncetre.prototype.depDe4Rec.call(this, p) ||
    this.rep.depDe4Rec(p) || this.d.depDe4Rec(p))
}

CMesureCoefDir.prototype.info = function () {
  return this.getNom() + ' : ' + kernel.getStr('chinfo153') + ' ' + this.d.nom + '\n' + kernel.getStr('chinfo32') + ' ' +
  this.rep.getNom()
}

CMesureCoefDir.prototype.infoHist = function () {
  var ch = this.info()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + kernel.chaineNombre(this.coef, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CMesureCoefDir.prototype.estDefiniParObjDs = function (listeOb) {
  return this.rep.estDefPar(listeOb) &&
  this.d.estDefPar(listeOb)
}

CMesureCoefDir.prototype.modifiableParMenu = function () {
  return true
}

CMesureCoefDir.prototype.modifDlg = function (app, callBack1) {
  var self = this
  new ModifRepDlg(app, this, this.rep, 'MesCoefDir', function (rep) {
    self.rep = rep
    if (callBack1 !== null) callBack1()
  })
}
