/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMesureY = require('../objets/CMesureY')
const kernel = require('../kernel/kernel')
const ModifRepDlg = require('../dialogs/ModifRepDlg')
module.exports = CMesureY

CMesureY.prototype.info = function () {
  return this.getNom() + ' : ' + kernel.getStr('chinfo81') + ' ' + this.pointMesure.getNom() + '\n' + kernel.getStr('chinfo32') +
    ' ' + this.repereAssocie.getNom()
}

CMesureY.prototype.infoHist = function () {
  var ch = this.info()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + kernel.chaineNombre(this.abscisse, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CMesureY.prototype.modifDlg = function (app, callBack1) {
  var self = this
  new ModifRepDlg(app, this, this.repereAssocie, 'MesOrdRep', function (rep) {
    self.repereAssocie = rep
    if (callBack1 !== null) callBack1()
  })
}
