/*
 * Created by yvesb on 23/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CMilieu = require('../objets/CMilieu')
const CPt = require('../objets/CPt')
const kernel = require('../kernel/kernel')
module.exports = CMilieu

CMilieu.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('Milieu') + ' ' + kernel.getStr('de') + ' ' +
    '[' + this.point1.nom + this.point2.nom + ']'
}

CMilieu.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.point1.depDe4Rec(p) || this.point2.depDe4Rec(p))
}

CMilieu.prototype.appartientDroiteParDefinition = function (droite) {
  return CPt.prototype.appartientDroiteParDefinition.call(this, droite) ||
    (this.point1.appartientDroiteParDefinition(droite) && this.point2.appartientDroiteParDefinition(droite))
}

CMilieu.prototype.estDefiniParObjDs = function (listeOb) {
  return this.point1.estDefPar(listeOb) &&
  this.point2.estDefPar(listeOb)
}
