/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointParAbscisse = require('../objets/CPointParAbscisse')
const CPt = require('../objets/CPt')
const PtParAbsDlg = require('../dialogs/PtParAbsDlg')
const kernel = require('../kernel/kernel')

module.exports = CPointParAbscisse

CPointParAbscisse.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo16') + ' ' + this.abscisse.chaineInfo() + ' ' +
    kernel.getStr('chinfo32') + ' ' + '(' + this.origine.nom + ',' + this.extremite.nom + ')'
}

CPointParAbscisse.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.origine.depDe4Rec(p) || this.extremite.depDe4Rec(p) || this.abscisse.depDe4Rec(p))
}

CPointParAbscisse.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CPointParAbscisse.prototype.modifDlg = function (app, callBack1, callBack2) {
  new PtParAbsDlg(app, this, true, callBack1, callBack2)
}

CPointParAbscisse.prototype.appartientDroiteParDefinition = function (droite) {
  return CPt.prototype.appartientDroiteParDefinition.call(this, droite) ||
    (this.origine.appartientDroiteParDefinition(droite) && this.extremite.appartientDroiteParDefinition(droite))
}

CPointParAbscisse.prototype.estDefiniParObjDs = function (listeOb) {
  return this.origine.estDefPar(listeOb) &&
  this.extremite.estDefPar(listeOb) &&
  this.abscisse.estDefiniParObjDs(listeOb)
}
