/*
 * Created by yvesb on 21/03/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointParSommeVect = require('../objets/CPointParSommeVect')
const CPt = require('../objets/CPt')
const kernel = require('../kernel/kernel')
module.exports = CPointParSommeVect

CPointParSommeVect.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo217') + ' ' + kernel.getStr('chinfo218') + '(' +
    this.antecedent.nom + this.nom + ') = ' + kernel.getStr('chinfo218') + '(' +
    this.vecteur1.point1.nom + this.vecteur1.point2.nom + ') + ' +
    kernel.getStr('chinfo218') + '(' + this.vecteur2.point1.nom + this.vecteur2.point2.nom + ')'
}

CPointParSommeVect.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CPt.prototype.depDe4Rec.call(this, p) ||
    this.antecedent.depDe4Rec(p) || this.vecteur1.depDe4Rec(p) || this.vecteur2.depDe4Rec(p))
}

CPointParSommeVect.prototype.estDefiniParObjDs = function (listeOb) {
  return this.antecedent.estDefPar(listeOb) &&
  this.vecteur1.estDefPar(listeOb) &&
  this.vecteur2.estDefPar(listeOb)
}
