/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CProduitScalaire = require('../objets/CProduitScalaire')
const kernel = require('../kernel/kernel')
const CCalculAncetre = require('../objets/CCalculAncetre')
module.exports = CProduitScalaire

CProduitScalaire.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCalculAncetre.prototype.depDe4Rec.call(this, p) ||
    this.vect1.depDe4Rec(p) || this.vect2.depDe4Rec(p) ||
    this.listeProprietaire.pointeurLongueurUnite.depDe4Rec(p))
}

CProduitScalaire.prototype.infoHist = function () {
  var ch = this.getNom() + ' : ' + kernel.getStr('chinfo157') + ' ' + this.vect1.point1.nom + this.vect1.point2.nom + '\n' +
    kernel.getStr('chinfo158') + ' ' + this.vect2.point1.nom + this.vect2.point2.nom
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.prosca, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CProduitScalaire.prototype.estDefiniParObjDs = function (listeOb) {
  return this.vect1.estDefPar(listeOb) &&
  this.vect2.estDefPar(listeOb)
}
