/*
 * Created by yvesb on 28/11/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const CSolutionEquation = require('../objets/CSolutionEquation')
const kernel = require('../kernel/kernel')
const SolutionEqDlg = require('../dialogs/SolutionEqDlg')
const CCalculAncetre = require('../objets/CCalculAncetre')
module.exports = CSolutionEquation

CSolutionEquation.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CCalculAncetre.prototype.depDe4Rec.call(this, p) || this.a.depDe4Rec(p) ||
    this.b.depDe4Rec(p) || this.incertitude.depDe4Rec(p) || this.equation.depDe4Rec(p))
}

CSolutionEquation.prototype.infoHist = function () {
  var variable = new Array(2)
  variable[0] = this.inconnue
  var ch = this.getNom() + ' : ' + kernel.getStr('chinfo98') + ' ' + kernel.getStr('chinfo99') + ' ' +
    this.equation.chaineCalculSansPar(variable) + '\n' + kernel.getStr('chinfo100') + ' ' + this.a.chaineInfo() + ' ' +
    kernel.getStr('et') + ' ' + this.b.chaineInfo() + '\n' +
    kernel.getStr('chinfo102') + ' ' + this.incertitude.chaineInfo()
  if (this.existe) ch = ch + '\n' + kernel.getStr('chinfo97') + ' ' + kernel.chaineNombre(this.solution, 12)
  else ch = ch + '\n' + kernel.getStr('ch18')
  return ch
}

CSolutionEquation.prototype.modifiableParMenu = function () {
  return !this.estElementFinal
}

CSolutionEquation.prototype.modifDlg = function (app, callBack1, callBack2) {
  new SolutionEqDlg(app, this, true, callBack1, callBack2)
}

/**
 * Sert à savoir si un objet est défini uniquement par des objets figurant dans une liste
 * Attention : cette fonction est spéciale pour cet objet
 * En effet, un objet calcul descendant de CCAlculBase ne faisant référence
 * qu'à des constantes renvoie true dans EstDefiniParObjetDans
 * Il faut donc qu'en plus le calcul dépende d'au moins un des objets sources
 * @param listeOb
 * @returns {boolean}
 */
CSolutionEquation.prototype.estDefiniParObjDs = function (listeOb) {
  return this.dependDeAuMoinsUn(listeOb) && this.equation.estDefiniParObjDs(listeOb) &&
  this.a.estDefiniParObjDs(listeOb) &&
  this.b.estDefiniParObjDs(listeOb) &&
  this.incertitude.estDefiniParObjDs(listeOb)
}

// Ajout version 6.3.0. Utilisé pour les créations de contructions
CSolutionEquation.prototype.estConstantPourConst = function () {
  return this.a.estConstantPourConst() && this.b.estConstantPourConst() && this.incertitude.estConstantPourConst() && this.equation.estConstantPourConst()
}
