/*
 * Created by yvesb on 10/10/2016.
 */
// const $ = require('jQuery')
const $ = require('../global/jQuery-ui')

/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CSurfaceAncetre = require('../objets/CSurfaceAncetre')
const kernel = require('../kernel/kernel')
const StyleRemplissage = require('../types/StyleRemplissage')

module.exports = CSurfaceAncetre
/**
 * Fonction renvoyant true si lieu est un des bors de la surface.
 * @param {CLieuDeBase} lieu
 * Utilisé quand on change le nombre de points d'un lieu. Il faut alors recréer les tableaux
 * utilisé par les surfaces ayant lieu pour bord.
 * @returns {boolean}
 */
CSurfaceAncetre.prototype.aPourBord = function (lieu) {
  return false
}

CSurfaceAncetre.prototype.setOpacity = function (opacity) {
  $(this.g).css('fill-opacity', opacity)
}

CSurfaceAncetre.prototype.donneStyleRemplissage = function (svg, style) {
  this.styleRemplissage = style
  if (this.pattern !== null) document.getElementById('mtg32_patterns').removeChild(this.pattern)
  if (style !== StyleRemplissage.quadrillagePleinTransp && style !== StyleRemplissage.quadrillagePlein) { this.createPattern() } else this.pattern = null
}

CSurfaceAncetre.prototype.tikzFillStyle = function () {
  var tikzCoul = this.tikzCouleur()
  switch (this.styleRemplissage) {
    case StyleRemplissage.quadrillageHorizontal:
      return '[pattern = horizontal lines, pattern color=' + tikzCoul + ']'
    case StyleRemplissage.quadrillageVertical:
      return '[pattern = vertical lines, pattern color=' + tikzCoul + ']'
    case StyleRemplissage.quadrillage45Bas:
      return '[pattern = north west lines, pattern color=' + tikzCoul + ']'
    case StyleRemplissage.quadrillage45Haut:
      return '[pattern = north east lines, pattern color=' + tikzCoul + ']'
    case StyleRemplissage.quadrillagePlein:
      return '[color = ' + tikzCoul + ', opacity = 1' + ']'
    case StyleRemplissage.quadrillagePleinTransp:
      return '[color = ' + tikzCoul + ', opacity = ' + kernel.chaineNombre(this.listeProprietaire.documentProprietaire.opacity, 2) + ']'
    default:
      return ''
  }
}
