/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CSurfaceDisque = require('../objets/CSurfaceDisque')
const kernel = require('../kernel/kernel')
module.exports = CSurfaceDisque

CSurfaceDisque.prototype.peutGenererLieuObjet = function () {
  return true
}

CSurfaceDisque.prototype.distancePoint = function (xp, yp, masquage) {
  if (!this.existe || (masquage && this.masque)) return -1
  return this.cercle.distancePointPourSurface(xp, yp, masquage)
}

CSurfaceDisque.prototype.coincideAvec = function (p) {
  if (p.className !== 'CSurfaceDisque') return false
  return this.cercle.coincideAvec(p.cercle)
}

CSurfaceDisque.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  var list = this.listeProprietaire
  var cercle = this.cercle
  var x1 = list.tikzXcoord(cercle.centreX, dimf, bu)
  var y1 = list.tikzYcoord(cercle.centreY, dimf, bu)
  var ray = list.tikzLongueur(cercle.rayon, dimf, bu)
  return '\\fill ' + this.tikzFillStyle() + '(' + kernel.chaineNombre(x1, 3) + ',' +
    kernel.chaineNombre(y1, 3) + ') circle ' + '(' + kernel.chaineNombre(ray, 3) + ');'
}
