/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CSurfacePolygone = require('../objets/CSurfacePolygone')
const kernel = require('../kernel/kernel')
module.exports = CSurfacePolygone

CSurfacePolygone.prototype.infoHist = function () {
  return this.nom + ' : ' + kernel.getStr('chinfo60') + ' ' + this.bord.getNom()
}

CSurfacePolygone.prototype.peutGenererLieuObjet = function () {
  return true
}

CSurfacePolygone.prototype.distancePoint = function (xp, yp, masquage) {
  if (!this.existe || (masquage && this.masque)) return -1
  return this.polygone.distancePointPourSurface(xp, yp, masquage)
}

CSurfacePolygone.prototype.tikz = function (dimf, nomaff, coefmult, bu) {
  var i; var x; var y; var ch
  var list = this.listeProprietaire
  var polygone = this.polygone
  ch = '\\fill ' + this.tikzFillStyle() + '('
  for (i = 0; i < polygone.nombrePoints - 1; i++) {
    x = list.tikzXcoord(polygone.absPoints[i], dimf, bu)
    y = list.tikzYcoord(polygone.ordPoints[i], dimf, bu)
    ch += kernel.chaineNombre(x, 3) + ',' + kernel.chaineNombre(y, 3) + ')--('
  }
  i = polygone.nombrePoints - 1
  x = list.tikzXcoord(polygone.absPoints[i], dimf, bu)
  y = list.tikzYcoord(polygone.ordPoints[i], dimf, bu)
  ch += kernel.chaineNombre(x, 3) + ',' + kernel.chaineNombre(y, 3) + ')--cycle;'
  return ch
}
