/*
 * Created by yvesb on 16/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CValeurAffichee = require('../objets/CValeurAffichee')
const CAffLiePt = require('../objets/CAffLiePt')
const AffichageValeurDlg = require('../dialogs/AffichageValeurDlg')
const kernel = require('../kernel/kernel')
module.exports = CValeurAffichee

CValeurAffichee.prototype.info = function () {
  return this.nom + ' : ' + kernel.getStr('AffichageValeur') + ' ' + kernel.getStr('de') + ' ' + this.valeurAssociee.getNom()
}

CValeurAffichee.prototype.infoHist = function () {
  var ch = this.info()
  if (this.pointLie !== null) ch += ' ' + kernel.getStr('liea') + ' ' + this.pointLie.nom
  return ch + this.infoAngle()
}

CValeurAffichee.prototype.depDe4Rec = function (p) {
  if (this.elementTestePourDependDePourRec === p) return this.dependDeElementTestePourRec
  return this.memDep4Rec(CAffLiePt.prototype.depDe4Rec.call(this, p) ||
    this.valeurAssociee.depDe4Rec(p))
}

CValeurAffichee.prototype.modifiableParMenu = function () {
  return true // On peu modifier un affichage de valeur qui est élément final de construction
  // mais pas modifier la valeur à afficher
}

CValeurAffichee.prototype.modifDlg = function (app, callBack1, callBack2) {
  new AffichageValeurDlg(app, this, true, callBack1, callBack2)
}

/**
 * Fonction utilisée pour générer un nom pour le protocole de la figure
 * @returns : Le nom généré
 */
CValeurAffichee.prototype.genereNom = function () {
  CValeurAffichee.ind++
  return kernel.getStr('raffval') + CValeurAffichee.ind
}

CValeurAffichee.prototype.estDefiniParObjDs = function (listeOb) {
  return CAffLiePt.prototype.estDefiniParObjDs.call(this, listeOb) &&
  this.valeurAssociee.estDefPar(listeOb)
}
