/*
 * Created by yvesb on 10/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CVariableBornee = require('../objets/CVariableBornee')
const kernel = require('../kernel/kernel')
const VariableDlg = require('../dialogs/VariableDlg')
module.exports = CVariableBornee

CVariableBornee.prototype.info = function () {
  return this.nomCalcul + ' : ' + kernel.getStr('Variable')
}

CVariableBornee.prototype.infoHist = function () {
  return this.nomCalcul + ' : ' + kernel.getStr('Variable') + '\n' +
    kernel.getStr('chinfo77') + ' ' + kernel.chaineNombre(this.valeurMini, 12) + '\n' +
    kernel.getStr('chinfo78') + ' ' + kernel.chaineNombre(this.valeurMaxi, 12) + '\n' +
    kernel.getStr('chinfo79') + ' ' + kernel.chaineNombre(this.valeurPas, 12) + '\n' +
    kernel.getStr('chinfo80') + ' ' + kernel.chaineNombre(this.valeurActuelle, 12)
}

CVariableBornee.prototype.modifiableParMenu = function () {
  return true
}

CVariableBornee.prototype.modifDlg = function (app, callBack1, callBack2) {
  new VariableDlg(app, this, true, callBack1, callBack2)
}

CVariableBornee.onClickEgal = function () {
  var list = this.listeProprietaire
  var app = list.documentProprietaire.app
  var self = this
  new VariableDlg(app, this, true, function () {
    list.metAJour() // Pour mettre à jour les calculs de dérivées
    list.positionneDependantsDe(false, app.dimf, self)
    app.listePr.updateDependants(self, app.svgFigure, app.doc.couleurFond, app.doc.opacity, true)
    self.updateDisplay()
  }, null)
}

CVariableBornee.prototype.estDefiniParObjDs = function (listeOb) {
  // Modifié version 6.3.0 car si un objet final dépend dune variable qui n'est pas un objet source, elle sera rajoutée
  // aux éléments intermédiaires.
  // return (listeOb.contains(this));
  return true
}
