/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CAbscisseOrigineRep = require('../objets/CAbscisseOrigineRep')
const InfoRepDlg = require('../dialogs/InfoRepDlg')
const NatCal = require('../types/NatCal')
module.exports = OutilAbsOrRep

function OutilAbsOrRep (app) {
  Outil.call(this, app, 'AbsOrRep', 32031, false, false)
}
OutilAbsOrRep.prototype = new Outil()

OutilAbsOrRep.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  var list = app.listePr
  var calc = new CAbscisseOrigineRep(list, null, false, '', list.premierRepVis())
  new InfoRepDlg(app, calc, 0, false, null, null)
  this.app.activeOutilCapt()
}

OutilAbsOrRep.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NRepere) > 0
}
