/*
 * Created by yvesb on 13/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
module.exports = OutilAdd

/**
 * Outil servant à créer un outil permettant d'activer des outils supplémentaires via une boîte de dialogue
 * @param app Application propriétaire
 * @param {string} toolName Le nom de l'outil
 * @param {array} toolArray array contenant les noms des outils que cet outil propose.
 * @constructor
 */
function OutilAdd (app, toolName, toolArray) {
  Outil.call(this, app, toolName, -1, false)
  this.toolArray = toolArray
}
OutilAdd.prototype = new Outil()

OutilAdd.prototype.activationValide = function () {
  for (var i = 0; i < this.toolArray.length; i++) {
    var tool = this.app['outil' + this.toolArray[i]]
    if ((tool.activationValide() && this.app.doc.toolDispo(tool.toolIndex) && this.app.level.toolDispo(tool.toolIndex))) return true
  }
  return false
}
