/*
 * Created by yvesb on 24/06/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CCentreCercle = require('../objets/CCentreCercle')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')
module.exports = OutilCentreCercle

/**
 * Outil servant à créer le centre d'un cercle
 * @param app L'application propriétaire
 * @constructor
 */
function OutilCentreCercle (app) {
  OutilObjetPar1Objet.call(this, app, 'CentreCercle', 33155, true, NatObj.NCercle)
}

OutilCentreCercle.prototype = new OutilObjetPar1Objet()

OutilCentreCercle.prototype.indication = function () {
  return 'indCer'
}

OutilCentreCercle.prototype.objet = function (cer) {
  var app = this.app
  return new CCentreCercle(app.listePr, null, false, app.getCouleur(), false, 0, 3, false, '',
    app.getTaillePoliceNom(), app.getStylePoint(), false, cer)
}

// Pas d'objets visuels pour cet outil
OutilCentreCercle.prototype.ajouteObjetsVisuels = function () {
}

OutilCentreCercle.prototype.isReadyForTouchEnd = function () {
  return false
}
