/*
 * Created by yvesb on 22/09/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CCercleOAB = require('../objets/CCercleOAB')
const OutilObjetPar3Pts = require('./OutilObjetPar3Pts')
const CVecteur = require('../objets/CVecteur')
const Color = require('../types/Color')
const StyleTrait = require('../types/StyleTrait')
const StyleFleche = require('../types/StyleFleche')
module.exports = OutilCerOAB
/**
 * Outil servant à créer un cercle défini apr centre et point
 * @param app L'application mtgApp propriétaire
 * @constructor
 */
function OutilCerOAB (app) {
  OutilObjetPar3Pts.call(this, app, 'CerOAB', 33001, true)
}

OutilCerOAB.prototype = new OutilObjetPar3Pts()

OutilCerOAB.prototype.indication = function (ind) {
  switch (ind) {
    case 1 : return 'indRay1'
    case 2 : return 'indRay2'
    case 3 : return 'indCentre'
  }
}

OutilCerOAB.prototype.objet = function (pt1, pt2, pt3) {
  var app = this.app
  return new CCercleOAB(app.listePr, null, false, app.getCouleur(), false, app.getStyleTrait(), pt3, pt1, pt2)
}

/**
 * Fonction renvoyant true si l'outil accepte qu'on crée un point par défaut lors d'un clic sur un endroit vide
 */
OutilCerOAB.prototype.creationPointPossible = function () {
  return true
}

OutilCerOAB.prototype.ajouteObjetsVisuels = function () {
  var app = this.app
  var list = app.listeObjetsVisuels
  var b = Color.black
  var stfp = StyleTrait.stfp(list)
  var vect1 = new CVecteur(list, null, false, b, false, stfp, this.point1, this.point2, StyleFleche.FlecheLonguePleine)
  app.ajouteObjetVisuel(vect1)
  var vect2 = new CVecteur(list, null, false, b, false, stfp, this.point2, this.point1, StyleFleche.FlecheLonguePleine)
  app.ajouteObjetVisuel(vect2)
  var cer = new CCercleOAB(list, null, false, b, false, stfp, app.mousePoint, this.point1, this.point2)
  app.ajouteObjetVisuel(cer)
  app.afficheObjetVisuels(0) // Ajout version 6.4.4
}
