/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const ChoixFinNumDlg = require('../dialogs/ChoixFinNumDlg')
module.exports = OutilChoixFinNumConst

function OutilChoixFinNumConst (app) {
  // Attention : Pour cet outil le troisième pramètre est "CreationConst" pour que l'icône de app.outilGestionConst soit
  // désactivée quand on désactive l'outil (cet outil n'a pas d'icône)
  Outil.call(this, app, 'CreationConst', -1, false, true)
}

OutilChoixFinNumConst.prototype = new Outil()

OutilChoixFinNumConst.prototype.select = function () {
  var app = this.app
  new ChoixFinNumDlg(app)
}

OutilChoixFinNumConst.prototype.activationValide = function () {
  var app = this.app
  return app.listeSrcG.longueur() > 0 || app.listeSrcNG.longueur() > 0
}
