/*
 * Created by yvesb on 21/01/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const CDroiteOm = require('../objets/CDroiteOm')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')
const CoefDirDlg = require('../dialogs/CoefDirDlg')
const CValeur = require('../objets/CValeur')
const AvertDlg = require('../dialogs/AvertDlg')
module.exports = OutilDtParCoef
/**
 * Outil servant à créer une droite horizontale
 * @param app L'application propriétaire
 * @constructor
 */
function OutilDtParCoef (app) {
  OutilObjetPar1Objet.call(this, app, 'DtParCoef', 32869, true, NatObj.NTtPoint)
}

OutilDtParCoef.prototype = new OutilObjetPar1Objet()

OutilDtParCoef.prototype.indication = function () {
  return 'indPt'
}

/*
OutilDtParCoef.prototype.objet = function(pt) {
  var app = this.app;
  return new CDroiteOm(app.listePr, null,false, app.getCouleur(), false, 0, 0, false, "", 16, app.getStyleTrait(), 0.9, this.rep, pt);
};
*/

OutilDtParCoef.prototype.traiteObjetDesigne = function (elg) {
  var app = this.app
  var list = app.listePr
  this.dt = new CDroiteOm(list, null, false, app.getCouleur(), false, 0, 0, false, '', app.getTaillePoliceNom(),
    app.getStyleTrait(), 0.9, list.premierRepVis(), elg, new CValeur(list, 0))
  var self = this
  new CoefDirDlg(app, this.dt, false, function () { self.callBackOK() }, function () { self.reselect() })
}

OutilDtParCoef.prototype.ajouteObjetsVisuels = function () {}

/**
 * Fonction de callback créant l'objet si la boîte de dialoge a été validée
 */
OutilDtParCoef.prototype.callBackOK = function () {
  var app = this.app
  app.ajouteElement(this.dt)
  if (app.verifieDernierElement(1)) {
    // L'élément créé existe bien et a été ajouté à la liste
    this.dt.creeAffichage(this.app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    this.annuleClignotement()
    this.saveFig()
    this.nbPtsCrees = 0
    this.reselect()
  } else new AvertDlg(app, 'DejaCree')
}

/**
 * Fonction renvoyant true si l'outil accepte qu'on crée un point par défaut lors d'un clic sur un endroit vide
 */
OutilDtParCoef.prototype.creationPointPossible = function () {
  return true
}
