/*
 * Created by yvesb on 13/02/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

const OutilLieuParPtLieAncetre = require('./OutilLieuParPtLieAncetre')
const CLieuDiscretParPointLie = require('../objets/CLieuDiscretParPointLie')
const LieuDlg = require('../dialogs/LieuDlg')
module.exports = OutilLieuDiscretParPtLie

/**
 * Outil servant à créer un lieu de points discret généré par un point lié
 * @param app L'application propriétaire
 * @constructor
 */
function OutilLieuDiscretParPtLie (app) {
  OutilLieuParPtLieAncetre.call(this, app, 'LieuDiscretParPtLie', 33004)
}

OutilLieuDiscretParPtLie.prototype = new OutilLieuParPtLieAncetre()

OutilLieuDiscretParPtLie.prototype.creeObjet = function () {
  var app = this.app
  var list = app.listePr
  var self = this
  this.lieu = new CLieuDiscretParPointLie(list, null, false, app.getCouleur(), false, this.pointPourTrace, 200,
    app.getStylePoint(), this.pointLieGenerateur)
  new LieuDlg(app, this.lieu, false, function () { self.actionApresDlgOK() }, function () { self.app.activeOutilCapt() })
}
