/*
 * Created by yvesb on 03/01/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CLongueur = require('../objets/CLongueur')
const OutilPar2Pts = require('./OutilPar2Pts')
const AvertDlg = require('../dialogs/AvertDlg')
const kernel = require('../kernel/kernel')

module.exports = OutilLongUnit
/**
 * Outil servant à mesurer en cliquant sur deux points de la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilLongUnit (app) {
  OutilPar2Pts.call(this, app, 'LongUnit', 32843, true)
}

OutilLongUnit.prototype = new OutilPar2Pts()

OutilLongUnit.prototype.select = function () {
  this.app.outilPointageActif = this.app.outilPointageCre
  OutilPar2Pts.prototype.select.call(this) // A appeler à la fin
}

OutilLongUnit.prototype.preIndication = function () {
  return 'LongUnit'
}

OutilLongUnit.prototype.creeObjet = function () {
  this.annuleClignotement()
  var app = this.app
  var li = app.listePr
  var lon = new CLongueur(li, null, false, this.point1, this.point2)
  li.pointeurLongueurUnite = lon
  app.ajouteElement(lon)
  new AvertDlg(this.app, kernel.getStr('AvertLu1') + this.point1.nom + this.point2.nom + kernel.getStr('AvertLu2'))
  this.saveFig()
  this.objetCree = true
  app.activeOutilCapt()
  return true
}

OutilLongUnit.prototype.activationValide = function () {
  return this.app.listePr.pointeurLongueurUnite === null
}

OutilLongUnit.prototype.nomsPointsIndisp = function () {
  return true
}
