/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const OutilMac = require('./OutilMac')
const CMacroBoucleAvecAnimation = require('../objets/CMacroBoucleAvecAnimation')
const CAffLiePt = require('../objets/CAffLiePt')
const MacBoucDlg = require('../dialogs/MacBoucDlg')

module.exports = OutilMacBoucAnim

/**
 * Outil servant à créer une macro affectant une valeur à une variable
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMacBoucAnim (app) {
  if (arguments.length === 0) return
  OutilMac.call(this, app, 'MacBoucAnim', 33031)
}

OutilMacBoucAnim.prototype = new OutilMac()

OutilMacBoucAnim.prototype.traiteObjetDesigne = function (elg, point) {
  var self = this
  var app = this.app
  var list = app.listePr
  this.addComClign(point)
  this.mac = new CMacroBoucleAvecAnimation(list, null, false, app.getCouleur(), point.x, point.y, 0, 0, false, null, 16,
    false, app.doc.couleurFond, CAffLiePt.alignHorLeft,
    CAffLiePt.alignVerTop, '', '', 10, true, null, null, null)
  new MacBoucDlg(app, this.mac, false,
    function () {
      self.creeObjet()
      app.activeOutilCapt()
    },
    function () {
      app.activeOutilCapt()
    })
}
