/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const OutilMacAppParAut = require('../outils/OutilMacAppParAut')
const CMacroDisparition = require('../objets/CMacroDisparition')
const CAffLiePt = require('../objets/CAffLiePt')

module.exports = OutilMacDispParAut

/**
 * Outil servant à mesurer en cliquant sur deux points de la figure
 * @param app L'application propriétaire
 * @constructor
 */
function OutilMacDispParAut (app) {
  OutilMacAppParAut.call(this, app)
}

OutilMacDispParAut.prototype = new OutilMacAppParAut()

/**
 * Fonction qui sera redéfinie dans OutilMacDispParAut et renverra false
 * @returns {boolean}
 */
OutilMacDispParAut.prototype.isMacApp = function () {
  return false
}

/**
 * Fonction créant la macro qui sera redéfinie dans OutilMacDis^p
 * @param point
 */
OutilMacDispParAut.prototype.createMac = function (point) {
  var app = this.app
  return new CMacroDisparition(app.listePr, null, false, app.getCouleur(), point.x, point.y,
    0, 0, false, null, 16, false, app.doc.couleurFond, CAffLiePt.alignHorLeft,
    CAffLiePt.alignVerTop, '', '', null)
}
