/*
 * Created by yvesb on 03/04/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CMinFonc = require('../objets/CMinFonc')
const MaxMinDlg = require('../dialogs/MaxMinDlg')
const NatCal = require('../types/NatCal')
const CValeur = require('../objets/CValeur')

module.exports = OutilMin

function OutilMin (app) {
  Outil.call(this, app, 'Min', 32024)
}
OutilMin.prototype = new Outil()

OutilMin.prototype.select = function () {
  Outil.prototype.select.call(this)
  var list = this.app.listePr
  var Min = new CMinFonc(list, null, false, '', null, new CValeur(list, 0), new CValeur(list, 0), new CValeur(list, 0))
  new MaxMinDlg(this.app, Min, false, false, null, null)
  this.app.activeOutilCapt()
}

OutilMin.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NFonction) > 0
}
