/*
 * Created by yvesb on 07/02/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
module.exports = OutilOutilModePointsAuto

/**
 * Outil servant à basculer entre le mode trace active et non active
 * @param app L'application propriétaire
 * @constructor
 */
function OutilOutilModePointsAuto (app) {
  Outil.call(this, app, 'ModePointsAuto', -1, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilOutilModePointsAuto.prototype = new Outil()

OutilOutilModePointsAuto.prototype.select = function () {
  var app = this.app
  app.pref_PointsAuto = !app.pref_PointsAuto
  const btn = this.app['button' + this.toolName]
  btn.activate(app.pref_PointsAuto)
  // Cette option est mémorisée pour la version electron
  if (app.electron) setPointsAuto(app.pref_PointsAuto) // eslint-disable-line no-undef
}
