/*
 * Created by yvesb on 06/01/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const ModificationObjNumDlg = require('../dialogs/ModificationObjNumDlg')
const AvertDlg = require('../dialogs/AvertDlg')
const NatCal = require('../types/NatCal')
module.exports = OutilModifObjNum

/**
 * Outil servant à modifier un objet qui a été créé par un menu
 * @param app L'application propriétaire
 * @constructor
 */
function OutilModifObjNum (app) {
  Outil.call(this, app, 'ModifObjNum', 32023, true, true)
}

OutilModifObjNum.prototype = new Outil()

OutilModifObjNum.prototype.select = function () {
  var app = this.app
  if (app.estExercice && !this.existeObjNumModifiable()) {
    new AvertDlg(app, 'NoObjNum', function () {
      app.activeOutilCapt()
    })
    return
  }
  Outil.prototype.select.call(this)
  new ModificationObjNumDlg(app, function () {
    app.activeOutilCapt()
  })
}

OutilModifObjNum.prototype.existeObjNumModifiable = function () {
  var app = this.app
  var list = app.listePr
  for (var i = app.nbObjInit; i < list.longueur(); i++) {
    var el = list.get(i)
    if (el.estDeNatureCalcul(NatCal.NTteValROuC) && el.modifiableParMenu()) return true
  }
  return false
}
