/*
 * Created by yvesb on 26/12/2016.
 */

/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const NewFigDlg = require('../dialogs/NewFigDlg')
const ConfirmDlg = require('../dialogs/ConfirmDlg')
module.exports = OutilNew
/**
 * Outil servant à modifier un objet qui a été créé par un menu
 * @param app L'application propriétaire
 * @constructor
 */
function OutilNew (app) {
  Outil.call(this, app, 'New', -1, false, true, app.newFig)
}

OutilNew.prototype = new Outil()

OutilNew.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  app.termineMacroEnCours() // Ajout version 6.4.1
  app.activeOutilCapt() // Ajout version 6.4.1 pour éviter plantages si par ex l'outil rideau est actiF

  // On regarde si on est en mode electron. Si oui on avertit si la figure n'a pas été sauvegardée
  if (app.doc.isDirty && app.electron) {
    new ConfirmDlg(app, 'AvertDirty', function () {
      new NewFigDlg(app, function () {
        app.activeOutilDem()
        app.reInitConst() // Pour réinitialiser une éventuelle construction en cours
        // Si on est dans la version electron on remet à zéro le document
        // resetDocument est une fonction de la page index.html de la version electron
        resetDocument() // eslint-disable-line no-undef
        app.gestionnaire.initialise()
      }, function () { app.activeOutilCapt() })
    })
  } else {
    new NewFigDlg(app, function () {
      app.activeOutilDem()
      app.reInitConst() // Pour réinitialiser une éventuelle construction en cours
      if (app.electron) {
        resetDocument() // eslint-disable-line no-undef
        app.gestionnaire.initialise()
      }
    }, function () { app.activeOutilCapt() })
  }
}
