/*
 * Created by yvesb on 27/09/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const OutilPar3Pts = require('./OutilPar3Pts')
const AvertDlg = require('../dialogs/AvertDlg')

module.exports = OutilObjetPar3Pts

/**
 *
 * Outil servant à créer un objet graphqie en cliquant sur trois points de la figure
 * Hérite de OutilPar3Pts
 * @param app L'application propriétaire
 * @param toolName Le nom de l'outil
 * @param toolIndex L'index de l'outil dans la version Java
 * @param avecClig Boolean : true si l'outil utilise le clignotement
 * @constructor
 */
function OutilObjetPar3Pts (app, toolName, toolIndex, avecClig) {
  OutilPar3Pts.call(this, app, toolName, toolIndex, avecClig)
}

OutilObjetPar3Pts.prototype = new OutilPar3Pts()
OutilObjetPar3Pts.prototype.constructor = OutilObjetPar3Pts

OutilObjetPar3Pts.prototype.select = function () {
  OutilPar3Pts.prototype.select.call(this)
  this.app.outilPointageActif = this.app.outilPointageCre
  this.app.outilPointageActif.aDesigner = NatObj.NTtPoint
  this.app.outilPointageActif.reset()
}

OutilObjetPar3Pts.prototype.creeObjet = function () {
  var app = this.app
  var ob = this.objet(this.point1, this.point2, this.point3)
  app.ajouteElement(ob)
  var verif = app.verifieDernierElement(1)
  if (verif) {
    // L'élément créé existe bien et a été ajouté à la liste
    ob.creeAffichage(this.app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    this.annuleClignotement()
    this.saveFig()
    this.nbPtsCrees = 0
  } else new AvertDlg(app, 'DejaCree')
  return verif
}

OutilObjetPar3Pts.prototype.ajouteObjetsVisuels = function () {
  var app = this.app
  var ob = this.objet(this.point1, this.point2, app.mousePoint)
  app.ajouteObjetVisuel(ob)
  app.afficheObjetVisuels(0) // Ajout version 6.4.4
}
