/*
 * Created by yvesb on 25/12/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const CPointProjete = require('../objets/CPointProjete')
const OutilParDtPt = require('./OutilParDtPt')
const Cpt = require('../objets/CPt')
const Color = require('../types/Color')
const CMarqueAngleGeometrique = require('../objets/CMarqueAngleGeometrique')
const CSegment = require('../objets/CSegment')
const StyleTrait = require('../types/StyleTrait')
const StyleMarqueAngle = require('../types/StyleMarqueAngle')
module.exports = OutilProj
/**
 * Outil servant à créer une droite parallèle
 * @param app L'application propriétaire
 * @constructor
 */
function OutilProj (app) {
  OutilParDtPt.call(this, app, 'Proj', 32780, true)
}

OutilProj.prototype = new OutilParDtPt()

OutilProj.prototype.indication = function (ind) {
  switch (ind) {
    case 1 : return 'indProj1'
    case 2 : return 'indProj2'
  }
}

OutilProj.prototype.preIndication = function () {
  return 'Proj'
}

/**
 * Spécial version mtgApp. Renvoie l'objet à créer
 * Sera redéifni pour les descendants
 * @param pt
 * @param dt
 */
OutilProj.prototype.objet = function (pt, dt) {
  var app = this.app
  return new CPointProjete(app.listePr, null, false, app.getCouleur(), false, 0, 3, false, '', app.getTaillePoliceNom(),
    app.getStylePoint(), false, pt, dt)
}

OutilProj.prototype.ajouteObjetsVisuels = function () {
  var app = this.app
  var list = app.listeObjetsVisuels
  var b = Color.black
  var stfc = StyleTrait.stfc(list)
  var stfp = StyleTrait.stfp(list)
  var ptproj = this.objet(this.app.mousePoint, this.droite1)
  app.ajouteObjetVisuel(ptproj)
  // On crée un point qui représente un point de l'objet sur lequel on veut projeter
  var pt = new Cpt(list, null, false, b, true, 0, 0, true, '', 0, 0, false)
  pt.placeEn(this.droite1.point_x, this.droite1.point_y)
  app.ajouteObjetVisuel(pt)
  var seg = new CSegment(list, null, false, b, false, stfp, app.mousePoint, ptproj)
  app.ajouteObjetVisuel(seg)
  var ma = new CMarqueAngleGeometrique(list, null, false, b, false, stfc, StyleMarqueAngle.marqueSimple,
    12, pt, ptproj, app.mousePoint)
  app.ajouteObjetVisuel(ma)
  app.afficheObjetVisuels(0) // Ajout version 6.4.4
}
