/*
 * Created by yvesb on 25/03/2017.
 */
/**
 * Outil servant à créer un point défini par son abscisse relativement à deux autres
 * Si les points ne sont pas nommés, un nom leur sera attribué
 * @param app L'application propriétaire
 * @constructor
 */
const OutilPar2Pts = require('../outils/OutilPar2Pts')
const CValeur = require('../objets/CValeurAngle')
const CPointParAbscisse = require('../objets/CPointParAbscisse')
const PtParAbsDlg = require('../dialogs/PtParAbsDlg')
const CConstante = require('../objets/CConstante')
const AvertDlg = require('../dialogs/AvertDlg')
module.exports = OutilPtParAbs

function OutilPtParAbs (app, toolName, toolIndex, avecClig) {
  // Dernier  paramètre false pour que ce ne soit pas OutilPar2Pts qui appelle reselect() car il ne aut pas appeler
  // reselecct() avant qua la oîte de dialogue ne femrme
  OutilPar2Pts.call(this, app, 'PtParAbs', 32889, true, false)
}

OutilPtParAbs.prototype = new OutilPar2Pts()

OutilPtParAbs.prototype.select = function () {
  this.app.outilPointageActif = this.app.outilPointageCre
  OutilPar2Pts.prototype.select.call(this) // A appeler à la fin
}

OutilPtParAbs.prototype.indication = function (ind) {
  switch (ind) {
    case 1: return 'intPtParAbs1'
    case 2: return 'intPtParAbs2'
  }
}

OutilPtParAbs.prototype.nomsPointsIndisp = function () {
  return true
}

OutilPtParAbs.prototype.creeObjet = function () {
  var app = this.app
  var self = this
  // if (app.lastDlgId() === "angleArcDlg") return;
  var li = app.listePr
  var abs = new CValeur(li, new CConstante(li, 1))
  this.pt = new CPointParAbscisse(li, null, false, app.getCouleur(), false, 0, 3, false, '', app.getTaillePoliceNom(),
    app.getStylePoint(), false, this.point1, this.point2, abs)
  new PtParAbsDlg(this.app, this.pt, false, function () { self.actionApresDlgOK() }, function () { self.reselect() })
}

OutilPtParAbs.prototype.actionApresDlgOK = function () {
  var app = this.app
  var self = this
  app.ajouteElement(this.pt)
  if (app.verifieDernierElement(1)) {
    this.objetCree = true // Por  que les noms attribués ne disparaissent pas
    this.pt.creeAffichage(app.svgFigure, false, app.doc.couleurFond, app.doc.opacity)
    this.annuleClignotement() // Pour que le centre clignotant ne soit pas enregistré comme caché
    this.saveFig()
    this.reselect()
  } else {
    new AvertDlg(app, 'DejaCree', function () {
      self.reselect()
    })
  }
}
