/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
module.exports = OutilReInitConst

function OutilReInitConst (app) {
  // Attention : Pour cet outil le troisième pramètre est "CreationConst" pour que l'icône de app.outilGestionConst soit
  // désactivée quand on désactive l'outil (cet outil n'a pas d'icône)
  Outil.call(this, app, 'CreationConst', -1, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilReInitConst.prototype = new Outil()

OutilReInitConst.prototype.select = function () {
  var app = this.app
  app.reInitConst()
  app.activeOutilCapt()
}

OutilReInitConst.prototype.activationValide = function () {
  var app = this.app
  return app.listeSrcG.longueur() > 0 || app.listeSrcNG.longueur() > 0
}
