/*
 * Created by yvesb on 18/01/2017.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const NatObj = require('../types/NatObj')
const Nat = require('../types/Nat')
const OutilObjetPar1Objet = require('./OutilObjetPar1Objet')
const CSurfacePolygone = require('../objets/CSurfacePolygone')
const CSurfaceDisque = require('../objets/CSurfaceDisque')
const CSurfaceSecteurCirculaire = require('../objets/CSurfaceSecteurCirculaire')
const CSurfaceLieu = require('../objets/CSurfaceLieu')
module.exports = OutilSurface

/**
 * Outil servant à créer une surface délimitée par un polygône, un cercle, un arc de cercle ou un lieu fermé
 * @param app L'application propriétaire
 * @constructor
 */
function OutilSurface (app) {
  OutilObjetPar1Objet.call(this, app, 'Surface', 32866, true, Nat.or(NatObj.NPolygone, NatObj.NCercle, NatObj.NArc, NatObj.NLieu))
}

OutilSurface.prototype = new OutilObjetPar1Objet()

OutilSurface.prototype.indication = function () {
  return 'indSurface'
}

OutilSurface.prototype.objet = function (pt) {
  var app = this.app
  var li = app.listePr
  var coul = app.getCouleur()
  var style = app.getStyleRemplissage()
  switch (pt.getNature()) {
    case NatObj.NPolygone :
      return new CSurfacePolygone(li, null, false, coul, false, style, pt)
    case NatObj.NCercle :
      return new CSurfaceDisque(li, null, false, coul, false, style, pt)
    case NatObj.NArc :
      return new CSurfaceSecteurCirculaire(li, null, false, coul, false, style, pt)
    case NatObj.NLieu :
      return new CSurfaceLieu(li, null, false, coul, false, style, pt)
  }
}

OutilSurface.prototype.ajouteObjetsVisuels = function () { // Rien pour cet outil
}
