/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('./Outil')
const CUnitexRep = require('../objets/CUnitexRep')
const InfoRepDlg = require('../dialogs/InfoRepDlg')
const NatCal = require('../types/NatCal')
module.exports = OutilUnitexRep

function OutilUnitexRep (app) {
  Outil.call(this, app, 'UnitexRep', 32033, false, false)
}
OutilUnitexRep.prototype = new Outil()

OutilUnitexRep.prototype.select = function () {
  Outil.prototype.select.call(this)
  var app = this.app
  var list = app.listePr
  var calc = new CUnitexRep(list, null, false, '', list.premierRepVis())
  new InfoRepDlg(app, calc, 2, false, null, null)
  this.app.activeOutilCapt()
}

OutilUnitexRep.prototype.activationValide = function () {
  return this.app.listePr.nombreObjetsCalcul(NatCal.NRepere) > 0
}
