/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */
const Outil = require('../outils/Outil')
const AvertDlg = require('../dialogs/AvertDlg')
const kernel = require('../kernel/kernel')
module.exports = OutilCopy
/**
 * Outil servant à modifier un objet qui a été créé par un menu
 * @param app L'application propriétaire
 * @constructor
 */
function OutilCopy (app) {
  Outil.call(this, app, '', 'Copy', -1, false, false) // Le dernier false car l'outil n'est pas sélectionnable
}

OutilCopy.prototype = new Outil()

OutilCopy.prototype.select = function () {
  // Ici il faut appeler une fontion de callBack pour que copy ne soit appelé que lorsque les données
  // sont prêtes.
  // savePNG est une fonction globale de la page index.html pour la version electron
  var app = this.app
  app.getBase64ImageData('png', function (data) { copy(data) }, app.pref_coefMult, 1) // eslint-disable-line no-undef
  new AvertDlg(app, kernel.getStr('CopyOK'))
  //
}
