/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

/**
 * Contient les textes utilisés dans le logiciel
 * @typedef Textes
 * @type {object}
 */
/**
 * Les textes utilisés dans le logiciel en langue anglaise
 * @type {Textes}
 * @private
 */
const textesEn = {
  step: 'step',
  var1: 'New value for variable ',
  var2: 'Enter a value between ',
  et: ' and ',
  // Chaînes servant suivant la langue à reconstruire les formules mathématiques
  abs: 'abs',
  intgr: 'int',
  sqrt: 'sqrt',
  rac: 'sqrt',
  sin: 'sin',
  cos: 'cos',
  tan: 'tan',
  ln: 'ln',
  lnlat: '\\ln',
  exp: 'exp',
  arctan: 'atan',
  arctanlat: 'atan',
  arccos: 'acos',
  arccoslat: 'acos',
  arcsin: 'asin',
  arcsinlat: 'asin',
  ch: 'cosh',
  chlat: '\\cosh',
  sh: 'sinh',
  shlat: '\\sinh',
  th: 'tanh',
  thlat: '\\tanh',
  argch: 'acosh',
  argsh: 'asinh',
  argth: 'atanh',
  rand: 'rand',
  conj: 'conj',
  arg: 'arg',
  re: 're',
  im: 'im',

  maxi: 'max',
  mini: 'min',
  gcd: 'gcd',
  lcm: 'lcm',
  ncr: 'nCr',
  npr: 'nPr',
  mod: 'mod',
  si: 'if',
  integrale: 'integral',
  primitive: 'primitive',
  fact: 'fact',
  somme: 'sum',
  produit: 'prod',
  left: 'left',
  right: 'right',
  transp: 'transp',
  deter: 'deter',
  dotmult: 'dotmult',
  inv: 'inv',
  frac: 'frac'
}

module.exports = textesEn
