/*
 * Created by yvesb on 22/10/2016.
 */
/*
 * MathGraph32 Javascript : Software for animating online dynamic mathematics figures
 * http://www.mathgraph32.org/
 * @Author Yves Biton (yves.biton@sesamath.net)
 * @License: GNU AGPLv3 https://www.gnu.org/licenses/agpl-3.0.html
 */

//
const NatCal = require('./NatCal')
const Nat = require('./Nat')

NatCal.NFonctionReelle1Variable = Nat.or(NatCal.NFonction, NatCal.NDerivee)

NatCal.NTtObjNum = Nat.or(NatCal.NTteValR, NatCal.NTteValC
  , NatCal.NFoncouSuiteR, NatCal.NFoncouSuiteC, NatCal.NRepere, NatCal.NTteMatrice)

/*
NatCal.NTtObjNumPourReclass = Nat.or(NatCal.NTteValRouCSaufConst
  , NatCal.NTteFoncRouC ,  NatCal.NSuiteRecurrenteReelle , NatCal.NSuiteRecurrenteReelle2
  , NatCal.NSuiteRecurrenteReelle3 , NatCal.NSuiteRecurrenteComplexe
  , NatCal.NRepere , NatCal.NSuiteRecurrenteComplexe2 , NatCal.NSuiteRecurrenteComplexe3);
*/

NatCal.NTteFoncRouCSaufDer = Nat.or(NatCal.NFonction, NatCal.NFoncPlusieursVar
  , NatCal.NFonctionComplexe, NatCal.NFoncCPlusieursVar)

// Version 6.7 : Les matrices peuvent aussi être objets sources numériques
NatCal.NObjCalcPourSourcesProtoSaufRep = Nat.or(NatCal.NCalculReel, NatCal.NCalculComplexe
  , NatCal.NSuiteRecurrenteReelle, NatCal.NSuiteRecurrenteReelle2, NatCal.NSuiteRecurrenteReelle3
  , NatCal.NSuiteRecurrenteComplexe, NatCal.NSuiteRecurrenteComplexe2, NatCal.NSuiteRecurrenteComplexe3
  , NatCal.NVariable, NatCal.NTteFoncRouCSaufDer, NatCal.NTteMatrice
)

NatCal.NObjCalcPourSourcesProto = Nat.or(NatCal.NObjCalcPourSourcesProtoSaufRep, NatCal.NRepere)

/*
NatCal.NObjCalcPourSourcesProtoSaufRep = Nat.or(NatCal.NCalculReel , NatCal.NCalculComplexe
  , NatCal.NSuiteRecurrenteReelle , NatCal.NSuiteRecurrenteReelle2 , NatCal.NSuiteRecurrenteReelle3
  , NatCal.NSuiteRecurrenteComplexe , NatCal.NSuiteRecurrenteComplexe2 , NatCal.NSuiteRecurrenteComplexe3
  , NatCal.NVariable , NatCal.NTteFoncRouCSaufDer);
*/

NatCal.NTtObjNumSaufConst = Nat.or(NatCal.NTteValRSaufConst
  , NatCal.NTteValC, NatCal.NFoncouSuiteR
  , NatCal.NFoncouSuiteC, NatCal.NRepere, NatCal.NTteMatrice)

/*
NatCal.NObjetCalculSourcePourConst = Nat.or(NatCal.NCalculReel , NatCal.NCalculComplexe
  , NatCal.NSuiteRecurrenteReelle, NatCal.NSuiteRecurrenteReelle2
  , NatCal.NSuiteRecurrenteReelle3, NatCal.NSuiteRecurrenteComplexe
  , NatCal.NSuiteRecurrenteComplexe2, NatCal.NSuiteRecurrenteComplexe3, NatCal.NVariable
  , NatCal.NTteFoncRouC);
*/

/*
NatCal.NObjFinalNumerique = Nat.or(NatCal.NVariable
  , NatCal.NCalculReel , NatCal.NCalculReelConstant
  , NatCal.NSolutionEquation , NatCal.NIntegrale, NatCal.NTestExistence
  , NatCal.NSommeIndicee ,NatCal.NProduitIndice , NatCal.NPartieReelle
  , NatCal.NPartieImaginaire , NatCal.NModule , NatCal.NArgument
  , NatCal.NMesureLongueur , NatCal.NMesureAngleNonOriente ,NatCal.NMesureAngleOriente
  , NatCal.NMesureAbscisseSurDroite , NatCal.NMesureAbscisseRepere
  , NatCal.NMesureOrdonneeRepere   , NatCal.NMesureLongueurLigne
  , NatCal.NMesureAirePolygone , NatCal.NCalculComplexe , NatCal.NMesureAffixe
  , NatCal.NTteFoncR , NatCal.NTteFoncC
  , NatCal.NSuiteRecurrenteReelle , NatCal.NSuiteRecurrenteReelle2
  , NatCal.NSuiteRecurrenteReelle3 , NatCal.NSuiteRecurrenteComplexe
  , NatCal.NSuiteRecurrenteComplexe2, NatCal.NSuiteRecurrenteComplexe3
  , NatCal.NDerivee, NatCal.NMesureCoefDir , NatCal.NRepere
  , NatCal.NMesureProduitScalaire, NatCal.NMaximumFonction
  , NatCal.NMinimumFonction , NatCal.NAbscisseOrigineRep , NatCal.NOrdonneeOrigineRep
  , NatCal.NUnitexRep , NatCal.NUniteyRep, NatCal.NTestEquivalence, NatCal.NTestFact
  , NatCal.NDeriveePartielle , NatCal.NTestDependanceVariable
  , NatCal.NTestNatureOperateur);
*/

NatCal.NFoncRNvar = Nat.or(NatCal.NFoncPlusieursVar, NatCal.NDeriveePartielle)

NatCal.NFoncROuCompNvar = Nat.or(NatCal.NFoncPlusieursVar, NatCal.NFoncCPlusieursVar)

/*
NatCal.NTteMes = Nat.or(NatCal.NMesureLongueur , NatCal.NMesureAngleNonOriente
  , NatCal.NMesureAngleOriente, NatCal.NMesureAbscisseSurDroite , NatCal.NMesureAbscisseRepere
  , NatCal.NMesureOrdonneeRepere , NatCal.NMesureLongueurLigne, NatCal.NMesureAirePolygone
  , NatCal.NMesureAffixe , NatCal.NMesureCoefDir , NatCal.NMesureProduitScalaire);

NatCal.NTouteFonctionOuSuiteComplexe = Nat.or(NatCal.NTteFoncC
  , NatCal.NTteSuiteRecC);
  */

NatCal.NTtCalcNommeSaufConst = Nat.or(NatCal.NCalculReel, NatCal.NCalculComplexe
  , NatCal.NTteFoncRouC, NatCal.NDerivee, NatCal.NSuiteRecurrenteReelle
  , NatCal.NSuiteRecurrenteReelle2, NatCal.NSuiteRecurrenteReelle3, NatCal.NSuiteRecurrenteComplexe
  , NatCal.NSuiteRecurrenteComplexe2, NatCal.NSuiteRecurrenteComplexe3, NatCal.NVariable
  , NatCal.NSolutionEquation, NatCal.NIntegrale, NatCal.NTestExistence
  , NatCal.NSommeIndicee, NatCal.NProduitIndice, NatCal.NPartieReelle
  , NatCal.NPartieImaginaire, NatCal.NModule, NatCal.NArgument
  , NatCal.NMesureAbscisseRepere, NatCal.NMesureOrdonneeRepere
  , NatCal.NMesureAbscisseSurDroite, NatCal.NMesureAffixe, NatCal.NMesureAngleOriente
  , NatCal.NMesureLongueurLigne, NatCal.NMesureAirePolygone
  , NatCal.NMesureCoefDir, NatCal.NMesureProduitScalaire
  , NatCal.NMaximumFonction, NatCal.NMinimumFonction
  , NatCal.NAbscisseOrigineRep, NatCal.NOrdonneeOrigineRep
  , NatCal.NUnitexRep, NatCal.NUniteyRep, NatCal.NTestEquivalence, NatCal.NTestFact
  , NatCal.NTestDependanceVariable, NatCal.NTestNatureOperateur, NatCal.NTteMatrice)

NatCal.NTteValROuCOuFoncROuC = Nat.or(NatCal.NTteValROuC, NatCal.NTteFoncC, NatCal.NSuiteRecurrenteComplexe,
  NatCal.NSuiteRecurrenteComplexe2, NatCal.NSuiteRecurrenteComplexe3, NatCal.NTteFoncR,
  NatCal.NTteMatrice)

NatCal.NCalculOuFonctionParFormule = Nat.or(NatCal.NCalculReel, NatCal.NCalculComplexe, NatCal.NFonction, NatCal.NFonction2Var,
  NatCal.NFonction3Var, NatCal.NFonctionComplexe, NatCal.NFonctionComplexe2Var, NatCal.NFonctionComplexe3Var)

module.exports = NatCal
